
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveC11H12O4FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::
myTotalFlowRateAdvectiveDiffusiveC11H12O4::interpTable
(
    IStringStream
    (
        "("
        "(  275 3.6411e-24 )"
        "(  280 2.3490e-23 )"
        "(  285 1.4198e-22 )"
        "(  290 8.0680e-22 )"
        "(  295 4.3233e-21 )"
        "(  300 2.1910e-20 )"
        "(  305 1.0530e-19 )"
        "(  310 4.8116e-19 )"
        "(  315 2.0952e-18 )"
        "(  320 8.7131e-18 )"
        "(  325 3.4676e-17 )"
        "(  330 1.3232e-16 )"
        "(  335 4.8493e-16 )"
        "(  340 1.7097e-15 )"
        "(  345 5.8070e-15 )"
        "(  350 1.9027e-14 )"
        "(  355 6.0211e-14 )"
        "(  360 1.8421e-13 )"
        "(  365 5.4537e-13 )"
        "(  370 1.5636e-12 )"
        "(  375 4.3441e-12 )"
        "(  380 1.1701e-11 )"
        "(  385 3.0565e-11 )"
        "(  390 7.7456e-11 )"
        "(  395 1.9045e-10 )"
        "(  400 4.5443e-10 )"
        "(  405 1.0523e-09 )"
        "(  410 2.3654e-09 )"
        "(  415 5.1621e-09 )"
        "(  420 1.0941e-08 )"
        "(  425 2.2530e-08 )"
        "(  430 4.5109e-08 )"
        "(  435 8.7875e-08 )"
        "(  440 1.6672e-07 )"
        "(  445 3.0837e-07 )"
        "(  450 5.5672e-07 )"
        "(  455 9.8218e-07 )"
        "(  460 1.6954e-06 )"
        "(  465 2.8667e-06 )"
        "(  470 4.7539e-06 )"
        "(  475 7.7405e-06 )"
        "(  480 1.2388e-05 )"
        "(  485 1.9504e-05 )"
        "(  490 3.0241e-05 )"
        "(  495 4.6210e-05 )"
        "(  500 6.9644e-05 )"
        "(  505 1.0359e-04 )"
        "(  510 1.5217e-04 )"
        "(  515 2.2086e-04 )"
        "(  520 3.1690e-04 )"
        "(  525 4.4967e-04 )"
        "(  530 6.3127e-04 )"
        "(  535 8.7702e-04 )"
        "(  540 1.2062e-03 )"
        "(  545 1.6425e-03 )"
        "(  550 2.2149e-03 )"
        "(  555 2.9585e-03 )"
        "(  560 3.9145e-03 )"
        "(  565 5.1311e-03 )"
        "(  570 6.6634e-03 )"
        "(  575 8.5729e-03 )"
        "(  580 1.0927e-02 )"
        "(  585 1.3796e-02 )"
        "(  590 1.7254e-02 )"
        "(  595 2.1372e-02 )"
        "(  600 2.6214e-02 )"
        "(  605 3.1836e-02 )"
        "(  610 3.8278e-02 )"
        "(  615 4.5561e-02 )"
        "(  620 5.3681e-02 )"
        "(  625 6.2613e-02 )"
        "(  630 7.2305e-02 )"
        "(  635 8.2680e-02 )"
        "(  640 9.3641e-02 )"
        "(  645 1.0507e-01 )"
        "(  650 1.1682e-01 )"
        "(  655 1.2875e-01 )"
        "(  660 1.4067e-01 )"
        "(  665 1.5239e-01 )"
        "(  670 1.6371e-01 )"
        "(  675 1.7441e-01 )"
        "(  680 1.8429e-01 )"
        "(  685 1.9317e-01 )"
        "(  690 2.0088e-01 )"
        "(  695 2.0733e-01 )"
        "(  700 2.1243e-01 )"
        "(  705 2.1616e-01 )"
        "(  710 2.1853e-01 )"
        "(  715 2.1959e-01 )"
        "(  720 2.1941e-01 )"
        "(  725 2.1810e-01 )"
        "(  730 2.1576e-01 )"
        "(  735 2.1252e-01 )"
        "(  740 2.0850e-01 )"
        "(  745 2.0381e-01 )"
        "(  750 1.9855e-01 )"
        "(  755 1.9285e-01 )"
        "(  760 1.8679e-01 )"
        "(  765 1.8046e-01 )"
        "(  770 1.7397e-01 )"
        "(  775 1.6739e-01 )"
        "(  780 1.6081e-01 )"
        "(  785 1.5430e-01 )"
        "(  790 1.4791e-01 )"
        "(  795 1.4168e-01 )"
        "(  800 1.3564e-01 )"
        "(  805 1.2980e-01 )"
        "(  810 1.2416e-01 )"
        "(  815 1.1872e-01 )"
        "(  820 1.1348e-01 )"
        "(  825 1.0843e-01 )"
        "(  830 1.0357e-01 )"
        "(  835 9.8883e-02 )"
        "(  840 9.4370e-02 )"
        "(  845 9.0023e-02 )"
        "(  850 8.5839e-02 )"
        "(  855 8.1814e-02 )"
        "(  860 7.7945e-02 )"
        "(  865 7.4230e-02 )"
        "(  870 7.0666e-02 )"
        "(  875 6.7249e-02 )"
        "(  880 6.3977e-02 )"
        "(  885 6.0846e-02 )"
        "(  890 5.7853e-02 )"
        "(  895 5.4994e-02 )"
        "(  900 5.2266e-02 )"
        "(  905 4.9665e-02 )"
        "(  910 4.7186e-02 )"
        "(  915 4.4827e-02 )"
        "(  920 4.2582e-02 )"
        "(  925 4.0447e-02 )"
        "(  930 3.8418e-02 )"
        "(  935 3.6491e-02 )"
        "(  940 3.4661e-02 )"
        "(  945 3.2924e-02 )"
        "(  950 3.1276e-02 )"
        "(  955 2.9713e-02 )"
        "(  960 2.8230e-02 )"
        "(  965 2.6824e-02 )"
        "(  970 2.5491e-02 )"
        "(  975 2.4227e-02 )"
        "(  980 2.3028e-02 )"
        "(  985 2.1892e-02 )"
        "(  990 2.0814e-02 )"
        "(  995 1.9792e-02 )"
        "( 1000 1.8823e-02 )"
        "( 1005 1.7904e-02 )"
        "( 1010 1.7031e-02 )"
        "( 1015 1.6204e-02 )"
        "( 1020 1.5418e-02 )"
        "( 1025 1.4672e-02 )"
        "( 1030 1.3964e-02 )"
        "( 1035 1.3291e-02 )"
        "( 1040 1.2651e-02 )"
        "( 1045 1.2043e-02 )"
        "( 1050 1.1465e-02 )"
        "( 1055 1.0915e-02 )"
        "( 1060 1.0391e-02 )"
        "( 1065 9.8932e-03 )"
        "( 1070 9.4191e-03 )"
        "( 1075 8.9678e-03 )"
        "( 1080 8.5383e-03 )"
        "( 1085 8.1297e-03 )"
        "( 1090 7.7409e-03 )"
        "( 1095 7.3713e-03 )"
        "( 1100 7.0201e-03 )"
        "( 1105 6.6866e-03 )"
        "( 1110 6.3701e-03 )"
        "( 1115 6.0701e-03 )"
        "( 1120 5.7857e-03 )"
        "( 1125 5.5164e-03 )"
        "( 1130 5.2614e-03 )"
        "( 1135 5.0200e-03 )"
        "( 1140 4.7915e-03 )"
        "( 1145 4.5750e-03 )"
        "( 1150 4.3699e-03 )"
        "( 1155 4.1756e-03 )"
        "( 1160 3.9912e-03 )"
        "( 1165 3.8164e-03 )"
        "( 1170 3.6505e-03 )"
        "( 1175 3.4932e-03 )"
        "( 1180 3.3439e-03 )"
        "( 1185 3.2022e-03 )"
        "( 1190 3.0679e-03 )"
        "( 1195 2.9405e-03 )"
        "( 1200 2.8197e-03 )"
        "( 1205 2.7051e-03 )"
        "( 1210 2.5964e-03 )"
        "( 1215 2.4933e-03 )"
        "( 1220 2.3955e-03 )"
        "( 1225 2.3026e-03 )"
        "( 1230 2.2143e-03 )"
        "( 1235 2.1303e-03 )"
        "( 1240 2.0503e-03 )"
        "( 1245 1.9741e-03 )"
        "( 1250 1.9015e-03 )"
        "( 1255 1.8322e-03 )"
        "( 1260 1.7660e-03 )"
        "( 1265 1.7028e-03 )"
        "( 1270 1.6424e-03 )"
        "( 1275 1.5846e-03 )"
        "( 1280 1.5293e-03 )"
        "( 1285 1.4764e-03 )"
        "( 1290 1.4257e-03 )"
        "( 1295 1.3771e-03 )"
        "( 1300 1.3305e-03 )"
        "( 1305 1.2858e-03 )"
        "( 1310 1.2430e-03 )"
        "( 1315 1.2018e-03 )"
        "( 1320 1.1624e-03 )"
        "( 1325 1.1245e-03 )"
        "( 1330 1.0880e-03 )"
        "( 1335 1.0530e-03 )"
        "( 1340 1.0194e-03 )"
        "( 1345 9.8709e-04 )"
        "( 1350 9.5600e-04 )"
        "( 1355 9.2610e-04 )"
        "( 1360 8.9732e-04 )"
        "( 1365 8.6963e-04 )"
        "( 1370 8.4298e-04 )"
        "( 1375 8.1731e-04 )"
        "( 1380 7.9259e-04 )"
        "( 1385 7.6878e-04 )"
        "( 1390 7.4584e-04 )"
        "( 1395 7.2373e-04 )"
        "( 1400 7.0241e-04 )"
        "( 1405 6.8186e-04 )"
        "( 1410 6.6204e-04 )"
        "( 1415 6.4293e-04 )"
        "( 1420 6.2448e-04 )"
        "( 1425 6.0669e-04 )"
        "( 1430 5.8951e-04 )"
        "( 1435 5.7292e-04 )"
        "( 1440 5.5691e-04 )"
        "( 1445 5.4144e-04 )"
        "( 1450 5.2650e-04 )"
        "( 1455 5.1207e-04 )"
        "( 1460 4.9812e-04 )"
        "( 1465 4.8464e-04 )"
        "( 1470 4.7161e-04 )"
        "( 1475 4.5901e-04 )"
        "( 1480 4.4682e-04 )"
        "( 1485 4.3503e-04 )"
        "( 1490 4.2363e-04 )"
        "( 1495 4.1259e-04 )"
        "( 1500 4.0191e-04 )"
        "( 1505 3.9158e-04 )"
        "( 1510 3.8157e-04 )"
        "( 1515 3.7188e-04 )"
        "( 1520 3.6249e-04 )"
        "( 1525 3.5340e-04 )"
        "( 1530 3.4459e-04 )"
        "( 1535 3.3605e-04 )"
        "( 1540 3.2778e-04 )"
        "( 1545 3.1976e-04 )"
        "( 1550 3.1199e-04 )"
        "( 1555 3.0445e-04 )"
        "( 1560 2.9714e-04 )"
        "( 1565 2.9005e-04 )"
        "( 1570 2.8317e-04 )"
        "( 1575 2.7650e-04 )"
        "( 1580 2.7002e-04 )"
        "( 1585 2.6373e-04 )"
        "( 1590 2.5763e-04 )"
        "( 1595 2.5170e-04 )"
        "( 1600 2.4595e-04 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::
myTotalFlowRateAdvectiveDiffusiveC11H12O4
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::
myTotalFlowRateAdvectiveDiffusiveC11H12O4
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::
myTotalFlowRateAdvectiveDiffusiveC11H12O4
(
    const myTotalFlowRateAdvectiveDiffusiveC11H12O4& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::
myTotalFlowRateAdvectiveDiffusiveC11H12O4
(
    const myTotalFlowRateAdvectiveDiffusiveC11H12O4& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::
myTotalFlowRateAdvectiveDiffusiveC11H12O4
(
    const myTotalFlowRateAdvectiveDiffusiveC11H12O4& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC11H12O4::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveC11H12O4
    );

}

// ************************************************************************* //
