
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 1.1976e-10 )"
        "(  280 2.8470e-10 )"
        "(  285 6.5653e-10 )"
        "(  290 1.4710e-09 )"
        "(  295 3.2066e-09 )"
        "(  300 6.8106e-09 )"
        "(  305 1.4111e-08 )"
        "(  310 2.8555e-08 )"
        "(  315 5.6496e-08 )"
        "(  320 1.0939e-07 )"
        "(  325 2.0749e-07 )"
        "(  330 3.8584e-07 )"
        "(  335 7.0395e-07 )"
        "(  340 1.2610e-06 )"
        "(  345 2.2189e-06 )"
        "(  350 3.8375e-06 )"
        "(  355 6.5258e-06 )"
        "(  360 1.0915e-05 )"
        "(  365 1.7960e-05 )"
        "(  370 2.9076e-05 )"
        "(  375 4.6314e-05 )"
        "(  380 7.2577e-05 )"
        "(  385 1.1187e-04 )"
        "(  390 1.6958e-04 )"
        "(  395 2.5271e-04 )"
        "(  400 3.7011e-04 )"
        "(  405 5.3254e-04 )"
        "(  410 7.5262e-04 )"
        "(  415 1.0445e-03 )"
        "(  420 1.4236e-03 )"
        "(  425 1.9055e-03 )"
        "(  430 2.5057e-03 )"
        "(  435 3.2385e-03 )"
        "(  440 4.1166e-03 )"
        "(  445 5.1505e-03 )"
        "(  450 6.3482e-03 )"
        "(  455 7.7156e-03 )"
        "(  460 9.2562e-03 )"
        "(  465 1.0972e-02 )"
        "(  470 1.2862e-02 )"
        "(  475 1.4925e-02 )"
        "(  480 1.7160e-02 )"
        "(  485 1.9562e-02 )"
        "(  490 2.2129e-02 )"
        "(  495 2.4855e-02 )"
        "(  500 2.7736e-02 )"
        "(  505 3.0765e-02 )"
        "(  510 3.3934e-02 )"
        "(  515 3.7237e-02 )"
        "(  520 4.0662e-02 )"
        "(  525 4.4196e-02 )"
        "(  530 4.7824e-02 )"
        "(  535 5.1528e-02 )"
        "(  540 5.5286e-02 )"
        "(  545 5.9073e-02 )"
        "(  550 6.2858e-02 )"
        "(  555 6.6609e-02 )"
        "(  560 7.0286e-02 )"
        "(  565 7.3848e-02 )"
        "(  570 7.7248e-02 )"
        "(  575 8.0438e-02 )"
        "(  580 8.3366e-02 )"
        "(  585 8.5978e-02 )"
        "(  590 8.8222e-02 )"
        "(  595 9.0051e-02 )"
        "(  600 9.1421e-02 )"
        "(  605 9.2297e-02 )"
        "(  610 9.2659e-02 )"
        "(  615 9.2500e-02 )"
        "(  620 9.1830e-02 )"
        "(  625 9.0678e-02 )"
        "(  630 8.9089e-02 )"
        "(  635 8.7122e-02 )"
        "(  640 8.4846e-02 )"
        "(  645 8.2336e-02 )"
        "(  650 7.9666e-02 )"
        "(  655 7.6905e-02 )"
        "(  660 7.4115e-02 )"
        "(  665 7.1348e-02 )"
        "(  670 6.8649e-02 )"
        "(  675 6.6055e-02 )"
        "(  680 6.3594e-02 )"
        "(  685 6.1294e-02 )"
        "(  690 5.9175e-02 )"
        "(  695 5.7252e-02 )"
        "(  700 5.5535e-02 )"
        "(  705 5.4029e-02 )"
        "(  710 5.2729e-02 )"
        "(  715 5.1625e-02 )"
        "(  720 5.0703e-02 )"
        "(  725 4.9943e-02 )"
        "(  730 4.9322e-02 )"
        "(  735 4.8816e-02 )"
        "(  740 4.8402e-02 )"
        "(  745 4.8059e-02 )"
        "(  750 4.7768e-02 )"
        "(  755 4.7515e-02 )"
        "(  760 4.7289e-02 )"
        "(  765 4.7084e-02 )"
        "(  770 4.6899e-02 )"
        "(  775 4.6734e-02 )"
        "(  780 4.6593e-02 )"
        "(  785 4.6482e-02 )"
        "(  790 4.6405e-02 )"
        "(  795 4.6365e-02 )"
        "(  800 4.6363e-02 )"
        "(  805 4.6399e-02 )"
        "(  810 4.6470e-02 )"
        "(  815 4.6574e-02 )"
        "(  820 4.6706e-02 )"
        "(  825 4.6862e-02 )"
        "(  830 4.7037e-02 )"
        "(  835 4.7227e-02 )"
        "(  840 4.7429e-02 )"
        "(  845 4.7638e-02 )"
        "(  850 4.7851e-02 )"
        "(  855 4.8067e-02 )"
        "(  860 4.8284e-02 )"
        "(  865 4.8500e-02 )"
        "(  870 4.8714e-02 )"
        "(  875 4.8924e-02 )"
        "(  880 4.9131e-02 )"
        "(  885 4.9333e-02 )"
        "(  890 4.9530e-02 )"
        "(  895 4.9723e-02 )"
        "(  900 4.9910e-02 )"
        "(  905 5.0092e-02 )"
        "(  910 5.0269e-02 )"
        "(  915 5.0440e-02 )"
        "(  920 5.0607e-02 )"
        "(  925 5.0770e-02 )"
        "(  930 5.0928e-02 )"
        "(  935 5.1081e-02 )"
        "(  940 5.1231e-02 )"
        "(  945 5.1376e-02 )"
        "(  950 5.1517e-02 )"
        "(  955 5.1655e-02 )"
        "(  960 5.1788e-02 )"
        "(  965 5.1917e-02 )"
        "(  970 5.2043e-02 )"
        "(  975 5.2163e-02 )"
        "(  980 5.2280e-02 )"
        "(  985 5.2391e-02 )"
        "(  990 5.2497e-02 )"
        "(  995 5.2598e-02 )"
        "( 1000 5.2692e-02 )"
        "( 1005 5.2780e-02 )"
        "( 1010 5.2861e-02 )"
        "( 1015 5.2935e-02 )"
        "( 1020 5.3000e-02 )"
        "( 1025 5.3057e-02 )"
        "( 1030 5.3103e-02 )"
        "( 1035 5.3139e-02 )"
        "( 1040 5.3164e-02 )"
        "( 1045 5.3177e-02 )"
        "( 1050 5.3176e-02 )"
        "( 1055 5.3162e-02 )"
        "( 1060 5.3133e-02 )"
        "( 1065 5.3089e-02 )"
        "( 1070 5.3030e-02 )"
        "( 1075 5.2955e-02 )"
        "( 1080 5.2866e-02 )"
        "( 1085 5.2761e-02 )"
        "( 1090 5.2643e-02 )"
        "( 1095 5.2513e-02 )"
        "( 1100 5.2373e-02 )"
        "( 1105 5.2225e-02 )"
        "( 1110 5.2071e-02 )"
        "( 1115 5.1914e-02 )"
        "( 1120 5.1755e-02 )"
        "( 1125 5.1597e-02 )"
        "( 1130 5.1442e-02 )"
        "( 1135 5.1289e-02 )"
        "( 1140 5.1141e-02 )"
        "( 1145 5.0996e-02 )"
        "( 1150 5.0855e-02 )"
        "( 1155 5.0717e-02 )"
        "( 1160 5.0583e-02 )"
        "( 1165 5.0451e-02 )"
        "( 1170 5.0323e-02 )"
        "( 1175 5.0200e-02 )"
        "( 1180 5.0080e-02 )"
        "( 1185 4.9967e-02 )"
        "( 1190 4.9861e-02 )"
        "( 1195 4.9762e-02 )"
        "( 1200 4.9672e-02 )"
        "( 1205 4.9592e-02 )"
        "( 1210 4.9522e-02 )"
        "( 1215 4.9462e-02 )"
        "( 1220 4.9412e-02 )"
        "( 1225 4.9371e-02 )"
        "( 1230 4.9339e-02 )"
        "( 1235 4.9316e-02 )"
        "( 1240 4.9299e-02 )"
        "( 1245 4.9289e-02 )"
        "( 1250 4.9284e-02 )"
        "( 1255 4.9283e-02 )"
        "( 1260 4.9287e-02 )"
        "( 1265 4.9294e-02 )"
        "( 1270 4.9304e-02 )"
        "( 1275 4.9317e-02 )"
        "( 1280 4.9331e-02 )"
        "( 1285 4.9347e-02 )"
        "( 1290 4.9365e-02 )"
        "( 1295 4.9384e-02 )"
        "( 1300 4.9403e-02 )"
        "( 1305 4.9424e-02 )"
        "( 1310 4.9445e-02 )"
        "( 1315 4.9466e-02 )"
        "( 1320 4.9488e-02 )"
        "( 1325 4.9510e-02 )"
        "( 1330 4.9532e-02 )"
        "( 1335 4.9554e-02 )"
        "( 1340 4.9576e-02 )"
        "( 1345 4.9597e-02 )"
        "( 1350 4.9619e-02 )"
        "( 1355 4.9640e-02 )"
        "( 1360 4.9662e-02 )"
        "( 1365 4.9682e-02 )"
        "( 1370 4.9703e-02 )"
        "( 1375 4.9723e-02 )"
        "( 1380 4.9743e-02 )"
        "( 1385 4.9762e-02 )"
        "( 1390 4.9781e-02 )"
        "( 1395 4.9800e-02 )"
        "( 1400 4.9818e-02 )"
        "( 1405 4.9836e-02 )"
        "( 1410 4.9854e-02 )"
        "( 1415 4.9870e-02 )"
        "( 1420 4.9887e-02 )"
        "( 1425 4.9903e-02 )"
        "( 1430 4.9919e-02 )"
        "( 1435 4.9934e-02 )"
        "( 1440 4.9949e-02 )"
        "( 1445 4.9963e-02 )"
        "( 1450 4.9978e-02 )"
        "( 1455 4.9991e-02 )"
        "( 1460 5.0004e-02 )"
        "( 1465 5.0017e-02 )"
        "( 1470 5.0030e-02 )"
        "( 1475 5.0042e-02 )"
        "( 1480 5.0053e-02 )"
        "( 1485 5.0065e-02 )"
        "( 1490 5.0076e-02 )"
        "( 1495 5.0086e-02 )"
        "( 1500 5.0096e-02 )"
        "( 1505 5.0106e-02 )"
        "( 1510 5.0116e-02 )"
        "( 1515 5.0125e-02 )"
        "( 1520 5.0134e-02 )"
        "( 1525 5.0142e-02 )"
        "( 1530 5.0151e-02 )"
        "( 1535 5.0158e-02 )"
        "( 1540 5.0166e-02 )"
        "( 1545 5.0173e-02 )"
        "( 1550 5.0180e-02 )"
        "( 1555 5.0187e-02 )"
        "( 1560 5.0193e-02 )"
        "( 1565 5.0200e-02 )"
        "( 1570 5.0205e-02 )"
        "( 1575 5.0211e-02 )"
        "( 1580 5.0216e-02 )"
        "( 1585 5.0221e-02 )"
        "( 1590 5.0226e-02 )"
        "( 1595 5.0231e-02 )"
        "( 1600 5.0235e-02 )"
        ")"

    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveC2H2O2FvPatchScalarField
    );

}

// ************************************************************************* //
