
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveC2H4FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::
myTotalFlowRateAdvectiveDiffusiveC2H4::interpTable
(
    IStringStream
    (
        "("
        "(  275 1.1563e-10 )"
        "(  280 2.7488e-10 )"
        "(  285 6.3389e-10 )"
        "(  290 1.4202e-09 )"
        "(  295 3.0960e-09 )"
        "(  300 6.5758e-09 )"
        "(  305 1.3625e-08 )"
        "(  310 2.7571e-08 )"
        "(  315 5.4548e-08 )"
        "(  320 1.0562e-07 )"
        "(  325 2.0034e-07 )"
        "(  330 3.7254e-07 )"
        "(  335 6.7968e-07 )"
        "(  340 1.2175e-06 )"
        "(  345 2.1424e-06 )"
        "(  350 3.7052e-06 )"
        "(  355 6.3009e-06 )"
        "(  360 1.0539e-05 )"
        "(  365 1.7341e-05 )"
        "(  370 2.8074e-05 )"
        "(  375 4.4718e-05 )"
        "(  380 7.0078e-05 )"
        "(  385 1.0802e-04 )"
        "(  390 1.6375e-04 )"
        "(  395 2.4402e-04 )"
        "(  400 3.5739e-04 )"
        "(  405 5.1425e-04 )"
        "(  410 7.2679e-04 )"
        "(  415 1.0087e-03 )"
        "(  420 1.3748e-03 )"
        "(  425 1.8403e-03 )"
        "(  430 2.4201e-03 )"
        "(  435 3.1281e-03 )"
        "(  440 3.9765e-03 )"
        "(  445 4.9756e-03 )"
        "(  450 6.1333e-03 )"
        "(  455 7.4552e-03 )"
        "(  460 8.9450e-03 )"
        "(  465 1.0604e-02 )"
        "(  470 1.2433e-02 )"
        "(  475 1.4431e-02 )"
        "(  480 1.6596e-02 )"
        "(  485 1.8924e-02 )"
        "(  490 2.1413e-02 )"
        "(  495 2.4059e-02 )"
        "(  500 2.6858e-02 )"
        "(  505 2.9803e-02 )"
        "(  510 3.2889e-02 )"
        "(  515 3.6108e-02 )"
        "(  520 3.9450e-02 )"
        "(  525 4.2904e-02 )"
        "(  530 4.6456e-02 )"
        "(  535 5.0089e-02 )"
        "(  540 5.3782e-02 )"
        "(  545 5.7511e-02 )"
        "(  550 6.1247e-02 )"
        "(  555 6.4959e-02 )"
        "(  560 6.8609e-02 )"
        "(  565 7.2156e-02 )"
        "(  570 7.5556e-02 )"
        "(  575 7.8759e-02 )"
        "(  580 8.1714e-02 )"
        "(  585 8.4370e-02 )"
        "(  590 8.6673e-02 )"
        "(  595 8.8574e-02 )"
        "(  600 9.0029e-02 )"
        "(  605 9.1002e-02 )"
        "(  610 9.1469e-02 )"
        "(  615 9.1422e-02 )"
        "(  620 9.0868e-02 )"
        "(  625 8.9831e-02 )"
        "(  630 8.8355e-02 )"
        "(  635 8.6495e-02 )"
        "(  640 8.4318e-02 )"
        "(  645 8.1896e-02 )"
        "(  650 7.9302e-02 )"
        "(  655 7.6604e-02 )"
        "(  660 7.3862e-02 )"
        "(  665 7.1129e-02 )"
        "(  670 6.8449e-02 )"
        "(  675 6.5858e-02 )"
        "(  680 6.3388e-02 )"
        "(  685 6.1063e-02 )"
        "(  690 5.8906e-02 )"
        "(  695 5.6932e-02 )"
        "(  700 5.5151e-02 )"
        "(  705 5.3566e-02 )"
        "(  710 5.2174e-02 )"
        "(  715 5.0964e-02 )"
        "(  720 4.9922e-02 )"
        "(  725 4.9028e-02 )"
        "(  730 4.8258e-02 )"
        "(  735 4.7588e-02 )"
        "(  740 4.6997e-02 )"
        "(  745 4.6461e-02 )"
        "(  750 4.5965e-02 )"
        "(  755 4.5493e-02 )"
        "(  760 4.5037e-02 )"
        "(  765 4.4591e-02 )"
        "(  770 4.4154e-02 )"
        "(  775 4.3727e-02 )"
        "(  780 4.3315e-02 )"
        "(  785 4.2922e-02 )"
        "(  790 4.2554e-02 )"
        "(  795 4.2213e-02 )"
        "(  800 4.1900e-02 )"
        "(  805 4.1616e-02 )"
        "(  810 4.1357e-02 )"
        "(  815 4.1122e-02 )"
        "(  820 4.0906e-02 )"
        "(  825 4.0707e-02 )"
        "(  830 4.0519e-02 )"
        "(  835 4.0340e-02 )"
        "(  840 4.0167e-02 )"
        "(  845 3.9996e-02 )"
        "(  850 3.9827e-02 )"
        "(  855 3.9657e-02 )"
        "(  860 3.9486e-02 )"
        "(  865 3.9312e-02 )"
        "(  870 3.9136e-02 )"
        "(  875 3.8956e-02 )"
        "(  880 3.8774e-02 )"
        "(  885 3.8588e-02 )"
        "(  890 3.8399e-02 )"
        "(  895 3.8208e-02 )"
        "(  900 3.8015e-02 )"
        "(  905 3.7821e-02 )"
        "(  910 3.7625e-02 )"
        "(  915 3.7429e-02 )"
        "(  920 3.7234e-02 )"
        "(  925 3.7040e-02 )"
        "(  930 3.6849e-02 )"
        "(  935 3.6660e-02 )"
        "(  940 3.6475e-02 )"
        "(  945 3.6295e-02 )"
        "(  950 3.6121e-02 )"
        "(  955 3.5955e-02 )"
        "(  960 3.5797e-02 )"
        "(  965 3.5648e-02 )"
        "(  970 3.5512e-02 )"
        "(  975 3.5388e-02 )"
        "(  980 3.5280e-02 )"
        "(  985 3.5189e-02 )"
        "(  990 3.5119e-02 )"
        "(  995 3.5071e-02 )"
        "( 1000 3.5050e-02 )"
        "( 1005 3.5058e-02 )"
        "( 1010 3.5100e-02 )"
        "( 1015 3.5179e-02 )"
        "( 1020 3.5301e-02 )"
        "( 1025 3.5470e-02 )"
        "( 1030 3.5691e-02 )"
        "( 1035 3.5970e-02 )"
        "( 1040 3.6312e-02 )"
        "( 1045 3.6721e-02 )"
        "( 1050 3.7202e-02 )"
        "( 1055 3.7758e-02 )"
        "( 1060 3.8393e-02 )"
        "( 1065 3.9106e-02 )"
        "( 1070 3.9896e-02 )"
        "( 1075 4.0761e-02 )"
        "( 1080 4.1693e-02 )"
        "( 1085 4.2681e-02 )"
        "( 1090 4.3714e-02 )"
        "( 1095 4.4774e-02 )"
        "( 1100 4.5842e-02 )"
        "( 1105 4.6897e-02 )"
        "( 1110 4.7916e-02 )"
        "( 1115 4.8877e-02 )"
        "( 1120 4.9759e-02 )"
        "( 1125 5.0546e-02 )"
        "( 1130 5.1226e-02 )"
        "( 1135 5.1791e-02 )"
        "( 1140 5.2239e-02 )"
        "( 1145 5.2575e-02 )"
        "( 1150 5.2806e-02 )"
        "( 1155 5.2942e-02 )"
        "( 1160 5.2995e-02 )"
        "( 1165 5.2977e-02 )"
        "( 1170 5.2900e-02 )"
        "( 1175 5.2774e-02 )"
        "( 1180 5.2610e-02 )"
        "( 1185 5.2414e-02 )"
        "( 1190 5.2196e-02 )"
        "( 1195 5.1962e-02 )"
        "( 1200 5.1716e-02 )"
        "( 1205 5.1464e-02 )"
        "( 1210 5.1209e-02 )"
        "( 1215 5.0954e-02 )"
        "( 1220 5.0700e-02 )"
        "( 1225 5.0450e-02 )"
        "( 1230 5.0204e-02 )"
        "( 1235 4.9962e-02 )"
        "( 1240 4.9725e-02 )"
        "( 1245 4.9493e-02 )"
        "( 1250 4.9266e-02 )"
        "( 1255 4.9043e-02 )"
        "( 1260 4.8824e-02 )"
        "( 1265 4.8610e-02 )"
        "( 1270 4.8401e-02 )"
        "( 1275 4.8195e-02 )"
        "( 1280 4.7993e-02 )"
        "( 1285 4.7795e-02 )"
        "( 1290 4.7601e-02 )"
        "( 1295 4.7411e-02 )"
        "( 1300 4.7224e-02 )"
        "( 1305 4.7041e-02 )"
        "( 1310 4.6862e-02 )"
        "( 1315 4.6685e-02 )"
        "( 1320 4.6512e-02 )"
        "( 1325 4.6343e-02 )"
        "( 1330 4.6176e-02 )"
        "( 1335 4.6012e-02 )"
        "( 1340 4.5852e-02 )"
        "( 1345 4.5695e-02 )"
        "( 1350 4.5540e-02 )"
        "( 1355 4.5388e-02 )"
        "( 1360 4.5239e-02 )"
        "( 1365 4.5093e-02 )"
        "( 1370 4.4950e-02 )"
        "( 1375 4.4809e-02 )"
        "( 1380 4.4671e-02 )"
        "( 1385 4.4535e-02 )"
        "( 1390 4.4402e-02 )"
        "( 1395 4.4271e-02 )"
        "( 1400 4.4143e-02 )"
        "( 1405 4.4017e-02 )"
        "( 1410 4.3893e-02 )"
        "( 1415 4.3772e-02 )"
        "( 1420 4.3653e-02 )"
        "( 1425 4.3536e-02 )"
        "( 1430 4.3421e-02 )"
        "( 1435 4.3308e-02 )"
        "( 1440 4.3197e-02 )"
        "( 1445 4.3089e-02 )"
        "( 1450 4.2982e-02 )"
        "( 1455 4.2877e-02 )"
        "( 1460 4.2774e-02 )"
        "( 1465 4.2674e-02 )"
        "( 1470 4.2574e-02 )"
        "( 1475 4.2477e-02 )"
        "( 1480 4.2382e-02 )"
        "( 1485 4.2288e-02 )"
        "( 1490 4.2196e-02 )"
        "( 1495 4.2106e-02 )"
        "( 1500 4.2017e-02 )"
        "( 1505 4.1930e-02 )"
        "( 1510 4.1844e-02 )"
        "( 1515 4.1760e-02 )"
        "( 1520 4.1678e-02 )"
        "( 1525 4.1597e-02 )"
        "( 1530 4.1517e-02 )"
        "( 1535 4.1439e-02 )"
        "( 1540 4.1363e-02 )"
        "( 1545 4.1287e-02 )"
        "( 1550 4.1214e-02 )"
        "( 1555 4.1141e-02 )"
        "( 1560 4.1070e-02 )"
        "( 1565 4.1000e-02 )"
        "( 1570 4.0931e-02 )"
        "( 1575 4.0864e-02 )"
        "( 1580 4.0798e-02 )"
        "( 1585 4.0733e-02 )"
        "( 1590 4.0669e-02 )"
        "( 1595 4.0606e-02 )"
        "( 1600 4.0545e-02 )"
        ")"


    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::
myTotalFlowRateAdvectiveDiffusiveC2H4
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::
myTotalFlowRateAdvectiveDiffusiveC2H4
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::
myTotalFlowRateAdvectiveDiffusiveC2H4
(
    const myTotalFlowRateAdvectiveDiffusiveC2H4& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::
myTotalFlowRateAdvectiveDiffusiveC2H4
(
    const myTotalFlowRateAdvectiveDiffusiveC2H4& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::
myTotalFlowRateAdvectiveDiffusiveC2H4
(
    const myTotalFlowRateAdvectiveDiffusiveC2H4& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC2H4::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveC2H4
    );

}

// ************************************************************************* //
