
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveC2H4O2FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::
myTotalFlowRateAdvectiveDiffusiveC2H4O2::interpTable
(
    IStringStream
    (
        "("
        "(  275 8.6449e-23 )"
        "(  280 5.0690e-22 )"
        "(  285 2.7964e-21 )"
        "(  290 1.4558e-20 )"
        "(  295 7.1733e-20 )"
        "(  300 3.3540e-19 )"
        "(  305 1.4919e-18 )"
        "(  310 6.3277e-18 )"
        "(  315 2.5646e-17 )"
        "(  320 9.9520e-17 )"
        "(  325 3.7046e-16 )"
        "(  330 1.3251e-15 )"
        "(  335 4.5617e-15 )"
        "(  340 1.5135e-14 )"
        "(  345 4.8461e-14 )"
        "(  350 1.4992e-13 )"
        "(  355 4.4855e-13 )"
        "(  360 1.2991e-12 )"
        "(  365 3.6448e-12 )"
        "(  370 9.9121e-12 )"
        "(  375 2.6140e-11 )"
        "(  380 6.6870e-11 )"
        "(  385 1.6597e-10 )"
        "(  390 3.9969e-10 )"
        "(  395 9.3392e-10 )"
        "(  400 2.1172e-09 )"
        "(  405 4.6561e-09 )"
        "(  410 9.9331e-09 )"
        "(  415 2.0556e-08 )"
        "(  420 4.1269e-08 )"
        "(  425 8.0401e-08 )"
        "(  430 1.5207e-07 )"
        "(  435 2.7939e-07 )"
        "(  440 4.9902e-07 )"
        "(  445 8.6730e-07 )"
        "(  450 1.4683e-06 )"
        "(  455 2.4241e-06 )"
        "(  460 3.9078e-06 )"
        "(  465 6.1591e-06 )"
        "(  470 9.5034e-06 )"
        "(  475 1.4374e-05 )"
        "(  480 2.1342e-05 )"
        "(  485 3.1146e-05 )"
        "(  490 4.4733e-05 )"
        "(  495 6.3312e-05 )"
        "(  500 8.8404e-05 )"
        "(  505 1.2192e-04 )"
        "(  510 1.6625e-04 )"
        "(  515 2.2434e-04 )"
        "(  520 2.9982e-04 )"
        "(  525 3.9713e-04 )"
        "(  530 5.2164e-04 )"
        "(  535 6.7977e-04 )"
        "(  540 8.7917e-04 )"
        "(  545 1.1288e-03 )"
        "(  550 1.4390e-03 )"
        "(  555 1.8216e-03 )"
        "(  560 2.2897e-03 )"
        "(  565 2.8578e-03 )"
        "(  570 3.5410e-03 )"
        "(  575 4.3549e-03 )"
        "(  580 5.3144e-03 )"
        "(  585 6.4325e-03 )"
        "(  590 7.7192e-03 )"
        "(  595 9.1793e-03 )"
        "(  600 1.0810e-02 )"
        "(  605 1.2601e-02 )"
        "(  610 1.4528e-02 )"
        "(  615 1.6556e-02 )"
        "(  620 1.8640e-02 )"
        "(  625 2.0720e-02 )"
        "(  630 2.2729e-02 )"
        "(  635 2.4598e-02 )"
        "(  640 2.6258e-02 )"
        "(  645 2.7652e-02 )"
        "(  650 2.8736e-02 )"
        "(  655 2.9488e-02 )"
        "(  660 2.9912e-02 )"
        "(  665 3.0033e-02 )"
        "(  670 2.9897e-02 )"
        "(  675 2.9562e-02 )"
        "(  680 2.9093e-02 )"
        "(  685 2.8550e-02 )"
        "(  690 2.7987e-02 )"
        "(  695 2.7445e-02 )"
        "(  700 2.6957e-02 )"
        "(  705 2.6544e-02 )"
        "(  710 2.6219e-02 )"
        "(  715 2.5989e-02 )"
        "(  720 2.5855e-02 )"
        "(  725 2.5813e-02 )"
        "(  730 2.5857e-02 )"
        "(  735 2.5978e-02 )"
        "(  740 2.6168e-02 )"
        "(  745 2.6416e-02 )"
        "(  750 2.6714e-02 )"
        "(  755 2.7055e-02 )"
        "(  760 2.7434e-02 )"
        "(  765 2.7847e-02 )"
        "(  770 2.8293e-02 )"
        "(  775 2.8772e-02 )"
        "(  780 2.9287e-02 )"
        "(  785 2.9840e-02 )"
        "(  790 3.0436e-02 )"
        "(  795 3.1076e-02 )"
        "(  800 3.1763e-02 )"
        "(  805 3.2497e-02 )"
        "(  810 3.3277e-02 )"
        "(  815 3.4102e-02 )"
        "(  820 3.4971e-02 )"
        "(  825 3.5880e-02 )"
        "(  830 3.6827e-02 )"
        "(  835 3.7809e-02 )"
        "(  840 3.8822e-02 )"
        "(  845 3.9865e-02 )"
        "(  850 4.0934e-02 )"
        "(  855 4.2026e-02 )"
        "(  860 4.3141e-02 )"
        "(  865 4.4275e-02 )"
        "(  870 4.5426e-02 )"
        "(  875 4.6593e-02 )"
        "(  880 4.7772e-02 )"
        "(  885 4.8963e-02 )"
        "(  890 5.0162e-02 )"
        "(  895 5.1369e-02 )"
        "(  900 5.2580e-02 )"
        "(  905 5.3794e-02 )"
        "(  910 5.5009e-02 )"
        "(  915 5.6222e-02 )"
        "(  920 5.7433e-02 )"
        "(  925 5.8639e-02 )"
        "(  930 5.9839e-02 )"
        "(  935 6.1031e-02 )"
        "(  940 6.2214e-02 )"
        "(  945 6.3387e-02 )"
        "(  950 6.4550e-02 )"
        "(  955 6.5700e-02 )"
        "(  960 6.6837e-02 )"
        "(  965 6.7961e-02 )"
        "(  970 6.9071e-02 )"
        "(  975 7.0167e-02 )"
        "(  980 7.1246e-02 )"
        "(  985 7.2310e-02 )"
        "(  990 7.3356e-02 )"
        "(  995 7.4386e-02 )"
        "( 1000 7.5396e-02 )"
        "( 1005 7.6387e-02 )"
        "( 1010 7.7358e-02 )"
        "( 1015 7.8307e-02 )"
        "( 1020 7.9233e-02 )"
        "( 1025 8.0135e-02 )"
        "( 1030 8.1011e-02 )"
        "( 1035 8.1860e-02 )"
        "( 1040 8.2679e-02 )"
        "( 1045 8.3468e-02 )"
        "( 1050 8.4225e-02 )"
        "( 1055 8.4947e-02 )"
        "( 1060 8.5633e-02 )"
        "( 1065 8.6283e-02 )"
        "( 1070 8.6894e-02 )"
        "( 1075 8.7467e-02 )"
        "( 1080 8.8001e-02 )"
        "( 1085 8.8498e-02 )"
        "( 1090 8.8958e-02 )"
        "( 1095 8.9384e-02 )"
        "( 1100 8.9778e-02 )"
        "( 1105 9.0145e-02 )"
        "( 1110 9.0488e-02 )"
        "( 1115 9.0811e-02 )"
        "( 1120 9.1119e-02 )"
        "( 1125 9.1414e-02 )"
        "( 1130 9.1701e-02 )"
        "( 1135 9.1981e-02 )"
        "( 1140 9.2254e-02 )"
        "( 1145 9.2523e-02 )"
        "( 1150 9.2787e-02 )"
        "( 1155 9.3045e-02 )"
        "( 1160 9.3298e-02 )"
        "( 1165 9.3546e-02 )"
        "( 1170 9.3789e-02 )"
        "( 1175 9.4030e-02 )"
        "( 1180 9.4269e-02 )"
        "( 1185 9.4509e-02 )"
        "( 1190 9.4753e-02 )"
        "( 1195 9.5002e-02 )"
        "( 1200 9.5259e-02 )"
        "( 1205 9.5526e-02 )"
        "( 1210 9.5804e-02 )"
        "( 1215 9.6094e-02 )"
        "( 1220 9.6395e-02 )"
        "( 1225 9.6708e-02 )"
        "( 1230 9.7030e-02 )"
        "( 1235 9.7362e-02 )"
        "( 1240 9.7701e-02 )"
        "( 1245 9.8046e-02 )"
        "( 1250 9.8396e-02 )"
        "( 1255 9.8750e-02 )"
        "( 1260 9.9105e-02 )"
        "( 1265 9.9462e-02 )"
        "( 1270 9.9819e-02 )"
        "( 1275 1.0018e-01 )"
        "( 1280 1.0053e-01 )"
        "( 1285 1.0089e-01 )"
        "( 1290 1.0124e-01 )"
        "( 1295 1.0159e-01 )"
        "( 1300 1.0193e-01 )"
        "( 1305 1.0228e-01 )"
        "( 1310 1.0262e-01 )"
        "( 1315 1.0295e-01 )"
        "( 1320 1.0329e-01 )"
        "( 1325 1.0361e-01 )"
        "( 1330 1.0394e-01 )"
        "( 1335 1.0426e-01 )"
        "( 1340 1.0458e-01 )"
        "( 1345 1.0489e-01 )"
        "( 1350 1.0520e-01 )"
        "( 1355 1.0550e-01 )"
        "( 1360 1.0580e-01 )"
        "( 1365 1.0609e-01 )"
        "( 1370 1.0639e-01 )"
        "( 1375 1.0667e-01 )"
        "( 1380 1.0695e-01 )"
        "( 1385 1.0723e-01 )"
        "( 1390 1.0751e-01 )"
        "( 1395 1.0777e-01 )"
        "( 1400 1.0804e-01 )"
        "( 1405 1.0830e-01 )"
        "( 1410 1.0856e-01 )"
        "( 1415 1.0881e-01 )"
        "( 1420 1.0906e-01 )"
        "( 1425 1.0931e-01 )"
        "( 1430 1.0955e-01 )"
        "( 1435 1.0978e-01 )"
        "( 1440 1.1002e-01 )"
        "( 1445 1.1025e-01 )"
        "( 1450 1.1047e-01 )"
        "( 1455 1.1070e-01 )"
        "( 1460 1.1092e-01 )"
        "( 1465 1.1113e-01 )"
        "( 1470 1.1134e-01 )"
        "( 1475 1.1155e-01 )"
        "( 1480 1.1176e-01 )"
        "( 1485 1.1196e-01 )"
        "( 1490 1.1216e-01 )"
        "( 1495 1.1236e-01 )"
        "( 1500 1.1255e-01 )"
        "( 1505 1.1274e-01 )"
        "( 1510 1.1293e-01 )"
        "( 1515 1.1311e-01 )"
        "( 1520 1.1329e-01 )"
        "( 1525 1.1347e-01 )"
        "( 1530 1.1364e-01 )"
        "( 1535 1.1382e-01 )"
        "( 1540 1.1399e-01 )"
        "( 1545 1.1415e-01 )"
        "( 1550 1.1432e-01 )"
        "( 1555 1.1448e-01 )"
        "( 1560 1.1464e-01 )"
        "( 1565 1.1480e-01 )"
        "( 1570 1.1495e-01 )"
        "( 1575 1.1510e-01 )"
        "( 1580 1.1525e-01 )"
        "( 1585 1.1540e-01 )"
        "( 1590 1.1555e-01 )"
        "( 1595 1.1569e-01 )"
        "( 1600 1.1583e-01 )"
        ")"

    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::
myTotalFlowRateAdvectiveDiffusiveC2H4O2
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::
myTotalFlowRateAdvectiveDiffusiveC2H4O2
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::
myTotalFlowRateAdvectiveDiffusiveC2H4O2
(
    const myTotalFlowRateAdvectiveDiffusiveC2H4O2& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::
myTotalFlowRateAdvectiveDiffusiveC2H4O2
(
    const myTotalFlowRateAdvectiveDiffusiveC2H4O2& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::
myTotalFlowRateAdvectiveDiffusiveC2H4O2
(
    const myTotalFlowRateAdvectiveDiffusiveC2H4O2& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC2H4O2::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveC2H4O2
    );

}

// ************************************************************************* //
