
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveC3H6OFvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::
myTotalFlowRateAdvectiveDiffusiveC3H6O::interpTable
(
    IStringStream
    (
        "("
        "(  275 2.3952e-10 )"
        "(  280 5.6940e-10 )"
        "(  285 1.3131e-09 )"
        "(  290 2.9419e-09 )"
        "(  295 6.4132e-09 )"
        "(  300 1.3621e-08 )"
        "(  305 2.8222e-08 )"
        "(  310 5.7110e-08 )"
        "(  315 1.1299e-07 )"
        "(  320 2.1878e-07 )"
        "(  325 4.1498e-07 )"
        "(  330 7.7168e-07 )"
        "(  335 1.4079e-06 )"
        "(  340 2.5219e-06 )"
        "(  345 4.4377e-06 )"
        "(  350 7.6750e-06 )"
        "(  355 1.3052e-05 )"
        "(  360 2.1830e-05 )"
        "(  365 3.5920e-05 )"
        "(  370 5.8152e-05 )"
        "(  375 9.2627e-05 )"
        "(  380 1.4515e-04 )"
        "(  385 2.2375e-04 )"
        "(  390 3.3916e-04 )"
        "(  395 5.0543e-04 )"
        "(  400 7.4022e-04 )"
        "(  405 1.0651e-03 )"
        "(  410 1.5053e-03 )"
        "(  415 2.0891e-03 )"
        "(  420 2.8473e-03 )"
        "(  425 3.8112e-03 )"
        "(  430 5.0116e-03 )"
        "(  435 6.4774e-03 )"
        "(  440 8.2338e-03 )"
        "(  445 1.0302e-02 )"
        "(  450 1.2698e-02 )"
        "(  455 1.5433e-02 )"
        "(  460 1.8516e-02 )"
        "(  465 2.1948e-02 )"
        "(  470 2.5731e-02 )"
        "(  475 2.9862e-02 )"
        "(  480 3.4336e-02 )"
        "(  485 3.9148e-02 )"
        "(  490 4.4291e-02 )"
        "(  495 4.9755e-02 )"
        "(  500 5.5533e-02 )"
        "(  505 6.1611e-02 )"
        "(  510 6.7979e-02 )"
        "(  515 7.4618e-02 )"
        "(  520 8.1512e-02 )"
        "(  525 8.8635e-02 )"
        "(  530 9.5961e-02 )"
        "(  535 1.0346e-01 )"
        "(  540 1.1108e-01 )"
        "(  545 1.1878e-01 )"
        "(  550 1.2651e-01 )"
        "(  555 1.3420e-01 )"
        "(  560 1.4179e-01 )"
        "(  565 1.4919e-01 )"
        "(  570 1.5632e-01 )"
        "(  575 1.6309e-01 )"
        "(  580 1.6940e-01 )"
        "(  585 1.7514e-01 )"
        "(  590 1.8024e-01 )"
        "(  595 1.8457e-01 )"
        "(  600 1.8807e-01 )"
        "(  605 1.9065e-01 )"
        "(  610 1.9227e-01 )"
        "(  615 1.9290e-01 )"
        "(  620 1.9254e-01 )"
        "(  625 1.9121e-01 )"
        "(  630 1.8899e-01 )"
        "(  635 1.8596e-01 )"
        "(  640 1.8223e-01 )"
        "(  645 1.7793e-01 )"
        "(  650 1.7318e-01 )"
        "(  655 1.6812e-01 )"
        "(  660 1.6287e-01 )"
        "(  665 1.5756e-01 )"
        "(  670 1.5230e-01 )"
        "(  675 1.4718e-01 )"
        "(  680 1.4230e-01 )"
        "(  685 1.3773e-01 )"
        "(  690 1.3353e-01 )"
        "(  695 1.2975e-01 )"
        "(  700 1.2642e-01 )"
        "(  705 1.2355e-01 )"
        "(  710 1.2111e-01 )"
        "(  715 1.1911e-01 )"
        "(  720 1.1748e-01 )"
        "(  725 1.1620e-01 )"
        "(  730 1.1520e-01 )"
        "(  735 1.1443e-01 )"
        "(  740 1.1384e-01 )"
        "(  745 1.1337e-01 )"
        "(  750 1.1299e-01 )"
        "(  755 1.1266e-01 )"
        "(  760 1.1236e-01 )"
        "(  765 1.1207e-01 )"
        "(  770 1.1180e-01 )"
        "(  775 1.1154e-01 )"
        "(  780 1.1130e-01 )"
        "(  785 1.1111e-01 )"
        "(  790 1.1096e-01 )"
        "(  795 1.1087e-01 )"
        "(  800 1.1084e-01 )"
        "(  805 1.1088e-01 )"
        "(  810 1.1097e-01 )"
        "(  815 1.1111e-01 )"
        "(  820 1.1129e-01 )"
        "(  825 1.1150e-01 )"
        "(  830 1.1173e-01 )"
        "(  835 1.1197e-01 )"
        "(  840 1.1222e-01 )"
        "(  845 1.1246e-01 )"
        "(  850 1.1269e-01 )"
        "(  855 1.1290e-01 )"
        "(  860 1.1310e-01 )"
        "(  865 1.1327e-01 )"
        "(  870 1.1342e-01 )"
        "(  875 1.1355e-01 )"
        "(  880 1.1365e-01 )"
        "(  885 1.1373e-01 )"
        "(  890 1.1378e-01 )"
        "(  895 1.1381e-01 )"
        "(  900 1.1382e-01 )"
        "(  905 1.1380e-01 )"
        "(  910 1.1377e-01 )"
        "(  915 1.1371e-01 )"
        "(  920 1.1364e-01 )"
        "(  925 1.1354e-01 )"
        "(  930 1.1344e-01 )"
        "(  935 1.1332e-01 )"
        "(  940 1.1318e-01 )"
        "(  945 1.1303e-01 )"
        "(  950 1.1288e-01 )"
        "(  955 1.1271e-01 )"
        "(  960 1.1253e-01 )"
        "(  965 1.1234e-01 )"
        "(  970 1.1214e-01 )"
        "(  975 1.1194e-01 )"
        "(  980 1.1172e-01 )"
        "(  985 1.1149e-01 )"
        "(  990 1.1126e-01 )"
        "(  995 1.1102e-01 )"
        "( 1000 1.1076e-01 )"
        "( 1005 1.1050e-01 )"
        "( 1010 1.1022e-01 )"
        "( 1015 1.0993e-01 )"
        "( 1020 1.0963e-01 )"
        "( 1025 1.0931e-01 )"
        "( 1030 1.0898e-01 )"
        "( 1035 1.0863e-01 )"
        "( 1040 1.0827e-01 )"
        "( 1045 1.0788e-01 )"
        "( 1050 1.0747e-01 )"
        "( 1055 1.0704e-01 )"
        "( 1060 1.0659e-01 )"
        "( 1065 1.0612e-01 )"
        "( 1070 1.0562e-01 )"
        "( 1075 1.0509e-01 )"
        "( 1080 1.0454e-01 )"
        "( 1085 1.0397e-01 )"
        "( 1090 1.0339e-01 )"
        "( 1095 1.0278e-01 )"
        "( 1100 1.0216e-01 )"
        "( 1105 1.0154e-01 )"
        "( 1110 1.0091e-01 )"
        "( 1115 1.0028e-01 )"
        "( 1120 9.9657e-02 )"
        "( 1125 9.9042e-02 )"
        "( 1130 9.8439e-02 )"
        "( 1135 9.7848e-02 )"
        "( 1140 9.7272e-02 )"
        "( 1145 9.6710e-02 )"
        "( 1150 9.6161e-02 )"
        "( 1155 9.5626e-02 )"
        "( 1160 9.5102e-02 )"
        "( 1165 9.4591e-02 )"
        "( 1170 9.4092e-02 )"
        "( 1175 9.3606e-02 )"
        "( 1180 9.3135e-02 )"
        "( 1185 9.2680e-02 )"
        "( 1190 9.2244e-02 )"
        "( 1195 9.1827e-02 )"
        "( 1200 9.1431e-02 )"
        "( 1205 9.1058e-02 )"
        "( 1210 9.0708e-02 )"
        "( 1215 9.0381e-02 )"
        "( 1220 9.0077e-02 )"
        "( 1225 8.9794e-02 )"
        "( 1230 8.9531e-02 )"
        "( 1235 8.9286e-02 )"
        "( 1240 8.9058e-02 )"
        "( 1245 8.8845e-02 )"
        "( 1250 8.8645e-02 )"
        "( 1255 8.8457e-02 )"
        "( 1260 8.8280e-02 )"
        "( 1265 8.8111e-02 )"
        "( 1270 8.7951e-02 )"
        "( 1275 8.7799e-02 )"
        "( 1280 8.7653e-02 )"
        "( 1285 8.7513e-02 )"
        "( 1290 8.7378e-02 )"
        "( 1295 8.7248e-02 )"
        "( 1300 8.7123e-02 )"
        "( 1305 8.7001e-02 )"
        "( 1310 8.6883e-02 )"
        "( 1315 8.6768e-02 )"
        "( 1320 8.6657e-02 )"
        "( 1325 8.6548e-02 )"
        "( 1330 8.6442e-02 )"
        "( 1335 8.6338e-02 )"
        "( 1340 8.6236e-02 )"
        "( 1345 8.6136e-02 )"
        "( 1350 8.6038e-02 )"
        "( 1355 8.5942e-02 )"
        "( 1360 8.5848e-02 )"
        "( 1365 8.5755e-02 )"
        "( 1370 8.5664e-02 )"
        "( 1375 8.5574e-02 )"
        "( 1380 8.5485e-02 )"
        "( 1385 8.5398e-02 )"
        "( 1390 8.5312e-02 )"
        "( 1395 8.5227e-02 )"
        "( 1400 8.5143e-02 )"
        "( 1405 8.5061e-02 )"
        "( 1410 8.4979e-02 )"
        "( 1415 8.4899e-02 )"
        "( 1420 8.4819e-02 )"
        "( 1425 8.4741e-02 )"
        "( 1430 8.4663e-02 )"
        "( 1435 8.4586e-02 )"
        "( 1440 8.4510e-02 )"
        "( 1445 8.4435e-02 )"
        "( 1450 8.4361e-02 )"
        "( 1455 8.4288e-02 )"
        "( 1460 8.4215e-02 )"
        "( 1465 8.4143e-02 )"
        "( 1470 8.4072e-02 )"
        "( 1475 8.4002e-02 )"
        "( 1480 8.3932e-02 )"
        "( 1485 8.3863e-02 )"
        "( 1490 8.3795e-02 )"
        "( 1495 8.3728e-02 )"
        "( 1500 8.3661e-02 )"
        "( 1505 8.3595e-02 )"
        "( 1510 8.3529e-02 )"
        "( 1515 8.3464e-02 )"
        "( 1520 8.3400e-02 )"
        "( 1525 8.3336e-02 )"
        "( 1530 8.3273e-02 )"
        "( 1535 8.3211e-02 )"
        "( 1540 8.3149e-02 )"
        "( 1545 8.3088e-02 )"
        "( 1550 8.3027e-02 )"
        "( 1555 8.2967e-02 )"
        "( 1560 8.2908e-02 )"
        "( 1565 8.2849e-02 )"
        "( 1570 8.2790e-02 )"
        "( 1575 8.2732e-02 )"
        "( 1580 8.2675e-02 )"
        "( 1585 8.2618e-02 )"
        "( 1590 8.2562e-02 )"
        "( 1595 8.2506e-02 )"
        "( 1600 8.2450e-02 )"
        ")"


    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::
myTotalFlowRateAdvectiveDiffusiveC3H6O
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::
myTotalFlowRateAdvectiveDiffusiveC3H6O
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::
myTotalFlowRateAdvectiveDiffusiveC3H6O
(
    const myTotalFlowRateAdvectiveDiffusiveC3H6O& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::
myTotalFlowRateAdvectiveDiffusiveC3H6O
(
    const myTotalFlowRateAdvectiveDiffusiveC3H6O& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::
myTotalFlowRateAdvectiveDiffusiveC3H6O
(
    const myTotalFlowRateAdvectiveDiffusiveC3H6O& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC3H6O::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveC3H6O
    );

}

// ************************************************************************* //
