
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 2.5765e-18 )"
        "(  280 1.1793e-17 )"
        "(  285 5.1189e-17 )"
        "(  290 2.1127e-16 )"
        "(  295 8.3119e-16 )"
        "(  300 3.1247e-15 )"
        "(  305 1.1249e-14 )"
        "(  310 3.8856e-14 )"
        "(  315 1.2904e-13 )"
        "(  320 4.1267e-13 )"
        "(  325 1.2730e-12 )"
        "(  330 3.7937e-12 )"
        "(  335 1.0936e-11 )"
        "(  340 3.0533e-11 )"
        "(  345 8.2654e-11 )"
        "(  350 2.1715e-10 )"
        "(  355 5.5413e-10 )"
        "(  360 1.3745e-09 )"
        "(  365 3.3157e-09 )"
        "(  370 7.7822e-09 )"
        "(  375 1.7777e-08 )"
        "(  380 3.9527e-08 )"
        "(  385 8.5551e-08 )"
        "(  390 1.8023e-07 )"
        "(  395 3.6950e-07 )"
        "(  400 7.3705e-07 )"
        "(  405 1.4301e-06 )"
        "(  410 2.6986e-06 )"
        "(  415 4.9516e-06 )"
        "(  420 8.8343e-06 )"
        "(  425 1.5327e-05 )"
        "(  430 2.5866e-05 )"
        "(  435 4.2480e-05 )"
        "(  440 6.7934e-05 )"
        "(  445 1.0587e-04 )"
        "(  450 1.6093e-04 )"
        "(  455 2.3883e-04 )"
        "(  460 3.4645e-04 )"
        "(  465 4.9174e-04 )"
        "(  470 6.8376e-04 )"
        "(  475 9.3250e-04 )"
        "(  480 1.2488e-03 )"
        "(  485 1.6442e-03 )"
        "(  490 2.1307e-03 )"
        "(  495 2.7208e-03 )"
        "(  500 3.4276e-03 )"
        "(  505 4.2642e-03 )"
        "(  510 5.2439e-03 )"
        "(  515 6.3803e-03 )"
        "(  520 7.6864e-03 )"
        "(  525 9.1751e-03 )"
        "(  530 1.0858e-02 )"
        "(  535 1.2745e-02 )"
        "(  540 1.4844e-02 )"
        "(  545 1.7160e-02 )"
        "(  550 1.9695e-02 )"
        "(  555 2.2445e-02 )"
        "(  560 2.5402e-02 )"
        "(  565 2.8551e-02 )"
        "(  570 3.1869e-02 )"
        "(  575 3.5328e-02 )"
        "(  580 3.8890e-02 )"
        "(  585 4.2510e-02 )"
        "(  590 4.6136e-02 )"
        "(  595 4.9709e-02 )"
        "(  600 5.3167e-02 )"
        "(  605 5.6444e-02 )"
        "(  610 5.9481e-02 )"
        "(  615 6.2219e-02 )"
        "(  620 6.4615e-02 )"
        "(  625 6.6635e-02 )"
        "(  630 6.8262e-02 )"
        "(  635 6.9498e-02 )"
        "(  640 7.0358e-02 )"
        "(  645 7.0871e-02 )"
        "(  650 7.1078e-02 )"
        "(  655 7.1023e-02 )"
        "(  660 7.0754e-02 )"
        "(  665 7.0316e-02 )"
        "(  670 6.9756e-02 )"
        "(  675 6.9117e-02 )"
        "(  680 6.8440e-02 )"
        "(  685 6.7765e-02 )"
        "(  690 6.7131e-02 )"
        "(  695 6.6572e-02 )"
        "(  700 6.6117e-02 )"
        "(  705 6.5788e-02 )"
        "(  710 6.5600e-02 )"
        "(  715 6.5556e-02 )"
        "(  720 6.5653e-02 )"
        "(  725 6.5879e-02 )"
        "(  730 6.6216e-02 )"
        "(  735 6.6642e-02 )"
        "(  740 6.7132e-02 )"
        "(  745 6.7662e-02 )"
        "(  750 6.8211e-02 )"
        "(  755 6.8761e-02 )"
        "(  760 6.9299e-02 )"
        "(  765 6.9817e-02 )"
        "(  770 7.0315e-02 )"
        "(  775 7.0796e-02 )"
        "(  780 7.1266e-02 )"
        "(  785 7.1735e-02 )"
        "(  790 7.2212e-02 )"
        "(  795 7.2704e-02 )"
        "(  800 7.3214e-02 )"
        "(  805 7.3744e-02 )"
        "(  810 7.4291e-02 )"
        "(  815 7.4851e-02 )"
        "(  820 7.5420e-02 )"
        "(  825 7.5991e-02 )"
        "(  830 7.6558e-02 )"
        "(  835 7.7115e-02 )"
        "(  840 7.7655e-02 )"
        "(  845 7.8174e-02 )"
        "(  850 7.8668e-02 )"
        "(  855 7.9133e-02 )"
        "(  860 7.9568e-02 )"
        "(  865 7.9970e-02 )"
        "(  870 8.0337e-02 )"
        "(  875 8.0670e-02 )"
        "(  880 8.0967e-02 )"
        "(  885 8.1228e-02 )"
        "(  890 8.1454e-02 )"
        "(  895 8.1645e-02 )"
        "(  900 8.1801e-02 )"
        "(  905 8.1924e-02 )"
        "(  910 8.2014e-02 )"
        "(  915 8.2074e-02 )"
        "(  920 8.2103e-02 )"
        "(  925 8.2103e-02 )"
        "(  930 8.2075e-02 )"
        "(  935 8.2021e-02 )"
        "(  940 8.1942e-02 )"
        "(  945 8.1839e-02 )"
        "(  950 8.1712e-02 )"
        "(  955 8.1563e-02 )"
        "(  960 8.1393e-02 )"
        "(  965 8.1202e-02 )"
        "(  970 8.0991e-02 )"
        "(  975 8.0760e-02 )"
        "(  980 8.0511e-02 )"
        "(  985 8.0243e-02 )"
        "(  990 7.9957e-02 )"
        "(  995 7.9653e-02 )"
        "( 1000 7.9331e-02 )"
        "( 1005 7.8991e-02 )"
        "( 1010 7.8633e-02 )"
        "( 1015 7.8258e-02 )"
        "( 1020 7.7865e-02 )"
        "( 1025 7.7453e-02 )"
        "( 1030 7.7023e-02 )"
        "( 1035 7.6574e-02 )"
        "( 1040 7.6105e-02 )"
        "( 1045 7.5617e-02 )"
        "( 1050 7.5108e-02 )"
        "( 1055 7.4578e-02 )"
        "( 1060 7.4028e-02 )"
        "( 1065 7.3457e-02 )"
        "( 1070 7.2866e-02 )"
        "( 1075 7.2255e-02 )"
        "( 1080 7.1625e-02 )"
        "( 1085 7.0979e-02 )"
        "( 1090 7.0317e-02 )"
        "( 1095 6.9643e-02 )"
        "( 1100 6.8960e-02 )"
        "( 1105 6.8271e-02 )"
        "( 1110 6.7579e-02 )"
        "( 1115 6.6888e-02 )"
        "( 1120 6.6200e-02 )"
        "( 1125 6.5519e-02 )"
        "( 1130 6.4847e-02 )"
        "( 1135 6.4184e-02 )"
        "( 1140 6.3532e-02 )"
        "( 1145 6.2890e-02 )"
        "( 1150 6.2258e-02 )"
        "( 1155 6.1637e-02 )"
        "( 1160 6.1025e-02 )"
        "( 1165 6.0423e-02 )"
        "( 1170 5.9830e-02 )"
        "( 1175 5.9248e-02 )"
        "( 1180 5.8678e-02 )"
        "( 1185 5.8120e-02 )"
        "( 1190 5.7575e-02 )"
        "( 1195 5.7045e-02 )"
        "( 1200 5.6530e-02 )"
        "( 1205 5.6032e-02 )"
        "( 1210 5.5550e-02 )"
        "( 1215 5.5084e-02 )"
        "( 1220 5.4634e-02 )"
        "( 1225 5.4199e-02 )"
        "( 1230 5.3778e-02 )"
        "( 1235 5.3371e-02 )"
        "( 1240 5.2975e-02 )"
        "( 1245 5.2590e-02 )"
        "( 1250 5.2215e-02 )"
        "( 1255 5.1848e-02 )"
        "( 1260 5.1490e-02 )"
        "( 1265 5.1139e-02 )"
        "( 1270 5.0794e-02 )"
        "( 1275 5.0456e-02 )"
        "( 1280 5.0124e-02 )"
        "( 1285 4.9797e-02 )"
        "( 1290 4.9475e-02 )"
        "( 1295 4.9157e-02 )"
        "( 1300 4.8844e-02 )"
        "( 1305 4.8535e-02 )"
        "( 1310 4.8230e-02 )"
        "( 1315 4.7929e-02 )"
        "( 1320 4.7632e-02 )"
        "( 1325 4.7338e-02 )"
        "( 1330 4.7047e-02 )"
        "( 1335 4.6760e-02 )"
        "( 1340 4.6476e-02 )"
        "( 1345 4.6195e-02 )"
        "( 1350 4.5917e-02 )"
        "( 1355 4.5642e-02 )"
        "( 1360 4.5370e-02 )"
        "( 1365 4.5100e-02 )"
        "( 1370 4.4834e-02 )"
        "( 1375 4.4570e-02 )"
        "( 1380 4.4309e-02 )"
        "( 1385 4.4051e-02 )"
        "( 1390 4.3795e-02 )"
        "( 1395 4.3542e-02 )"
        "( 1400 4.3292e-02 )"
        "( 1405 4.3044e-02 )"
        "( 1410 4.2798e-02 )"
        "( 1415 4.2556e-02 )"
        "( 1420 4.2315e-02 )"
        "( 1425 4.2077e-02 )"
        "( 1430 4.1842e-02 )"
        "( 1435 4.1608e-02 )"
        "( 1440 4.1378e-02 )"
        "( 1445 4.1149e-02 )"
        "( 1450 4.0923e-02 )"
        "( 1455 4.0699e-02 )"
        "( 1460 4.0478e-02 )"
        "( 1465 4.0258e-02 )"
        "( 1470 4.0041e-02 )"
        "( 1475 3.9826e-02 )"
        "( 1480 3.9614e-02 )"
        "( 1485 3.9403e-02 )"
        "( 1490 3.9195e-02 )"
        "( 1495 3.8989e-02 )"
        "( 1500 3.8784e-02 )"
        "( 1505 3.8582e-02 )"
        "( 1510 3.8382e-02 )"
        "( 1515 3.8184e-02 )"
        "( 1520 3.7989e-02 )"
        "( 1525 3.7795e-02 )"
        "( 1530 3.7603e-02 )"
        "( 1535 3.7413e-02 )"
        "( 1540 3.7225e-02 )"
        "( 1545 3.7039e-02 )"
        "( 1550 3.6854e-02 )"
        "( 1555 3.6672e-02 )"
        "( 1560 3.6492e-02 )"
        "( 1565 3.6313e-02 )"
        "( 1570 3.6136e-02 )"
        "( 1575 3.5961e-02 )"
        "( 1580 3.5788e-02 )"
        "( 1585 3.5617e-02 )"
        "( 1590 3.5447e-02 )"
        "( 1595 3.5279e-02 )"
        "( 1600 3.5113e-02 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveC6H10O5FvPatchScalarField
    );

}

// ************************************************************************* //
