
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 9.9993e-01 )"
        "(  280 9.9990e-01 )"
        "(  285 9.9984e-01 )"
        "(  290 9.9976e-01 )"
        "(  295 9.9964e-01 )"
        "(  300 9.9945e-01 )"
        "(  305 9.9919e-01 )"
        "(  310 9.9882e-01 )"
        "(  315 9.9830e-01 )"
        "(  320 9.9756e-01 )"
        "(  325 9.9655e-01 )"
        "(  330 9.9517e-01 )"
        "(  335 9.9331e-01 )"
        "(  340 9.9081e-01 )"
        "(  345 9.8751e-01 )"
        "(  350 9.8318e-01 )"
        "(  355 9.7758e-01 )"
        "(  360 9.7038e-01 )"
        "(  365 9.6125e-01 )"
        "(  370 9.4981e-01 )"
        "(  375 9.3562e-01 )"
        "(  380 9.1826e-01 )"
        "(  385 8.9733e-01 )"
        "(  390 8.7245e-01 )"
        "(  395 8.4334e-01 )"
        "(  400 8.0989e-01 )"
        "(  405 7.7212e-01 )"
        "(  410 7.3032e-01 )"
        "(  415 6.8496e-01 )"
        "(  420 6.3677e-01 )"
        "(  425 5.8664e-01 )"
        "(  430 5.3558e-01 )"
        "(  435 4.8464e-01 )"
        "(  440 4.3482e-01 )"
        "(  445 3.8699e-01 )"
        "(  450 3.4189e-01 )"
        "(  455 3.0003e-01 )"
        "(  460 2.6173e-01 )"
        "(  465 2.2713e-01 )"
        "(  470 1.9624e-01 )"
        "(  475 1.6892e-01 )"
        "(  480 1.4495e-01 )"
        "(  485 1.2409e-01 )"
        "(  490 1.0602e-01 )"
        "(  495 9.0451e-02 )"
        "(  500 7.7091e-02 )"
        "(  505 6.5662e-02 )"
        "(  510 5.5908e-02 )"
        "(  515 4.7597e-02 )"
        "(  520 4.0526e-02 )"
        "(  525 3.4513e-02 )"
        "(  530 2.9404e-02 )"
        "(  535 2.5062e-02 )"
        "(  540 2.1374e-02 )"
        "(  545 1.8240e-02 )"
        "(  550 1.5576e-02 )"
        "(  555 1.3313e-02 )"
        "(  560 1.1390e-02 )"
        "(  565 9.7558e-03 )"
        "(  570 8.3686e-03 )"
        "(  575 7.1917e-03 )"
        "(  580 6.1947e-03 )"
        "(  585 5.3512e-03 )"
        "(  590 4.6394e-03 )"
        "(  595 4.0401e-03 )"
        "(  600 3.5371e-03 )"
        "(  605 3.1166e-03 )"
        "(  610 2.7664e-03 )"
        "(  615 2.4761e-03 )"
        "(  620 2.2366e-03 )"
        "(  625 2.0400e-03 )"
        "(  630 1.8795e-03 )"
        "(  635 1.7493e-03 )"
        "(  640 1.6442e-03 )"
        "(  645 1.5601e-03 )"
        "(  650 1.4933e-03 )"
        "(  655 1.4410e-03 )"
        "(  660 1.4006e-03 )"
        "(  665 1.3703e-03 )"
        "(  670 1.3483e-03 )"
        "(  675 1.3335e-03 )"
        "(  680 1.3252e-03 )"
        "(  685 1.3226e-03 )"
        "(  690 1.3257e-03 )"
        "(  695 1.3341e-03 )"
        "(  700 1.3481e-03 )"
        "(  705 1.3676e-03 )"
        "(  710 1.3927e-03 )"
        "(  715 1.4234e-03 )"
        "(  720 1.4598e-03 )"
        "(  725 1.5015e-03 )"
        "(  730 1.5484e-03 )"
        "(  735 1.6001e-03 )"
        "(  740 1.6562e-03 )"
        "(  745 1.7162e-03 )"
        "(  750 1.7799e-03 )"
        "(  755 1.8468e-03 )"
        "(  760 1.9169e-03 )"
        "(  765 1.9900e-03 )"
        "(  770 2.0662e-03 )"
        "(  775 2.1459e-03 )"
        "(  780 2.2296e-03 )"
        "(  785 2.3177e-03 )"
        "(  790 2.4109e-03 )"
        "(  795 2.5097e-03 )"
        "(  800 2.6149e-03 )"
        "(  805 2.7269e-03 )"
        "(  810 2.8462e-03 )"
        "(  815 2.9731e-03 )"
        "(  820 3.1079e-03 )"
        "(  825 3.2511e-03 )"
        "(  830 3.4028e-03 )"
        "(  835 3.5631e-03 )"
        "(  840 3.7324e-03 )"
        "(  845 3.9107e-03 )"
        "(  850 4.0980e-03 )"
        "(  855 4.2945e-03 )"
        "(  860 4.5000e-03 )"
        "(  865 4.7144e-03 )"
        "(  870 4.9374e-03 )"
        "(  875 5.1686e-03 )"
        "(  880 5.4076e-03 )"
        "(  885 5.6538e-03 )"
        "(  890 5.9063e-03 )"
        "(  895 6.1644e-03 )"
        "(  900 6.4271e-03 )"
        "(  905 6.6934e-03 )"
        "(  910 6.9622e-03 )"
        "(  915 7.2324e-03 )"
        "(  920 7.5031e-03 )"
        "(  925 7.7731e-03 )"
        "(  930 8.0416e-03 )"
        "(  935 8.3078e-03 )"
        "(  940 8.5709e-03 )"
        "(  945 8.8304e-03 )"
        "(  950 9.0859e-03 )"
        "(  955 9.3369e-03 )"
        "(  960 9.5833e-03 )"
        "(  965 9.8249e-03 )"
        "(  970 1.0062e-02 )"
        "(  975 1.0294e-02 )"
        "(  980 1.0521e-02 )"
        "(  985 1.0744e-02 )"
        "(  990 1.0961e-02 )"
        "(  995 1.1175e-02 )"
        "( 1000 1.1383e-02 )"
        "( 1005 1.1587e-02 )"
        "( 1010 1.1787e-02 )"
        "( 1015 1.1981e-02 )"
        "( 1020 1.2171e-02 )"
        "( 1025 1.2356e-02 )"
        "( 1030 1.2536e-02 )"
        "( 1035 1.2711e-02 )"
        "( 1040 1.2880e-02 )"
        "( 1045 1.3044e-02 )"
        "( 1050 1.3201e-02 )"
        "( 1055 1.3353e-02 )"
        "( 1060 1.3499e-02 )"
        "( 1065 1.3638e-02 )"
        "( 1070 1.3770e-02 )"
        "( 1075 1.3896e-02 )"
        "( 1080 1.4016e-02 )"
        "( 1085 1.4128e-02 )"
        "( 1090 1.4235e-02 )"
        "( 1095 1.4336e-02 )"
        "( 1100 1.4431e-02 )"
        "( 1105 1.4521e-02 )"
        "( 1110 1.4608e-02 )"
        "( 1115 1.4690e-02 )"
        "( 1120 1.4770e-02 )"
        "( 1125 1.4848e-02 )"
        "( 1130 1.4924e-02 )"
        "( 1135 1.4998e-02 )"
        "( 1140 1.5072e-02 )"
        "( 1145 1.5144e-02 )"
        "( 1150 1.5216e-02 )"
        "( 1155 1.5286e-02 )"
        "( 1160 1.5355e-02 )"
        "( 1165 1.5424e-02 )"
        "( 1170 1.5491e-02 )"
        "( 1175 1.5558e-02 )"
        "( 1180 1.5625e-02 )"
        "( 1185 1.5691e-02 )"
        "( 1190 1.5759e-02 )"
        "( 1195 1.5827e-02 )"
        "( 1200 1.5896e-02 )"
        "( 1205 1.5967e-02 )"
        "( 1210 1.6040e-02 )"
        "( 1215 1.6114e-02 )"
        "( 1220 1.6191e-02 )"
        "( 1225 1.6270e-02 )"
        "( 1230 1.6350e-02 )"
        "( 1235 1.6432e-02 )"
        "( 1240 1.6515e-02 )"
        "( 1245 1.6599e-02 )"
        "( 1250 1.6684e-02 )"
        "( 1255 1.6769e-02 )"
        "( 1260 1.6855e-02 )"
        "( 1265 1.6942e-02 )"
        "( 1270 1.7028e-02 )"
        "( 1275 1.7115e-02 )"
        "( 1280 1.7201e-02 )"
        "( 1285 1.7287e-02 )"
        "( 1290 1.7373e-02 )"
        "( 1295 1.7458e-02 )"
        "( 1300 1.7544e-02 )"
        "( 1305 1.7628e-02 )"
        "( 1310 1.7712e-02 )"
        "( 1315 1.7796e-02 )"
        "( 1320 1.7879e-02 )"
        "( 1325 1.7961e-02 )"
        "( 1330 1.8043e-02 )"
        "( 1335 1.8124e-02 )"
        "( 1340 1.8204e-02 )"
        "( 1345 1.8284e-02 )"
        "( 1350 1.8363e-02 )"
        "( 1355 1.8441e-02 )"
        "( 1360 1.8519e-02 )"
        "( 1365 1.8595e-02 )"
        "( 1370 1.8672e-02 )"
        "( 1375 1.8747e-02 )"
        "( 1380 1.8822e-02 )"
        "( 1385 1.8896e-02 )"
        "( 1390 1.8969e-02 )"
        "( 1395 1.9042e-02 )"
        "( 1400 1.9113e-02 )"
        "( 1405 1.9185e-02 )"
        "( 1410 1.9255e-02 )"
        "( 1415 1.9325e-02 )"
        "( 1420 1.9394e-02 )"
        "( 1425 1.9462e-02 )"
        "( 1430 1.9530e-02 )"
        "( 1435 1.9597e-02 )"
        "( 1440 1.9664e-02 )"
        "( 1445 1.9730e-02 )"
        "( 1450 1.9795e-02 )"
        "( 1455 1.9859e-02 )"
        "( 1460 1.9923e-02 )"
        "( 1465 1.9986e-02 )"
        "( 1470 2.0049e-02 )"
        "( 1475 2.0111e-02 )"
        "( 1480 2.0173e-02 )"
        "( 1485 2.0234e-02 )"
        "( 1490 2.0294e-02 )"
        "( 1495 2.0354e-02 )"
        "( 1500 2.0413e-02 )"
        "( 1505 2.0471e-02 )"
        "( 1510 2.0529e-02 )"
        "( 1515 2.0587e-02 )"
        "( 1520 2.0644e-02 )"
        "( 1525 2.0700e-02 )"
        "( 1530 2.0756e-02 )"
        "( 1535 2.0811e-02 )"
        "( 1540 2.0866e-02 )"
        "( 1545 2.0921e-02 )"
        "( 1550 2.0974e-02 )"
        "( 1555 2.1028e-02 )"
        "( 1560 2.1081e-02 )"
        "( 1565 2.1133e-02 )"
        "( 1570 2.1185e-02 )"
        "( 1575 2.1236e-02 )"
        "( 1580 2.1287e-02 )"
        "( 1585 2.1338e-02 )"
        "( 1590 2.1388e-02 )"
        "( 1595 2.1437e-02 )"
        "( 1600 2.1487e-02 )"
        ")"


    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveC6H6OFvPatchScalarField
    );

}

// ************************************************************************* //
