
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 5.3356e-23 )"
        "(  280 3.2294e-22 )"
        "(  285 1.8348e-21 )"
        "(  290 9.8177e-21 )"
        "(  295 4.9624e-20 )"
        "(  300 2.3761e-19 )"
        "(  305 1.0806e-18 )"
        "(  310 4.6789e-18 )"
        "(  315 1.9332e-17 )"
        "(  320 7.6381e-17 )"
        "(  325 2.8914e-16 )"
        "(  330 1.0506e-15 )"
        "(  335 3.6699e-15 )"
        "(  340 1.2343e-14 )"
        "(  345 4.0028e-14 )"
        "(  350 1.2530e-13 )"
        "(  355 3.7904e-13 )"
        "(  360 1.1090e-12 )"
        "(  365 3.1410e-12 )"
        "(  370 8.6165e-12 )"
        "(  375 2.2905e-11 )"
        "(  380 5.9019e-11 )"
        "(  385 1.4744e-10 )"
        "(  390 3.5715e-10 )"
        "(  395 8.3880e-10 )"
        "(  400 1.9099e-09 )"
        "(  405 4.2158e-09 )"
        "(  410 9.0201e-09 )"
        "(  415 1.8707e-08 )"
        "(  420 3.7607e-08 )"
        "(  425 7.3305e-08 )"
        "(  430 1.3859e-07 )"
        "(  435 2.5429e-07 )"
        "(  440 4.5314e-07 )"
        "(  445 7.8487e-07 )"
        "(  450 1.3227e-06 )"
        "(  455 2.1712e-06 )"
        "(  460 3.4754e-06 )"
        "(  465 5.4312e-06 )"
        "(  470 8.2970e-06 )"
        "(  475 1.2406e-05 )"
        "(  480 1.8177e-05 )"
        "(  485 2.6133e-05 )"
        "(  490 3.6911e-05 )"
        "(  495 5.1279e-05 )"
        "(  500 7.0152e-05 )"
        "(  505 9.4612e-05 )"
        "(  510 1.2592e-04 )"
        "(  515 1.6554e-04 )"
        "(  520 2.1514e-04 )"
        "(  525 2.7662e-04 )"
        "(  530 3.5208e-04 )"
        "(  535 4.4384e-04 )"
        "(  540 5.5440e-04 )"
        "(  545 6.8642e-04 )"
        "(  550 8.4262e-04 )"
        "(  555 1.0258e-03 )"
        "(  560 1.2385e-03 )"
        "(  565 1.4832e-03 )"
        "(  570 1.7620e-03 )"
        "(  575 2.0764e-03 )"
        "(  580 2.4271e-03 )"
        "(  585 2.8140e-03 )"
        "(  590 3.2358e-03 )"
        "(  595 3.6901e-03 )"
        "(  600 4.1731e-03 )"
        "(  605 4.6799e-03 )"
        "(  610 5.2043e-03 )"
        "(  615 5.7395e-03 )"
        "(  620 6.2783e-03 )"
        "(  625 6.8138e-03 )"
        "(  630 7.3394e-03 )"
        "(  635 7.8502e-03 )"
        "(  640 8.3422e-03 )"
        "(  645 8.8136e-03 )"
        "(  650 9.2636e-03 )"
        "(  655 9.6934e-03 )"
        "(  660 1.0105e-02 )"
        "(  665 1.0501e-02 )"
        "(  670 1.0884e-02 )"
        "(  675 1.1261e-02 )"
        "(  680 1.1635e-02 )"
        "(  685 1.2012e-02 )"
        "(  690 1.2400e-02 )"
        "(  695 1.2805e-02 )"
        "(  700 1.3235e-02 )"
        "(  705 1.3697e-02 )"
        "(  710 1.4196e-02 )"
        "(  715 1.4738e-02 )"
        "(  720 1.5324e-02 )"
        "(  725 1.5955e-02 )"
        "(  730 1.6631e-02 )"
        "(  735 1.7349e-02 )"
        "(  740 1.8105e-02 )"
        "(  745 1.8894e-02 )"
        "(  750 1.9712e-02 )"
        "(  755 2.0554e-02 )"
        "(  760 2.1416e-02 )"
        "(  765 2.2296e-02 )"
        "(  770 2.3194e-02 )"
        "(  775 2.4109e-02 )"
        "(  780 2.5045e-02 )"
        "(  785 2.6003e-02 )"
        "(  790 2.6989e-02 )"
        "(  795 2.8004e-02 )"
        "(  800 2.9052e-02 )"
        "(  805 3.0133e-02 )"
        "(  810 3.1247e-02 )"
        "(  815 3.2394e-02 )"
        "(  820 3.3572e-02 )"
        "(  825 3.4779e-02 )"
        "(  830 3.6012e-02 )"
        "(  835 3.7267e-02 )"
        "(  840 3.8543e-02 )"
        "(  845 3.9836e-02 )"
        "(  850 4.1143e-02 )"
        "(  855 4.2461e-02 )"
        "(  860 4.3788e-02 )"
        "(  865 4.5123e-02 )"
        "(  870 4.6462e-02 )"
        "(  875 4.7804e-02 )"
        "(  880 4.9148e-02 )"
        "(  885 5.0491e-02 )"
        "(  890 5.1832e-02 )"
        "(  895 5.3170e-02 )"
        "(  900 5.4503e-02 )"
        "(  905 5.5831e-02 )"
        "(  910 5.7153e-02 )"
        "(  915 5.8468e-02 )"
        "(  920 5.9774e-02 )"
        "(  925 6.1073e-02 )"
        "(  930 6.2362e-02 )"
        "(  935 6.3642e-02 )"
        "(  940 6.4911e-02 )"
        "(  945 6.6170e-02 )"
        "(  950 6.7418e-02 )"
        "(  955 6.8654e-02 )"
        "(  960 6.9877e-02 )"
        "(  965 7.1088e-02 )"
        "(  970 7.2284e-02 )"
        "(  975 7.3466e-02 )"
        "(  980 7.4633e-02 )"
        "(  985 7.5783e-02 )"
        "(  990 7.6917e-02 )"
        "(  995 7.8032e-02 )"
        "( 1000 7.9128e-02 )"
        "( 1005 8.0204e-02 )"
        "( 1010 8.1259e-02 )"
        "( 1015 8.2290e-02 )"
        "( 1020 8.3297e-02 )"
        "( 1025 8.4278e-02 )"
        "( 1030 8.5232e-02 )"
        "( 1035 8.6157e-02 )"
        "( 1040 8.7050e-02 )"
        "( 1045 8.7910e-02 )"
        "( 1050 8.8735e-02 )"
        "( 1055 8.9523e-02 )"
        "( 1060 9.0273e-02 )"
        "( 1065 9.0983e-02 )"
        "( 1070 9.1652e-02 )"
        "( 1075 9.2280e-02 )"
        "( 1080 9.2866e-02 )"
        "( 1085 9.3411e-02 )"
        "( 1090 9.3917e-02 )"
        "( 1095 9.4386e-02 )"
        "( 1100 9.4821e-02 )"
        "( 1105 9.5225e-02 )"
        "( 1110 9.5604e-02 )"
        "( 1115 9.5961e-02 )"
        "( 1120 9.6300e-02 )"
        "( 1125 9.6626e-02 )"
        "( 1130 9.6941e-02 )"
        "( 1135 9.7249e-02 )"
        "( 1140 9.7549e-02 )"
        "( 1145 9.7843e-02 )"
        "( 1150 9.8132e-02 )"
        "( 1155 9.8413e-02 )"
        "( 1160 9.8689e-02 )"
        "( 1165 9.8958e-02 )"
        "( 1170 9.9222e-02 )"
        "( 1175 9.9482e-02 )"
        "( 1180 9.9740e-02 )"
        "( 1185 9.9999e-02 )"
        "( 1190 1.0026e-01 )"
        "( 1195 1.0053e-01 )"
        "( 1200 1.0080e-01 )"
        "( 1205 1.0109e-01 )"
        "( 1210 1.0138e-01 )"
        "( 1215 1.0169e-01 )"
        "( 1220 1.0201e-01 )"
        "( 1225 1.0234e-01 )"
        "( 1230 1.0268e-01 )"
        "( 1235 1.0303e-01 )"
        "( 1240 1.0339e-01 )"
        "( 1245 1.0375e-01 )"
        "( 1250 1.0412e-01 )"
        "( 1255 1.0449e-01 )"
        "( 1260 1.0487e-01 )"
        "( 1265 1.0524e-01 )"
        "( 1270 1.0562e-01 )"
        "( 1275 1.0599e-01 )"
        "( 1280 1.0636e-01 )"
        "( 1285 1.0673e-01 )"
        "( 1290 1.0710e-01 )"
        "( 1295 1.0747e-01 )"
        "( 1300 1.0783e-01 )"
        "( 1305 1.0819e-01 )"
        "( 1310 1.0854e-01 )"
        "( 1315 1.0889e-01 )"
        "( 1320 1.0924e-01 )"
        "( 1325 1.0958e-01 )"
        "( 1330 1.0991e-01 )"
        "( 1335 1.1025e-01 )"
        "( 1340 1.1057e-01 )"
        "( 1345 1.1090e-01 )"
        "( 1350 1.1121e-01 )"
        "( 1355 1.1153e-01 )"
        "( 1360 1.1184e-01 )"
        "( 1365 1.1214e-01 )"
        "( 1370 1.1244e-01 )"
        "( 1375 1.1273e-01 )"
        "( 1380 1.1302e-01 )"
        "( 1385 1.1331e-01 )"
        "( 1390 1.1359e-01 )"
        "( 1395 1.1386e-01 )"
        "( 1400 1.1413e-01 )"
        "( 1405 1.1440e-01 )"
        "( 1410 1.1466e-01 )"
        "( 1415 1.1492e-01 )"
        "( 1420 1.1517e-01 )"
        "( 1425 1.1542e-01 )"
        "( 1430 1.1567e-01 )"
        "( 1435 1.1591e-01 )"
        "( 1440 1.1615e-01 )"
        "( 1445 1.1638e-01 )"
        "( 1450 1.1661e-01 )"
        "( 1455 1.1683e-01 )"
        "( 1460 1.1705e-01 )"
        "( 1465 1.1727e-01 )"
        "( 1470 1.1748e-01 )"
        "( 1475 1.1769e-01 )"
        "( 1480 1.1790e-01 )"
        "( 1485 1.1810e-01 )"
        "( 1490 1.1830e-01 )"
        "( 1495 1.1850e-01 )"
        "( 1500 1.1869e-01 )"
        "( 1505 1.1888e-01 )"
        "( 1510 1.1907e-01 )"
        "( 1515 1.1925e-01 )"
        "( 1520 1.1943e-01 )"
        "( 1525 1.1960e-01 )"
        "( 1530 1.1978e-01 )"
        "( 1535 1.1995e-01 )"
        "( 1540 1.2012e-01 )"
        "( 1545 1.2028e-01 )"
        "( 1550 1.2044e-01 )"
        "( 1555 1.2060e-01 )"
        "( 1560 1.2076e-01 )"
        "( 1565 1.2091e-01 )"
        "( 1570 1.2106e-01 )"
        "( 1575 1.2121e-01 )"
        "( 1580 1.2136e-01 )"
        "( 1585 1.2150e-01 )"
        "( 1590 1.2164e-01 )"
        "( 1595 1.2178e-01 )"
        "( 1600 1.2192e-01 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveC6H6O3FvPatchScalarField
    );

}

// ************************************************************************* //
