
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 2.9529e-17 )"
        "(  280 1.0056e-16 )"
        "(  285 3.2805e-16 )"
        "(  290 1.0274e-15 )"
        "(  295 3.0952e-15 )"
        "(  300 8.9877e-15 )"
        "(  305 2.5200e-14 )"
        "(  310 6.8337e-14 )"
        "(  315 1.7951e-13 )"
        "(  320 4.5741e-13 )"
        "(  325 1.1321e-12 )"
        "(  330 2.7252e-12 )"
        "(  335 6.3865e-12 )"
        "(  340 1.4587e-11 )"
        "(  345 3.2499e-11 )"
        "(  350 7.0686e-11 )"
        "(  355 1.5020e-10 )"
        "(  360 3.1197e-10 )"
        "(  365 6.3369e-10 )"
        "(  370 1.2593e-09 )"
        "(  375 2.4486e-09 )"
        "(  380 4.6598e-09 )"
        "(  385 8.6788e-09 )"
        "(  390 1.5819e-08 )"
        "(  395 2.8213e-08 )"
        "(  400 4.9231e-08 )"
        "(  405 8.4035e-08 )"
        "(  410 1.4031e-07 )"
        "(  415 2.2913e-07 )"
        "(  420 3.6602e-07 )"
        "(  425 5.7209e-07 )"
        "(  430 8.7530e-07 )"
        "(  435 1.3117e-06 )"
        "(  440 1.9267e-06 )"
        "(  445 2.7766e-06 )"
        "(  450 3.9295e-06 )"
        "(  455 5.4671e-06 )"
        "(  460 7.4857e-06 )"
        "(  465 1.0098e-05 )"
        "(  470 1.3436e-05 )"
        "(  475 1.7648e-05 )"
        "(  480 2.2907e-05 )"
        "(  485 2.9408e-05 )"
        "(  490 3.7371e-05 )"
        "(  495 4.7043e-05 )"
        "(  500 5.8696e-05 )"
        "(  505 7.2634e-05 )"
        "(  510 8.9187e-05 )"
        "(  515 1.0871e-04 )"
        "(  520 1.3160e-04 )"
        "(  525 1.5824e-04 )"
        "(  530 1.8906e-04 )"
        "(  535 2.2449e-04 )"
        "(  540 2.6494e-04 )"
        "(  545 3.1082e-04 )"
        "(  550 3.6250e-04 )"
        "(  555 4.2028e-04 )"
        "(  560 4.8439e-04 )"
        "(  565 5.5496e-04 )"
        "(  570 6.3198e-04 )"
        "(  575 7.1528e-04 )"
        "(  580 8.0448e-04 )"
        "(  585 8.9901e-04 )"
        "(  590 9.9805e-04 )"
        "(  595 1.1006e-03 )"
        "(  600 1.2053e-03 )"
        "(  605 1.3108e-03 )"
        "(  610 1.4156e-03 )"
        "(  615 1.5181e-03 )"
        "(  620 1.6168e-03 )"
        "(  625 1.7105e-03 )"
        "(  630 1.7981e-03 )"
        "(  635 1.8791e-03 )"
        "(  640 1.9531e-03 )"
        "(  645 2.0204e-03 )"
        "(  650 2.0813e-03 )"
        "(  655 2.1365e-03 )"
        "(  660 2.1870e-03 )"
        "(  665 2.2337e-03 )"
        "(  670 2.2777e-03 )"
        "(  675 2.3201e-03 )"
        "(  680 2.3621e-03 )"
        "(  685 2.4051e-03 )"
        "(  690 2.4504e-03 )"
        "(  695 2.4996e-03 )"
        "(  700 2.5539e-03 )"
        "(  705 2.6147e-03 )"
        "(  710 2.6831e-03 )"
        "(  715 2.7597e-03 )"
        "(  720 2.8452e-03 )"
        "(  725 2.9396e-03 )"
        "(  730 3.0429e-03 )"
        "(  735 3.1547e-03 )"
        "(  740 3.2745e-03 )"
        "(  745 3.4017e-03 )"
        "(  750 3.5357e-03 )"
        "(  755 3.6761e-03 )"
        "(  760 3.8227e-03 )"
        "(  765 3.9755e-03 )"
        "(  770 4.1350e-03 )"
        "(  775 4.3018e-03 )"
        "(  780 4.4769e-03 )"
        "(  785 4.6618e-03 )"
        "(  790 4.8577e-03 )"
        "(  795 5.0661e-03 )"
        "(  800 5.2883e-03 )"
        "(  805 5.5255e-03 )"
        "(  810 5.7788e-03 )"
        "(  815 6.0493e-03 )"
        "(  820 6.3378e-03 )"
        "(  825 6.6450e-03 )"
        "(  830 6.9716e-03 )"
        "(  835 7.3183e-03 )"
        "(  840 7.6854e-03 )"
        "(  845 8.0735e-03 )"
        "(  850 8.4828e-03 )"
        "(  855 8.9133e-03 )"
        "(  860 9.3651e-03 )"
        "(  865 9.8379e-03 )"
        "(  870 1.0331e-02 )"
        "(  875 1.0844e-02 )"
        "(  880 1.1375e-02 )"
        "(  885 1.1923e-02 )"
        "(  890 1.2486e-02 )"
        "(  895 1.3062e-02 )"
        "(  900 1.3650e-02 )"
        "(  905 1.4246e-02 )"
        "(  910 1.4848e-02 )"
        "(  915 1.5453e-02 )"
        "(  920 1.6060e-02 )"
        "(  925 1.6665e-02 )"
        "(  930 1.7267e-02 )"
        "(  935 1.7864e-02 )"
        "(  940 1.8453e-02 )"
        "(  945 1.9034e-02 )"
        "(  950 1.9605e-02 )"
        "(  955 2.0166e-02 )"
        "(  960 2.0716e-02 )"
        "(  965 2.1254e-02 )"
        "(  970 2.1782e-02 )"
        "(  975 2.2298e-02 )"
        "(  980 2.2804e-02 )"
        "(  985 2.3298e-02 )"
        "(  990 2.3781e-02 )"
        "(  995 2.4254e-02 )"
        "( 1000 2.4716e-02 )"
        "( 1005 2.5168e-02 )"
        "( 1010 2.5609e-02 )"
        "( 1015 2.6040e-02 )"
        "( 1020 2.6459e-02 )"
        "( 1025 2.6868e-02 )"
        "( 1030 2.7265e-02 )"
        "( 1035 2.7650e-02 )"
        "( 1040 2.8024e-02 )"
        "( 1045 2.8385e-02 )"
        "( 1050 2.8733e-02 )"
        "( 1055 2.9067e-02 )"
        "( 1060 2.9388e-02 )"
        "( 1065 2.9694e-02 )"
        "( 1070 2.9986e-02 )"
        "( 1075 3.0263e-02 )"
        "( 1080 3.0526e-02 )"
        "( 1085 3.0774e-02 )"
        "( 1090 3.1009e-02 )"
        "( 1095 3.1230e-02 )"
        "( 1100 3.1440e-02 )"
        "( 1105 3.1639e-02 )"
        "( 1110 3.1829e-02 )"
        "( 1115 3.2011e-02 )"
        "( 1120 3.2187e-02 )"
        "( 1125 3.2358e-02 )"
        "( 1130 3.2524e-02 )"
        "( 1135 3.2688e-02 )"
        "( 1140 3.2850e-02 )"
        "( 1145 3.3009e-02 )"
        "( 1150 3.3165e-02 )"
        "( 1155 3.3320e-02 )"
        "( 1160 3.3472e-02 )"
        "( 1165 3.3622e-02 )"
        "( 1170 3.3770e-02 )"
        "( 1175 3.3917e-02 )"
        "( 1180 3.4063e-02 )"
        "( 1185 3.4209e-02 )"
        "( 1190 3.4356e-02 )"
        "( 1195 3.4505e-02 )"
        "( 1200 3.4657e-02 )"
        "( 1205 3.4812e-02 )"
        "( 1210 3.4971e-02 )"
        "( 1215 3.5134e-02 )"
        "( 1220 3.5302e-02 )"
        "( 1225 3.5473e-02 )"
        "( 1230 3.5649e-02 )"
        "( 1235 3.5827e-02 )"
        "( 1240 3.6009e-02 )"
        "( 1245 3.6193e-02 )"
        "( 1250 3.6378e-02 )"
        "( 1255 3.6565e-02 )"
        "( 1260 3.6753e-02 )"
        "( 1265 3.6942e-02 )"
        "( 1270 3.7131e-02 )"
        "( 1275 3.7319e-02 )"
        "( 1280 3.7508e-02 )"
        "( 1285 3.7696e-02 )"
        "( 1290 3.7883e-02 )"
        "( 1295 3.8070e-02 )"
        "( 1300 3.8256e-02 )"
        "( 1305 3.8440e-02 )"
        "( 1310 3.8624e-02 )"
        "( 1315 3.8806e-02 )"
        "( 1320 3.8987e-02 )"
        "( 1325 3.9167e-02 )"
        "( 1330 3.9345e-02 )"
        "( 1335 3.9522e-02 )"
        "( 1340 3.9697e-02 )"
        "( 1345 3.9871e-02 )"
        "( 1350 4.0044e-02 )"
        "( 1355 4.0214e-02 )"
        "( 1360 4.0384e-02 )"
        "( 1365 4.0551e-02 )"
        "( 1370 4.0717e-02 )"
        "( 1375 4.0882e-02 )"
        "( 1380 4.1045e-02 )"
        "( 1385 4.1206e-02 )"
        "( 1390 4.1366e-02 )"
        "( 1395 4.1525e-02 )"
        "( 1400 4.1682e-02 )"
        "( 1405 4.1837e-02 )"
        "( 1410 4.1991e-02 )"
        "( 1415 4.2143e-02 )"
        "( 1420 4.2294e-02 )"
        "( 1425 4.2443e-02 )"
        "( 1430 4.2591e-02 )"
        "( 1435 4.2737e-02 )"
        "( 1440 4.2882e-02 )"
        "( 1445 4.3026e-02 )"
        "( 1450 4.3168e-02 )"
        "( 1455 4.3309e-02 )"
        "( 1460 4.3448e-02 )"
        "( 1465 4.3586e-02 )"
        "( 1470 4.3723e-02 )"
        "( 1475 4.3858e-02 )"
        "( 1480 4.3993e-02 )"
        "( 1485 4.4125e-02 )"
        "( 1490 4.4257e-02 )"
        "( 1495 4.4387e-02 )"
        "( 1500 4.4516e-02 )"
        "( 1505 4.4644e-02 )"
        "( 1510 4.4770e-02 )"
        "( 1515 4.4896e-02 )"
        "( 1520 4.5020e-02 )"
        "( 1525 4.5143e-02 )"
        "( 1530 4.5265e-02 )"
        "( 1535 4.5386e-02 )"
        "( 1540 4.5505e-02 )"
        "( 1545 4.5624e-02 )"
        "( 1550 4.5741e-02 )"
        "( 1555 4.5858e-02 )"
        "( 1560 4.5973e-02 )"
        "( 1565 4.6087e-02 )"
        "( 1570 4.6200e-02 )"
        "( 1575 4.6312e-02 )"
        "( 1580 4.6424e-02 )"
        "( 1585 4.6534e-02 )"
        "( 1590 4.6643e-02 )"
        "( 1595 4.6751e-02 )"
        "( 1600 4.6858e-02 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveC9H10O2FvPatchScalarField
    );

}

// ************************************************************************* //
