
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveCH2OFvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::
myTotalFlowRateAdvectiveDiffusiveCH2O::interpTable
(
    IStringStream
    (
        "("
        "(  275 2.5714e-11 )"
        "(  280 6.5361e-11 )"
        "(  285 1.6082e-10 )"
        "(  290 3.8371e-10 )"
        "(  295 8.8908e-10 )"
        "(  300 2.0035e-09 )"
        "(  305 4.3964e-09 )"
        "(  310 9.4065e-09 )"
        "(  315 1.9645e-08 )"
        "(  320 4.0091e-08 )"
        "(  325 8.0022e-08 )"
        "(  330 1.5636e-07 )"
        "(  335 2.9930e-07 )"
        "(  340 5.6168e-07 )"
        "(  345 1.0340e-06 )"
        "(  350 1.8681e-06 )"
        "(  355 3.3139e-06 )"
        "(  360 5.7735e-06 )"
        "(  365 9.8811e-06 )"
        "(  370 1.6614e-05 )"
        "(  375 2.7441e-05 )"
        "(  380 4.4523e-05 )"
        "(  385 7.0940e-05 )"
        "(  390 1.1097e-04 )"
        "(  395 1.7035e-04 )"
        "(  400 2.5653e-04 )"
        "(  405 3.7881e-04 )"
        "(  410 5.4832e-04 )"
        "(  415 7.7780e-04 )"
        "(  420 1.0810e-03 )"
        "(  425 1.4722e-03 )"
        "(  430 1.9649e-03 )"
        "(  435 2.5710e-03 )"
        "(  440 3.2997e-03 )"
        "(  445 4.1567e-03 )"
        "(  450 5.1437e-03 )"
        "(  455 6.2577e-03 )"
        "(  460 7.4914e-03 )"
        "(  465 8.8334e-03 )"
        "(  470 1.0268e-02 )"
        "(  475 1.1778e-02 )"
        "(  480 1.3343e-02 )"
        "(  485 1.4940e-02 )"
        "(  490 1.6549e-02 )"
        "(  495 1.8148e-02 )"
        "(  500 1.9719e-02 )"
        "(  505 2.1243e-02 )"
        "(  510 2.2708e-02 )"
        "(  515 2.4102e-02 )"
        "(  520 2.5420e-02 )"
        "(  525 2.6658e-02 )"
        "(  530 2.7818e-02 )"
        "(  535 2.8906e-02 )"
        "(  540 2.9930e-02 )"
        "(  545 3.0902e-02 )"
        "(  550 3.1838e-02 )"
        "(  555 3.2757e-02 )"
        "(  560 3.3678e-02 )"
        "(  565 3.4624e-02 )"
        "(  570 3.5618e-02 )"
        "(  575 3.6683e-02 )"
        "(  580 3.7844e-02 )"
        "(  585 3.9119e-02 )"
        "(  590 4.0525e-02 )"
        "(  595 4.2072e-02 )"
        "(  600 4.3763e-02 )"
        "(  605 4.5586e-02 )"
        "(  610 4.7522e-02 )"
        "(  615 4.9533e-02 )"
        "(  620 5.1571e-02 )"
        "(  625 5.3571e-02 )"
        "(  630 5.5462e-02 )"
        "(  635 5.7169e-02 )"
        "(  640 5.8618e-02 )"
        "(  645 5.9747e-02 )"
        "(  650 6.0511e-02 )"
        "(  655 6.0888e-02 )"
        "(  660 6.0886e-02 )"
        "(  665 6.0538e-02 )"
        "(  670 5.9899e-02 )"
        "(  675 5.9039e-02 )"
        "(  680 5.8032e-02 )"
        "(  685 5.6951e-02 )"
        "(  690 5.5857e-02 )"
        "(  695 5.4798e-02 )"
        "(  700 5.3808e-02 )"
        "(  705 5.2910e-02 )"
        "(  710 5.2115e-02 )"
        "(  715 5.1425e-02 )"
        "(  720 5.0837e-02 )"
        "(  725 5.0340e-02 )"
        "(  730 4.9921e-02 )"
        "(  735 4.9567e-02 )"
        "(  740 4.9262e-02 )"
        "(  745 4.8992e-02 )"
        "(  750 4.8745e-02 )"
        "(  755 4.8513e-02 )"
        "(  760 4.8289e-02 )"
        "(  765 4.8072e-02 )"
        "(  770 4.7862e-02 )"
        "(  775 4.7664e-02 )"
        "(  780 4.7483e-02 )"
        "(  785 4.7327e-02 )"
        "(  790 4.7201e-02 )"
        "(  795 4.7111e-02 )"
        "(  800 4.7058e-02 )"
        "(  805 4.7043e-02 )"
        "(  810 4.7064e-02 )"
        "(  815 4.7119e-02 )"
        "(  820 4.7204e-02 )"
        "(  825 4.7316e-02 )"
        "(  830 4.7449e-02 )"
        "(  835 4.7602e-02 )"
        "(  840 4.7769e-02 )"
        "(  845 4.7948e-02 )"
        "(  850 4.8136e-02 )"
        "(  855 4.8331e-02 )"
        "(  860 4.8532e-02 )"
        "(  865 4.8737e-02 )"
        "(  870 4.8945e-02 )"
        "(  875 4.9156e-02 )"
        "(  880 4.9368e-02 )"
        "(  885 4.9582e-02 )"
        "(  890 4.9796e-02 )"
        "(  895 5.0011e-02 )"
        "(  900 5.0227e-02 )"
        "(  905 5.0443e-02 )"
        "(  910 5.0659e-02 )"
        "(  915 5.0876e-02 )"
        "(  920 5.1093e-02 )"
        "(  925 5.1311e-02 )"
        "(  930 5.1530e-02 )"
        "(  935 5.1749e-02 )"
        "(  940 5.1969e-02 )"
        "(  945 5.2189e-02 )"
        "(  950 5.2411e-02 )"
        "(  955 5.2632e-02 )"
        "(  960 5.2853e-02 )"
        "(  965 5.3075e-02 )"
        "(  970 5.3296e-02 )"
        "(  975 5.3516e-02 )"
        "(  980 5.3734e-02 )"
        "(  985 5.3951e-02 )"
        "(  990 5.4166e-02 )"
        "(  995 5.4378e-02 )"
        "( 1000 5.4587e-02 )"
        "( 1005 5.4791e-02 )"
        "( 1010 5.4990e-02 )"
        "( 1015 5.5184e-02 )"
        "( 1020 5.5371e-02 )"
        "( 1025 5.5550e-02 )"
        "( 1030 5.5721e-02 )"
        "( 1035 5.5882e-02 )"
        "( 1040 5.6033e-02 )"
        "( 1045 5.6171e-02 )"
        "( 1050 5.6297e-02 )"
        "( 1055 5.6409e-02 )"
        "( 1060 5.6506e-02 )"
        "( 1065 5.6587e-02 )"
        "( 1070 5.6652e-02 )"
        "( 1075 5.6700e-02 )"
        "( 1080 5.6732e-02 )"
        "( 1085 5.6748e-02 )"
        "( 1090 5.6750e-02 )"
        "( 1095 5.6737e-02 )"
        "( 1100 5.6713e-02 )"
        "( 1105 5.6678e-02 )"
        "( 1110 5.6637e-02 )"
        "( 1115 5.6591e-02 )"
        "( 1120 5.6542e-02 )"
        "( 1125 5.6493e-02 )"
        "( 1130 5.6446e-02 )"
        "( 1135 5.6400e-02 )"
        "( 1140 5.6358e-02 )"
        "( 1145 5.6318e-02 )"
        "( 1150 5.6282e-02 )"
        "( 1155 5.6247e-02 )"
        "( 1160 5.6215e-02 )"
        "( 1165 5.6185e-02 )"
        "( 1170 5.6158e-02 )"
        "( 1175 5.6134e-02 )"
        "( 1180 5.6113e-02 )"
        "( 1185 5.6098e-02 )"
        "( 1190 5.6089e-02 )"
        "( 1195 5.6088e-02 )"
        "( 1200 5.6096e-02 )"
        "( 1205 5.6113e-02 )"
        "( 1210 5.6141e-02 )"
        "( 1215 5.6178e-02 )"
        "( 1220 5.6226e-02 )"
        "( 1225 5.6284e-02 )"
        "( 1230 5.6350e-02 )"
        "( 1235 5.6425e-02 )"
        "( 1240 5.6507e-02 )"
        "( 1245 5.6595e-02 )"
        "( 1250 5.6689e-02 )"
        "( 1255 5.6787e-02 )"
        "( 1260 5.6888e-02 )"
        "( 1265 5.6993e-02 )"
        "( 1270 5.7100e-02 )"
        "( 1275 5.7209e-02 )"
        "( 1280 5.7320e-02 )"
        "( 1285 5.7432e-02 )"
        "( 1290 5.7544e-02 )"
        "( 1295 5.7657e-02 )"
        "( 1300 5.7771e-02 )"
        "( 1305 5.7884e-02 )"
        "( 1310 5.7998e-02 )"
        "( 1315 5.8111e-02 )"
        "( 1320 5.8223e-02 )"
        "( 1325 5.8335e-02 )"
        "( 1330 5.8447e-02 )"
        "( 1335 5.8557e-02 )"
        "( 1340 5.8667e-02 )"
        "( 1345 5.8776e-02 )"
        "( 1350 5.8884e-02 )"
        "( 1355 5.8991e-02 )"
        "( 1360 5.9096e-02 )"
        "( 1365 5.9201e-02 )"
        "( 1370 5.9305e-02 )"
        "( 1375 5.9407e-02 )"
        "( 1380 5.9508e-02 )"
        "( 1385 5.9609e-02 )"
        "( 1390 5.9708e-02 )"
        "( 1395 5.9805e-02 )"
        "( 1400 5.9902e-02 )"
        "( 1405 5.9997e-02 )"
        "( 1410 6.0092e-02 )"
        "( 1415 6.0185e-02 )"
        "( 1420 6.0276e-02 )"
        "( 1425 6.0367e-02 )"
        "( 1430 6.0456e-02 )"
        "( 1435 6.0545e-02 )"
        "( 1440 6.0632e-02 )"
        "( 1445 6.0718e-02 )"
        "( 1450 6.0803e-02 )"
        "( 1455 6.0887e-02 )"
        "( 1460 6.0969e-02 )"
        "( 1465 6.1051e-02 )"
        "( 1470 6.1131e-02 )"
        "( 1475 6.1210e-02 )"
        "( 1480 6.1289e-02 )"
        "( 1485 6.1366e-02 )"
        "( 1490 6.1442e-02 )"
        "( 1495 6.1517e-02 )"
        "( 1500 6.1592e-02 )"
        "( 1505 6.1665e-02 )"
        "( 1510 6.1737e-02 )"
        "( 1515 6.1808e-02 )"
        "( 1520 6.1878e-02 )"
        "( 1525 6.1948e-02 )"
        "( 1530 6.2016e-02 )"
        "( 1535 6.2083e-02 )"
        "( 1540 6.2150e-02 )"
        "( 1545 6.2216e-02 )"
        "( 1550 6.2280e-02 )"
        "( 1555 6.2344e-02 )"
        "( 1560 6.2407e-02 )"
        "( 1565 6.2470e-02 )"
        "( 1570 6.2531e-02 )"
        "( 1575 6.2591e-02 )"
        "( 1580 6.2651e-02 )"
        "( 1585 6.2710e-02 )"
        "( 1590 6.2768e-02 )"
        "( 1595 6.2826e-02 )"
        "( 1600 6.2882e-02 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::
myTotalFlowRateAdvectiveDiffusiveCH2O
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::
myTotalFlowRateAdvectiveDiffusiveCH2O
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::
myTotalFlowRateAdvectiveDiffusiveCH2O
(
    const myTotalFlowRateAdvectiveDiffusiveCH2O& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::
myTotalFlowRateAdvectiveDiffusiveCH2O
(
    const myTotalFlowRateAdvectiveDiffusiveCH2O& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::
myTotalFlowRateAdvectiveDiffusiveCH2O
(
    const myTotalFlowRateAdvectiveDiffusiveCH2O& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH2O::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveCH2O
    );

}

// ************************************************************************* //
