
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 7.7831e-24 )"
        "(  280 4.7238e-23 )"
        "(  285 2.6916e-22 )"
        "(  290 1.4445e-21 )"
        "(  295 7.3236e-21 )"
        "(  300 3.5177e-20 )"
        "(  305 1.6049e-19 )"
        "(  310 6.9718e-19 )"
        "(  315 2.8903e-18 )"
        "(  320 1.1459e-17 )"
        "(  325 4.3532e-17 )"
        "(  330 1.5874e-16 )"
        "(  335 5.5658e-16 )"
        "(  340 1.8791e-15 )"
        "(  345 6.1176e-15 )"
        "(  350 1.9227e-14 )"
        "(  355 5.8404e-14 )"
        "(  360 1.7161e-13 )"
        "(  365 4.8819e-13 )"
        "(  370 1.3453e-12 )"
        "(  375 3.5932e-12 )"
        "(  380 9.3047e-12 )"
        "(  385 2.3366e-11 )"
        "(  390 5.6910e-11 )"
        "(  395 1.3443e-10 )"
        "(  400 3.0798e-10 )"
        "(  405 6.8429e-10 )"
        "(  410 1.4744e-09 )"
        "(  415 3.0810e-09 )"
        "(  420 6.2450e-09 )"
        "(  425 1.2282e-08 )"
        "(  430 2.3449e-08 )"
        "(  435 4.3488e-08 )"
        "(  440 7.8413e-08 )"
        "(  445 1.3760e-07 )"
        "(  450 2.3524e-07 )"
        "(  455 3.9235e-07 )"
        "(  460 6.3921e-07 )"
        "(  465 1.0187e-06 )"
        "(  470 1.5902e-06 )"
        "(  475 2.4351e-06 )"
        "(  480 3.6631e-06 )"
        "(  485 5.4205e-06 )"
        "(  490 7.9009e-06 )"
        "(  495 1.1358e-05 )"
        "(  500 1.6124e-05 )"
        "(  505 2.2627e-05 )"
        "(  510 3.1419e-05 )"
        "(  515 4.3206e-05 )"
        "(  520 5.8882e-05 )"
        "(  525 7.9572e-05 )"
        "(  530 1.0668e-04 )"
        "(  535 1.4195e-04 )"
        "(  540 1.8749e-04 )"
        "(  545 2.4589e-04 )"
        "(  550 3.2022e-04 )"
        "(  555 4.1412e-04 )"
        "(  560 5.3187e-04 )"
        "(  565 6.7834e-04 )"
        "(  570 8.5908e-04 )"
        "(  575 1.0802e-03 )"
        "(  580 1.3484e-03 )"
        "(  585 1.6707e-03 )"
        "(  590 2.0542e-03 )"
        "(  595 2.5061e-03 )"
        "(  600 3.0327e-03 )"
        "(  605 3.6399e-03 )"
        "(  610 4.3320e-03 )"
        "(  615 5.1118e-03 )"
        "(  620 5.9800e-03 )"
        "(  625 6.9356e-03 )"
        "(  630 7.9754e-03 )"
        "(  635 9.0942e-03 )"
        "(  640 1.0285e-02 )"
        "(  645 1.1540e-02 )"
        "(  650 1.2848e-02 )"
        "(  655 1.4197e-02 )"
        "(  660 1.5575e-02 )"
        "(  665 1.6963e-02 )"
        "(  670 1.8346e-02 )"
        "(  675 1.9704e-02 )"
        "(  680 2.1018e-02 )"
        "(  685 2.2269e-02 )"
        "(  690 2.3443e-02 )"
        "(  695 2.4525e-02 )"
        "(  700 2.5507e-02 )"
        "(  705 2.6382e-02 )"
        "(  710 2.7149e-02 )"
        "(  715 2.7807e-02 )"
        "(  720 2.8361e-02 )"
        "(  725 2.8815e-02 )"
        "(  730 2.9177e-02 )"
        "(  735 2.9453e-02 )"
        "(  740 2.9652e-02 )"
        "(  745 2.9782e-02 )"
        "(  750 2.9848e-02 )"
        "(  755 2.9859e-02 )"
        "(  760 2.9822e-02 )"
        "(  765 2.9744e-02 )"
        "(  770 2.9632e-02 )"
        "(  775 2.9497e-02 )"
        "(  780 2.9347e-02 )"
        "(  785 2.9191e-02 )"
        "(  790 2.9035e-02 )"
        "(  795 2.8885e-02 )"
        "(  800 2.8745e-02 )"
        "(  805 2.8617e-02 )"
        "(  810 2.8502e-02 )"
        "(  815 2.8399e-02 )"
        "(  820 2.8307e-02 )"
        "(  825 2.8225e-02 )"
        "(  830 2.8150e-02 )"
        "(  835 2.8081e-02 )"
        "(  840 2.8016e-02 )"
        "(  845 2.7954e-02 )"
        "(  850 2.7894e-02 )"
        "(  855 2.7835e-02 )"
        "(  860 2.7776e-02 )"
        "(  865 2.7717e-02 )"
        "(  870 2.7658e-02 )"
        "(  875 2.7598e-02 )"
        "(  880 2.7537e-02 )"
        "(  885 2.7475e-02 )"
        "(  890 2.7412e-02 )"
        "(  895 2.7349e-02 )"
        "(  900 2.7284e-02 )"
        "(  905 2.7220e-02 )"
        "(  910 2.7154e-02 )"
        "(  915 2.7088e-02 )"
        "(  920 2.7022e-02 )"
        "(  925 2.6957e-02 )"
        "(  930 2.6891e-02 )"
        "(  935 2.6825e-02 )"
        "(  940 2.6760e-02 )"
        "(  945 2.6695e-02 )"
        "(  950 2.6631e-02 )"
        "(  955 2.6567e-02 )"
        "(  960 2.6504e-02 )"
        "(  965 2.6441e-02 )"
        "(  970 2.6379e-02 )"
        "(  975 2.6316e-02 )"
        "(  980 2.6254e-02 )"
        "(  985 2.6192e-02 )"
        "(  990 2.6129e-02 )"
        "(  995 2.6066e-02 )"
        "( 1000 2.6002e-02 )"
        "( 1005 2.5937e-02 )"
        "( 1010 2.5871e-02 )"
        "( 1015 2.5804e-02 )"
        "( 1020 2.5734e-02 )"
        "( 1025 2.5663e-02 )"
        "( 1030 2.5589e-02 )"
        "( 1035 2.5512e-02 )"
        "( 1040 2.5431e-02 )"
        "( 1045 2.5347e-02 )"
        "( 1050 2.5259e-02 )"
        "( 1055 2.5166e-02 )"
        "( 1060 2.5068e-02 )"
        "( 1065 2.4966e-02 )"
        "( 1070 2.4858e-02 )"
        "( 1075 2.4744e-02 )"
        "( 1080 2.4626e-02 )"
        "( 1085 2.4503e-02 )"
        "( 1090 2.4376e-02 )"
        "( 1095 2.4245e-02 )"
        "( 1100 2.4111e-02 )"
        "( 1105 2.3976e-02 )"
        "( 1110 2.3839e-02 )"
        "( 1115 2.3703e-02 )"
        "( 1120 2.3568e-02 )"
        "( 1125 2.3436e-02 )"
        "( 1130 2.3305e-02 )"
        "( 1135 2.3178e-02 )"
        "( 1140 2.3055e-02 )"
        "( 1145 2.2934e-02 )"
        "( 1150 2.2817e-02 )"
        "( 1155 2.2703e-02 )"
        "( 1160 2.2591e-02 )"
        "( 1165 2.2482e-02 )"
        "( 1170 2.2376e-02 )"
        "( 1175 2.2274e-02 )"
        "( 1180 2.2174e-02 )"
        "( 1185 2.2078e-02 )"
        "( 1190 2.1986e-02 )"
        "( 1195 2.1899e-02 )"
        "( 1200 2.1817e-02 )"
        "( 1205 2.1740e-02 )"
        "( 1210 2.1669e-02 )"
        "( 1215 2.1602e-02 )"
        "( 1220 2.1541e-02 )"
        "( 1225 2.1485e-02 )"
        "( 1230 2.1434e-02 )"
        "( 1235 2.1387e-02 )"
        "( 1240 2.1344e-02 )"
        "( 1245 2.1304e-02 )"
        "( 1250 2.1267e-02 )"
        "( 1255 2.1233e-02 )"
        "( 1260 2.1201e-02 )"
        "( 1265 2.1172e-02 )"
        "( 1270 2.1144e-02 )"
        "( 1275 2.1118e-02 )"
        "( 1280 2.1093e-02 )"
        "( 1285 2.1070e-02 )"
        "( 1290 2.1048e-02 )"
        "( 1295 2.1026e-02 )"
        "( 1300 2.1006e-02 )"
        "( 1305 2.0987e-02 )"
        "( 1310 2.0968e-02 )"
        "( 1315 2.0950e-02 )"
        "( 1320 2.0932e-02 )"
        "( 1325 2.0915e-02 )"
        "( 1330 2.0899e-02 )"
        "( 1335 2.0883e-02 )"
        "( 1340 2.0868e-02 )"
        "( 1345 2.0852e-02 )"
        "( 1350 2.0837e-02 )"
        "( 1355 2.0823e-02 )"
        "( 1360 2.0809e-02 )"
        "( 1365 2.0795e-02 )"
        "( 1370 2.0781e-02 )"
        "( 1375 2.0767e-02 )"
        "( 1380 2.0754e-02 )"
        "( 1385 2.0741e-02 )"
        "( 1390 2.0728e-02 )"
        "( 1395 2.0715e-02 )"
        "( 1400 2.0703e-02 )"
        "( 1405 2.0690e-02 )"
        "( 1410 2.0678e-02 )"
        "( 1415 2.0666e-02 )"
        "( 1420 2.0654e-02 )"
        "( 1425 2.0642e-02 )"
        "( 1430 2.0630e-02 )"
        "( 1435 2.0618e-02 )"
        "( 1440 2.0607e-02 )"
        "( 1445 2.0596e-02 )"
        "( 1450 2.0584e-02 )"
        "( 1455 2.0573e-02 )"
        "( 1460 2.0562e-02 )"
        "( 1465 2.0551e-02 )"
        "( 1470 2.0540e-02 )"
        "( 1475 2.0529e-02 )"
        "( 1480 2.0518e-02 )"
        "( 1485 2.0508e-02 )"
        "( 1490 2.0497e-02 )"
        "( 1495 2.0487e-02 )"
        "( 1500 2.0476e-02 )"
        "( 1505 2.0466e-02 )"
        "( 1510 2.0456e-02 )"
        "( 1515 2.0445e-02 )"
        "( 1520 2.0435e-02 )"
        "( 1525 2.0425e-02 )"
        "( 1530 2.0415e-02 )"
        "( 1535 2.0405e-02 )"
        "( 1540 2.0395e-02 )"
        "( 1545 2.0386e-02 )"
        "( 1550 2.0376e-02 )"
        "( 1555 2.0366e-02 )"
        "( 1560 2.0357e-02 )"
        "( 1565 2.0347e-02 )"
        "( 1570 2.0338e-02 )"
        "( 1575 2.0329e-02 )"
        "( 1580 2.0319e-02 )"
        "( 1585 2.0310e-02 )"
        "( 1590 2.0301e-02 )"
        "( 1595 2.0292e-02 )"
        "( 1600 2.0283e-02 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveCH3CHOFvPatchScalarField
    );

}

// ************************************************************************* //
