
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 9.1089e-20 )"
        "(  280 3.9069e-19 )"
        "(  285 1.5928e-18 )"
        "(  290 6.1886e-18 )"
        "(  295 2.2973e-17 )"
        "(  300 8.1669e-17 )"
        "(  305 2.7863e-16 )"
        "(  310 9.1410e-16 )"
        "(  315 2.8893e-15 )"
        "(  320 8.8140e-15 )"
        "(  325 2.5992e-14 )"
        "(  330 7.4206e-14 )"
        "(  335 2.0539e-13 )"
        "(  340 5.5184e-13 )"
        "(  345 1.4409e-12 )"
        "(  350 3.6600e-12 )"
        "(  355 9.0525e-12 )"
        "(  360 2.1818e-11 )"
        "(  365 5.1276e-11 )"
        "(  370 1.1757e-10 )"
        "(  375 2.6310e-10 )"
        "(  380 5.7481e-10 )"
        "(  385 1.2262e-09 )"
        "(  390 2.5542e-09 )"
        "(  395 5.1952e-09 )"
        "(  400 1.0317e-08 )"
        "(  405 2.0001e-08 )"
        "(  410 3.7851e-08 )"
        "(  415 6.9923e-08 )"
        "(  420 1.2610e-07 )"
        "(  425 2.2205e-07 )"
        "(  430 3.8195e-07 )"
        "(  435 6.4209e-07 )"
        "(  440 1.0556e-06 )"
        "(  445 1.6986e-06 )"
        "(  450 2.6776e-06 )"
        "(  455 4.1389e-06 )"
        "(  460 6.2798e-06 )"
        "(  465 9.3622e-06 )"
        "(  470 1.3728e-05 )"
        "(  475 1.9819e-05 )"
        "(  480 2.8196e-05 )"
        "(  485 3.9570e-05 )"
        "(  490 5.4826e-05 )"
        "(  495 7.5062e-05 )"
        "(  500 1.0163e-04 )"
        "(  505 1.3618e-04 )"
        "(  510 1.8071e-04 )"
        "(  515 2.3766e-04 )"
        "(  520 3.0993e-04 )"
        "(  525 4.0102e-04 )"
        "(  530 5.1506e-04 )"
        "(  535 6.5694e-04 )"
        "(  540 8.3239e-04 )"
        "(  545 1.0481e-03 )"
        "(  550 1.3117e-03 )"
        "(  555 1.6320e-03 )"
        "(  560 2.0188e-03 )"
        "(  565 2.4831e-03 )"
        "(  570 3.0370e-03 )"
        "(  575 3.6932e-03 )"
        "(  580 4.4651e-03 )"
        "(  585 5.3664e-03 )"
        "(  590 6.4102e-03 )"
        "(  595 7.6089e-03 )"
        "(  600 8.9729e-03 )"
        "(  605 1.0510e-02 )"
        "(  610 1.2227e-02 )"
        "(  615 1.4123e-02 )"
        "(  620 1.6197e-02 )"
        "(  625 1.8442e-02 )"
        "(  630 2.0850e-02 )"
        "(  635 2.3408e-02 )"
        "(  640 2.6101e-02 )"
        "(  645 2.8912e-02 )"
        "(  650 3.1824e-02 )"
        "(  655 3.4814e-02 )"
        "(  660 3.7858e-02 )"
        "(  665 4.0927e-02 )"
        "(  670 4.3992e-02 )"
        "(  675 4.7019e-02 )"
        "(  680 4.9974e-02 )"
        "(  685 5.2829e-02 )"
        "(  690 5.5557e-02 )"
        "(  695 5.8139e-02 )"
        "(  700 6.0565e-02 )"
        "(  705 6.2829e-02 )"
        "(  710 6.4938e-02 )"
        "(  715 6.6900e-02 )"
        "(  720 6.8734e-02 )"
        "(  725 7.0461e-02 )"
        "(  730 7.2106e-02 )"
        "(  735 7.3697e-02 )"
        "(  740 7.5263e-02 )"
        "(  745 7.6830e-02 )"
        "(  750 7.8425e-02 )"
        "(  755 8.0072e-02 )"
        "(  760 8.1790e-02 )"
        "(  765 8.3595e-02 )"
        "(  770 8.5496e-02 )"
        "(  775 8.7493e-02 )"
        "(  780 8.9575e-02 )"
        "(  785 9.1717e-02 )"
        "(  790 9.3878e-02 )"
        "(  795 9.6004e-02 )"
        "(  800 9.8031e-02 )"
        "(  805 9.9897e-02 )"
        "(  810 1.0154e-01 )"
        "(  815 1.0293e-01 )"
        "(  820 1.0405e-01 )"
        "(  825 1.0490e-01 )"
        "(  830 1.0551e-01 )"
        "(  835 1.0590e-01 )"
        "(  840 1.0610e-01 )"
        "(  845 1.0615e-01 )"
        "(  850 1.0606e-01 )"
        "(  855 1.0586e-01 )"
        "(  860 1.0557e-01 )"
        "(  865 1.0519e-01 )"
        "(  870 1.0475e-01 )"
        "(  875 1.0424e-01 )"
        "(  880 1.0367e-01 )"
        "(  885 1.0307e-01 )"
        "(  890 1.0242e-01 )"
        "(  895 1.0173e-01 )"
        "(  900 1.0102e-01 )"
        "(  905 1.0028e-01 )"
        "(  910 9.9513e-02 )"
        "(  915 9.8731e-02 )"
        "(  920 9.7933e-02 )"
        "(  925 9.7123e-02 )"
        "(  930 9.6302e-02 )"
        "(  935 9.5473e-02 )"
        "(  940 9.4638e-02 )"
        "(  945 9.3798e-02 )"
        "(  950 9.2955e-02 )"
        "(  955 9.2110e-02 )"
        "(  960 9.1264e-02 )"
        "(  965 9.0418e-02 )"
        "(  970 8.9573e-02 )"
        "(  975 8.8728e-02 )"
        "(  980 8.7885e-02 )"
        "(  985 8.7044e-02 )"
        "(  990 8.6204e-02 )"
        "(  995 8.5366e-02 )"
        "( 1000 8.4530e-02 )"
        "( 1005 8.3694e-02 )"
        "( 1010 8.2860e-02 )"
        "( 1015 8.2026e-02 )"
        "( 1020 8.1193e-02 )"
        "( 1025 8.0359e-02 )"
        "( 1030 7.9523e-02 )"
        "( 1035 7.8686e-02 )"
        "( 1040 7.7845e-02 )"
        "( 1045 7.7002e-02 )"
        "( 1050 7.6154e-02 )"
        "( 1055 7.5301e-02 )"
        "( 1060 7.4443e-02 )"
        "( 1065 7.3580e-02 )"
        "( 1070 7.2711e-02 )"
        "( 1075 7.1837e-02 )"
        "( 1080 7.0959e-02 )"
        "( 1085 7.0078e-02 )"
        "( 1090 6.9195e-02 )"
        "( 1095 6.8314e-02 )"
        "( 1100 6.7435e-02 )"
        "( 1105 6.6563e-02 )"
        "( 1110 6.5700e-02 )"
        "( 1115 6.4849e-02 )"
        "( 1120 6.4013e-02 )"
        "( 1125 6.3193e-02 )"
        "( 1130 6.2391e-02 )"
        "( 1135 6.1609e-02 )"
        "( 1140 6.0845e-02 )"
        "( 1145 6.0101e-02 )"
        "( 1150 5.9374e-02 )"
        "( 1155 5.8665e-02 )"
        "( 1160 5.7973e-02 )"
        "( 1165 5.7298e-02 )"
        "( 1170 5.6639e-02 )"
        "( 1175 5.5996e-02 )"
        "( 1180 5.5371e-02 )"
        "( 1185 5.4764e-02 )"
        "( 1190 5.4175e-02 )"
        "( 1195 5.3606e-02 )"
        "( 1200 5.3056e-02 )"
        "( 1205 5.2527e-02 )"
        "( 1210 5.2018e-02 )"
        "( 1215 5.1529e-02 )"
        "( 1220 5.1059e-02 )"
        "( 1225 5.0607e-02 )"
        "( 1230 5.0172e-02 )"
        "( 1235 4.9754e-02 )"
        "( 1240 4.9350e-02 )"
        "( 1245 4.8960e-02 )"
        "( 1250 4.8583e-02 )"
        "( 1255 4.8217e-02 )"
        "( 1260 4.7861e-02 )"
        "( 1265 4.7515e-02 )"
        "( 1270 4.7179e-02 )"
        "( 1275 4.6850e-02 )"
        "( 1280 4.6530e-02 )"
        "( 1285 4.6217e-02 )"
        "( 1290 4.5911e-02 )"
        "( 1295 4.5612e-02 )"
        "( 1300 4.5319e-02 )"
        "( 1305 4.5032e-02 )"
        "( 1310 4.4751e-02 )"
        "( 1315 4.4475e-02 )"
        "( 1320 4.4204e-02 )"
        "( 1325 4.3939e-02 )"
        "( 1330 4.3678e-02 )"
        "( 1335 4.3422e-02 )"
        "( 1340 4.3171e-02 )"
        "( 1345 4.2923e-02 )"
        "( 1350 4.2681e-02 )"
        "( 1355 4.2442e-02 )"
        "( 1360 4.2207e-02 )"
        "( 1365 4.1976e-02 )"
        "( 1370 4.1749e-02 )"
        "( 1375 4.1525e-02 )"
        "( 1380 4.1305e-02 )"
        "( 1385 4.1089e-02 )"
        "( 1390 4.0876e-02 )"
        "( 1395 4.0666e-02 )"
        "( 1400 4.0460e-02 )"
        "( 1405 4.0257e-02 )"
        "( 1410 4.0057e-02 )"
        "( 1415 3.9860e-02 )"
        "( 1420 3.9666e-02 )"
        "( 1425 3.9475e-02 )"
        "( 1430 3.9287e-02 )"
        "( 1435 3.9101e-02 )"
        "( 1440 3.8919e-02 )"
        "( 1445 3.8739e-02 )"
        "( 1450 3.8561e-02 )"
        "( 1455 3.8387e-02 )"
        "( 1460 3.8215e-02 )"
        "( 1465 3.8045e-02 )"
        "( 1470 3.7878e-02 )"
        "( 1475 3.7713e-02 )"
        "( 1480 3.7551e-02 )"
        "( 1485 3.7391e-02 )"
        "( 1490 3.7234e-02 )"
        "( 1495 3.7078e-02 )"
        "( 1500 3.6925e-02 )"
        "( 1505 3.6774e-02 )"
        "( 1510 3.6625e-02 )"
        "( 1515 3.6478e-02 )"
        "( 1520 3.6333e-02 )"
        "( 1525 3.6190e-02 )"
        "( 1530 3.6050e-02 )"
        "( 1535 3.5911e-02 )"
        "( 1540 3.5774e-02 )"
        "( 1545 3.5639e-02 )"
        "( 1550 3.5505e-02 )"
        "( 1555 3.5374e-02 )"
        "( 1560 3.5244e-02 )"
        "( 1565 3.5116e-02 )"
        "( 1570 3.4990e-02 )"
        "( 1575 3.4866e-02 )"
        "( 1580 3.4743e-02 )"
        "( 1585 3.4622e-02 )"
        "( 1590 3.4502e-02 )"
        "( 1595 3.4384e-02 )"
        "( 1600 3.4267e-02 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveCH3OHFvPatchScalarField
    );

}

// ************************************************************************* //
