
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 7.5200e-21 )"
        "(  280 3.2195e-20 )"
        "(  285 1.3098e-19 )"
        "(  290 5.0773e-19 )"
        "(  295 1.8798e-18 )"
        "(  300 6.6624e-18 )"
        "(  305 2.2653e-17 )"
        "(  310 7.4041e-17 )"
        "(  315 2.3306e-16 )"
        "(  320 7.0769e-16 )"
        "(  325 2.0764e-15 )"
        "(  330 5.8955e-15 )"
        "(  335 1.6220e-14 )"
        "(  340 4.3297e-14 )"
        "(  345 1.1226e-13 )"
        "(  350 2.8301e-13 )"
        "(  355 6.9436e-13 )"
        "(  360 1.6593e-12 )"
        "(  365 3.8644e-12 )"
        "(  370 8.7766e-12 )"
        "(  375 1.9446e-11 )"
        "(  380 4.2048e-11 )"
        "(  385 8.8748e-11 )"
        "(  390 1.8286e-10 )"
        "(  395 3.6782e-10 )"
        "(  400 7.2232e-10 )"
        "(  405 1.3849e-09 )"
        "(  410 2.5924e-09 )"
        "(  415 4.7387e-09 )"
        "(  420 8.4602e-09 )"
        "(  425 1.4759e-08 )"
        "(  430 2.5171e-08 )"
        "(  435 4.2000e-08 )"
        "(  440 6.8626e-08 )"
        "(  445 1.0991e-07 )"
        "(  450 1.7273e-07 )"
        "(  455 2.6668e-07 )"
        "(  460 4.0494e-07 )"
        "(  465 6.0545e-07 )"
        "(  470 8.9234e-07 )"
        "(  475 1.2978e-06 )"
        "(  480 1.8643e-06 )"
        "(  485 2.6476e-06 )"
        "(  490 3.7203e-06 )"
        "(  495 5.1761e-06 )"
        "(  500 7.1351e-06 )"
        "(  505 9.7503e-06 )"
        "(  510 1.3215e-05 )"
        "(  515 1.7772e-05 )"
        "(  520 2.3723e-05 )"
        "(  525 3.1441e-05 )"
        "(  530 4.1382e-05 )"
        "(  535 5.4100e-05 )"
        "(  540 7.0260e-05 )"
        "(  545 9.0657e-05 )"
        "(  550 1.1622e-04 )"
        "(  555 1.4804e-04 )"
        "(  560 1.8736e-04 )"
        "(  565 2.3558e-04 )"
        "(  570 2.9428e-04 )"
        "(  575 3.6517e-04 )"
        "(  580 4.5004e-04 )"
        "(  585 5.5080e-04 )"
        "(  590 6.6929e-04 )"
        "(  595 8.0732e-04 )"
        "(  600 9.6647e-04 )"
        "(  605 1.1481e-03 )"
        "(  610 1.3531e-03 )"
        "(  615 1.5819e-03 )"
        "(  620 1.8345e-03 )"
        "(  625 2.1105e-03 )"
        "(  630 2.4086e-03 )"
        "(  635 2.7275e-03 )"
        "(  640 3.0654e-03 )"
        "(  645 3.4200e-03 )"
        "(  650 3.7890e-03 )"
        "(  655 4.1693e-03 )"
        "(  660 4.5577e-03 )"
        "(  665 4.9505e-03 )"
        "(  670 5.3433e-03 )"
        "(  675 5.7316e-03 )"
        "(  680 6.1106e-03 )"
        "(  685 6.4761e-03 )"
        "(  690 6.8241e-03 )"
        "(  695 7.1513e-03 )"
        "(  700 7.4553e-03 )"
        "(  705 7.7345e-03 )"
        "(  710 7.9881e-03 )"
        "(  715 8.2162e-03 )"
        "(  720 8.4192e-03 )"
        "(  725 8.5981e-03 )"
        "(  730 8.7545e-03 )"
        "(  735 8.8897e-03 )"
        "(  740 9.0053e-03 )"
        "(  745 9.1026e-03 )"
        "(  750 9.1832e-03 )"
        "(  755 9.2481e-03 )"
        "(  760 9.2989e-03 )"
        "(  765 9.3371e-03 )"
        "(  770 9.3644e-03 )"
        "(  775 9.3829e-03 )"
        "(  780 9.3949e-03 )"
        "(  785 9.4026e-03 )"
        "(  790 9.4077e-03 )"
        "(  795 9.4119e-03 )"
        "(  800 9.4161e-03 )"
        "(  805 9.4205e-03 )"
        "(  810 9.4253e-03 )"
        "(  815 9.4301e-03 )"
        "(  820 9.4344e-03 )"
        "(  825 9.4375e-03 )"
        "(  830 9.4389e-03 )"
        "(  835 9.4377e-03 )"
        "(  840 9.4335e-03 )"
        "(  845 9.4258e-03 )"
        "(  850 9.4143e-03 )"
        "(  855 9.3987e-03 )"
        "(  860 9.3788e-03 )"
        "(  865 9.3547e-03 )"
        "(  870 9.3263e-03 )"
        "(  875 9.2938e-03 )"
        "(  880 9.2572e-03 )"
        "(  885 9.2168e-03 )"
        "(  890 9.1728e-03 )"
        "(  895 9.1255e-03 )"
        "(  900 9.0753e-03 )"
        "(  905 9.0225e-03 )"
        "(  910 8.9676e-03 )"
        "(  915 8.9110e-03 )"
        "(  920 8.8533e-03 )"
        "(  925 8.7949e-03 )"
        "(  930 8.7366e-03 )"
        "(  935 8.6791e-03 )"
        "(  940 8.6231e-03 )"
        "(  945 8.5694e-03 )"
        "(  950 8.5191e-03 )"
        "(  955 8.4732e-03 )"
        "(  960 8.4331e-03 )"
        "(  965 8.4001e-03 )"
        "(  970 8.3759e-03 )"
        "(  975 8.3624e-03 )"
        "(  980 8.3617e-03 )"
        "(  985 8.3762e-03 )"
        "(  990 8.4089e-03 )"
        "(  995 8.4627e-03 )"
        "( 1000 8.5414e-03 )"
        "( 1005 8.6490e-03 )"
        "( 1010 8.7900e-03 )"
        "( 1015 8.9693e-03 )"
        "( 1020 9.1926e-03 )"
        "( 1025 9.4657e-03 )"
        "( 1030 9.7950e-03 )"
        "( 1035 1.0187e-02 )"
        "( 1040 1.0649e-02 )"
        "( 1045 1.1188e-02 )"
        "( 1050 1.1810e-02 )"
        "( 1055 1.2520e-02 )"
        "( 1060 1.3325e-02 )"
        "( 1065 1.4227e-02 )"
        "( 1070 1.5227e-02 )"
        "( 1075 1.6324e-02 )"
        "( 1080 1.7513e-02 )"
        "( 1085 1.8785e-02 )"
        "( 1090 2.0129e-02 )"
        "( 1095 2.1527e-02 )"
        "( 1100 2.2959e-02 )"
        "( 1105 2.4402e-02 )"
        "( 1110 2.5829e-02 )"
        "( 1115 2.7215e-02 )"
        "( 1120 2.8536e-02 )"
        "( 1125 2.9769e-02 )"
        "( 1130 3.0897e-02 )"
        "( 1135 3.1910e-02 )"
        "( 1140 3.2801e-02 )"
        "( 1145 3.3572e-02 )"
        "( 1150 3.4228e-02 )"
        "( 1155 3.4779e-02 )"
        "( 1160 3.5235e-02 )"
        "( 1165 3.5608e-02 )"
        "( 1170 3.5910e-02 )"
        "( 1175 3.6151e-02 )"
        "( 1180 3.6342e-02 )"
        "( 1185 3.6491e-02 )"
        "( 1190 3.6605e-02 )"
        "( 1195 3.6691e-02 )"
        "( 1200 3.6755e-02 )"
        "( 1205 3.6801e-02 )"
        "( 1210 3.6833e-02 )"
        "( 1215 3.6855e-02 )"
        "( 1220 3.6869e-02 )"
        "( 1225 3.6877e-02 )"
        "( 1230 3.6880e-02 )"
        "( 1235 3.6880e-02 )"
        "( 1240 3.6877e-02 )"
        "( 1245 3.6871e-02 )"
        "( 1250 3.6864e-02 )"
        "( 1255 3.6855e-02 )"
        "( 1260 3.6845e-02 )"
        "( 1265 3.6833e-02 )"
        "( 1270 3.6821e-02 )"
        "( 1275 3.6809e-02 )"
        "( 1280 3.6795e-02 )"
        "( 1285 3.6782e-02 )"
        "( 1290 3.6768e-02 )"
        "( 1295 3.6754e-02 )"
        "( 1300 3.6740e-02 )"
        "( 1305 3.6725e-02 )"
        "( 1310 3.6711e-02 )"
        "( 1315 3.6697e-02 )"
        "( 1320 3.6683e-02 )"
        "( 1325 3.6669e-02 )"
        "( 1330 3.6655e-02 )"
        "( 1335 3.6641e-02 )"
        "( 1340 3.6628e-02 )"
        "( 1345 3.6615e-02 )"
        "( 1350 3.6602e-02 )"
        "( 1355 3.6589e-02 )"
        "( 1360 3.6577e-02 )"
        "( 1365 3.6565e-02 )"
        "( 1370 3.6553e-02 )"
        "( 1375 3.6541e-02 )"
        "( 1380 3.6530e-02 )"
        "( 1385 3.6519e-02 )"
        "( 1390 3.6509e-02 )"
        "( 1395 3.6498e-02 )"
        "( 1400 3.6488e-02 )"
        "( 1405 3.6479e-02 )"
        "( 1410 3.6469e-02 )"
        "( 1415 3.6460e-02 )"
        "( 1420 3.6452e-02 )"
        "( 1425 3.6443e-02 )"
        "( 1430 3.6435e-02 )"
        "( 1435 3.6427e-02 )"
        "( 1440 3.6419e-02 )"
        "( 1445 3.6412e-02 )"
        "( 1450 3.6405e-02 )"
        "( 1455 3.6398e-02 )"
        "( 1460 3.6392e-02 )"
        "( 1465 3.6386e-02 )"
        "( 1470 3.6380e-02 )"
        "( 1475 3.6374e-02 )"
        "( 1480 3.6368e-02 )"
        "( 1485 3.6363e-02 )"
        "( 1490 3.6358e-02 )"
        "( 1495 3.6354e-02 )"
        "( 1500 3.6349e-02 )"
        "( 1505 3.6345e-02 )"
        "( 1510 3.6341e-02 )"
        "( 1515 3.6337e-02 )"
        "( 1520 3.6334e-02 )"
        "( 1525 3.6330e-02 )"
        "( 1530 3.6327e-02 )"
        "( 1535 3.6324e-02 )"
        "( 1540 3.6321e-02 )"
        "( 1545 3.6319e-02 )"
        "( 1550 3.6316e-02 )"
        "( 1555 3.6314e-02 )"
        "( 1560 3.6312e-02 )"
        "( 1565 3.6311e-02 )"
        "( 1570 3.6309e-02 )"
        "( 1575 3.6307e-02 )"
        "( 1580 3.6306e-02 )"
        "( 1585 3.6305e-02 )"
        "( 1590 3.6304e-02 )"
        "( 1595 3.6303e-02 )"
        "( 1600 3.6303e-02 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveCH4FvPatchScalarField
    );

}

// ************************************************************************* //
