
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::interpTable
(
    IStringStream
    (
"("
        "(  275 1.0000e+00 )"
        "(  280 1.0000e+00 )"
        "(  285 1.0000e+00 )"
        "(  290 9.9999e-01 )"
        "(  295 9.9999e-01 )"
        "(  300 9.9999e-01 )"
        "(  305 9.9999e-01 )"
        "(  310 9.9999e-01 )"
        "(  315 9.9999e-01 )"
        "(  320 9.9998e-01 )"
        "(  325 9.9998e-01 )"
        "(  330 9.9998e-01 )"
        "(  335 9.9997e-01 )"
        "(  340 9.9996e-01 )"
        "(  345 9.9995e-01 )"
        "(  350 9.9994e-01 )"
        "(  355 9.9992e-01 )"
        "(  360 9.9990e-01 )"
        "(  365 9.9987e-01 )"
        "(  370 9.9982e-01 )"
        "(  375 9.9976e-01 )"
        "(  380 9.9968e-01 )"
        "(  385 9.9957e-01 )"
        "(  390 9.9943e-01 )"
        "(  395 9.9925e-01 )"
        "(  400 9.9901e-01 )"
        "(  405 9.9871e-01 )"
        "(  410 9.9834e-01 )"
        "(  415 9.9788e-01 )"
        "(  420 9.9733e-01 )"
        "(  425 9.9669e-01 )"
        "(  430 9.9594e-01 )"
        "(  435 9.9508e-01 )"
        "(  440 9.9413e-01 )"
        "(  445 9.9308e-01 )"
        "(  450 9.9195e-01 )"
        "(  455 9.9073e-01 )"
        "(  460 9.8946e-01 )"
        "(  465 9.8813e-01 )"
        "(  470 9.8677e-01 )"
        "(  475 9.8539e-01 )"
        "(  480 9.8400e-01 )"
        "(  485 9.8263e-01 )"
        "(  490 9.8127e-01 )"
        "(  495 9.7996e-01 )"
        "(  500 9.7869e-01 )"
        "(  505 9.7748e-01 )"
        "(  510 9.7633e-01 )"
        "(  515 9.7525e-01 )"
        "(  520 9.7425e-01 )"
        "(  525 9.7331e-01 )"
        "(  530 9.7246e-01 )"
        "(  535 9.7167e-01 )"
        "(  540 9.7095e-01 )"
        "(  545 9.7028e-01 )"
        "(  550 9.6967e-01 )"
        "(  555 9.6909e-01 )"
        "(  560 9.6854e-01 )"
        "(  565 9.6799e-01 )"
        "(  570 9.6744e-01 )"
        "(  575 9.6687e-01 )"
        "(  580 9.6625e-01 )"
        "(  585 9.6556e-01 )"
        "(  590 9.6479e-01 )"
        "(  595 9.6392e-01 )"
        "(  600 9.6293e-01 )"
        "(  605 9.6180e-01 )"
        "(  610 9.6053e-01 )"
        "(  615 9.5911e-01 )"
        "(  620 9.5753e-01 )"
        "(  625 9.5582e-01 )"
        "(  630 9.5397e-01 )"
        "(  635 9.5201e-01 )"
        "(  640 9.4995e-01 )"
        "(  645 9.4782e-01 )"
        "(  650 9.4562e-01 )"
        "(  655 9.4339e-01 )"
        "(  660 9.4114e-01 )"
        "(  665 9.3889e-01 )"
        "(  670 9.3665e-01 )"
        "(  675 9.3445e-01 )"
        "(  680 9.3229e-01 )"
        "(  685 9.3021e-01 )"
        "(  690 9.2820e-01 )"
        "(  695 9.2629e-01 )"
        "(  700 9.2448e-01 )"
        "(  705 9.2278e-01 )"
        "(  710 9.2121e-01 )"
        "(  715 9.1974e-01 )"
        "(  720 9.1840e-01 )"
        "(  725 9.1716e-01 )"
        "(  730 9.1604e-01 )"
        "(  735 9.1502e-01 )"
        "(  740 9.1410e-01 )"
        "(  745 9.1327e-01 )"
        "(  750 9.1254e-01 )"
        "(  755 9.1189e-01 )"
        "(  760 9.1132e-01 )"
        "(  765 9.1083e-01 )"
        "(  770 9.1038e-01 )"
        "(  775 9.0998e-01 )"
        "(  780 9.0960e-01 )"
        "(  785 9.0922e-01 )"
        "(  790 9.0883e-01 )"
        "(  795 9.0841e-01 )"
        "(  800 9.0795e-01 )"
        "(  805 9.0746e-01 )"
        "(  810 9.0693e-01 )"
        "(  815 9.0636e-01 )"
        "(  820 9.0575e-01 )"
        "(  825 9.0513e-01 )"
        "(  830 9.0449e-01 )"
        "(  835 9.0383e-01 )"
        "(  840 9.0318e-01 )"
        "(  845 9.0252e-01 )"
        "(  850 9.0187e-01 )"
        "(  855 9.0123e-01 )"
        "(  860 9.0060e-01 )"
        "(  865 8.9999e-01 )"
        "(  870 8.9939e-01 )"
        "(  875 8.9881e-01 )"
        "(  880 8.9824e-01 )"
        "(  885 8.9770e-01 )"
        "(  890 8.9718e-01 )"
        "(  895 8.9667e-01 )"
        "(  900 8.9619e-01 )"
        "(  905 8.9572e-01 )"
        "(  910 8.9528e-01 )"
        "(  915 8.9485e-01 )"
        "(  920 8.9444e-01 )"
        "(  925 8.9405e-01 )"
        "(  930 8.9368e-01 )"
        "(  935 8.9332e-01 )"
        "(  940 8.9298e-01 )"
        "(  945 8.9266e-01 )"
        "(  950 8.9235e-01 )"
        "(  955 8.9206e-01 )"
        "(  960 8.9179e-01 )"
        "(  965 8.9152e-01 )"
        "(  970 8.9128e-01 )"
        "(  975 8.9105e-01 )"
        "(  980 8.9083e-01 )"
        "(  985 8.9062e-01 )"
        "(  990 8.9044e-01 )"
        "(  995 8.9026e-01 )"
        "( 1000 8.9010e-01 )"
        "( 1005 8.8996e-01 )"
        "( 1010 8.8984e-01 )"
        "( 1015 8.8973e-01 )"
        "( 1020 8.8964e-01 )"
        "( 1025 8.8957e-01 )"
        "( 1030 8.8952e-01 )"
        "( 1035 8.8950e-01 )"
        "( 1040 8.8950e-01 )"
        "( 1045 8.8952e-01 )"
        "( 1050 8.8958e-01 )"
        "( 1055 8.8966e-01 )"
        "( 1060 8.8977e-01 )"
        "( 1065 8.8991e-01 )"
        "( 1070 8.9008e-01 )"
        "( 1075 8.9028e-01 )"
        "( 1080 8.9052e-01 )"
        "( 1085 8.9078e-01 )"
        "( 1090 8.9107e-01 )"
        "( 1095 8.9138e-01 )"
        "( 1100 8.9172e-01 )"
        "( 1105 8.9206e-01 )"
        "( 1110 8.9242e-01 )"
        "( 1115 8.9279e-01 )"
        "( 1120 8.9315e-01 )"
        "( 1125 8.9352e-01 )"
        "( 1130 8.9387e-01 )"
        "( 1135 8.9422e-01 )"
        "( 1140 8.9456e-01 )"
        "( 1145 8.9489e-01 )"
        "( 1150 8.9521e-01 )"
        "( 1155 8.9553e-01 )"
        "( 1160 8.9583e-01 )"
        "( 1165 8.9613e-01 )"
        "( 1170 8.9641e-01 )"
        "( 1175 8.9669e-01 )"
        "( 1180 8.9696e-01 )"
        "( 1185 8.9721e-01 )"
        "( 1190 8.9745e-01 )"
        "( 1195 8.9767e-01 )"
        "( 1200 8.9788e-01 )"
        "( 1205 8.9806e-01 )"
        "( 1210 8.9821e-01 )"
        "( 1215 8.9835e-01 )"
        "( 1220 8.9847e-01 )"
        "( 1225 8.9856e-01 )"
        "( 1230 8.9864e-01 )"
        "( 1235 8.9870e-01 )"
        "( 1240 8.9874e-01 )"
        "( 1245 8.9877e-01 )"
        "( 1250 8.9878e-01 )"
        "( 1255 8.9879e-01 )"
        "( 1260 8.9878e-01 )"
        "( 1265 8.9877e-01 )"
        "( 1270 8.9875e-01 )"
        "( 1275 8.9873e-01 )"
        "( 1280 8.9870e-01 )"
        "( 1285 8.9867e-01 )"
        "( 1290 8.9863e-01 )"
        "( 1295 8.9859e-01 )"
        "( 1300 8.9854e-01 )"
        "( 1305 8.9850e-01 )"
        "( 1310 8.9845e-01 )"
        "( 1315 8.9840e-01 )"
        "( 1320 8.9835e-01 )"
        "( 1325 8.9830e-01 )"
        "( 1330 8.9825e-01 )"
        "( 1335 8.9819e-01 )"
        "( 1340 8.9814e-01 )"
        "( 1345 8.9808e-01 )"
        "( 1350 8.9803e-01 )"
        "( 1355 8.9797e-01 )"
        "( 1360 8.9792e-01 )"
        "( 1365 8.9786e-01 )"
        "( 1370 8.9781e-01 )"
        "( 1375 8.9775e-01 )"
        "( 1380 8.9770e-01 )"
        "( 1385 8.9765e-01 )"
        "( 1390 8.9759e-01 )"
        "( 1395 8.9754e-01 )"
        "( 1400 8.9748e-01 )"
        "( 1405 8.9743e-01 )"
        "( 1410 8.9738e-01 )"
        "( 1415 8.9733e-01 )"
        "( 1420 8.9727e-01 )"
        "( 1425 8.9722e-01 )"
        "( 1430 8.9717e-01 )"
        "( 1435 8.9712e-01 )"
        "( 1440 8.9707e-01 )"
        "( 1445 8.9702e-01 )"
        "( 1450 8.9697e-01 )"
        "( 1455 8.9692e-01 )"
        "( 1460 8.9687e-01 )"
        "( 1465 8.9683e-01 )"
        "( 1470 8.9678e-01 )"
        "( 1475 8.9673e-01 )"
        "( 1480 8.9669e-01 )"
        "( 1485 8.9664e-01 )"
        "( 1490 8.9659e-01 )"
        "( 1495 8.9655e-01 )"
        "( 1500 8.9650e-01 )"
        "( 1505 8.9646e-01 )"
        "( 1510 8.9642e-01 )"
        "( 1515 8.9637e-01 )"
        "( 1520 8.9633e-01 )"
        "( 1525 8.9629e-01 )"
        "( 1530 8.9625e-01 )"
        "( 1535 8.9620e-01 )"
        "( 1540 8.9616e-01 )"
        "( 1545 8.9612e-01 )"
        "( 1550 8.9608e-01 )"
        "( 1555 8.9604e-01 )"
        "( 1560 8.9600e-01 )"
        "( 1565 8.9596e-01 )"
        "( 1570 8.9592e-01 )"
        "( 1575 8.9589e-01 )"
        "( 1580 8.9585e-01 )"
        "( 1585 8.9581e-01 )"
        "( 1590 8.9577e-01 )"
        "( 1595 8.9574e-01 )"
        "( 1600 8.9570e-01 )"
        ")"


    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveCH4H2OFvPatchScalarField
    );

}

// ************************************************************************* //
