
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 4.7550e-06 )"
        "(  280 5.8037e-06 )"
        "(  285 7.0342e-06 )"
        "(  290 8.4691e-06 )"
        "(  295 1.0132e-05 )"
        "(  300 1.2049e-05 )"
        "(  305 1.4247e-05 )"
        "(  310 1.6753e-05 )"
        "(  315 1.9597e-05 )"
        "(  320 2.2809e-05 )"
        "(  325 2.6420e-05 )"
        "(  330 3.0462e-05 )"
        "(  335 3.4971e-05 )"
        "(  340 3.9984e-05 )"
        "(  345 4.5544e-05 )"
        "(  350 5.1709e-05 )"
        "(  355 5.8551e-05 )"
        "(  360 6.6179e-05 )"
        "(  365 7.4753e-05 )"
        "(  370 8.4519e-05 )"
        "(  375 9.5845e-05 )"
        "(  380 1.0929e-04 )"
        "(  385 1.2565e-04 )"
        "(  390 1.4607e-04 )"
        "(  395 1.7212e-04 )"
        "(  400 2.0589e-04 )"
        "(  405 2.5002e-04 )"
        "(  410 3.0775e-04 )"
        "(  415 3.8284e-04 )"
        "(  420 4.7944e-04 )"
        "(  425 6.0190e-04 )"
        "(  430 7.5447e-04 )"
        "(  435 9.4098e-04 )"
        "(  440 1.1645e-03 )"
        "(  445 1.4272e-03 )"
        "(  450 1.7298e-03 )"
        "(  455 2.0720e-03 )"
        "(  460 2.4520e-03 )"
        "(  465 2.8668e-03 )"
        "(  470 3.3124e-03 )"
        "(  475 3.7839e-03 )"
        "(  480 4.2758e-03 )"
        "(  485 4.7827e-03 )"
        "(  490 5.2989e-03 )"
        "(  495 5.8195e-03 )"
        "(  500 6.3403e-03 )"
        "(  505 6.8583e-03 )"
        "(  510 7.3717e-03 )"
        "(  515 7.8806e-03 )"
        "(  520 8.3866e-03 )"
        "(  525 8.8936e-03 )"
        "(  530 9.4072e-03 )"
        "(  535 9.9354e-03 )"
        "(  540 1.0488e-02 )"
        "(  545 1.1078e-02 )"
        "(  550 1.1719e-02 )"
        "(  555 1.2429e-02 )"
        "(  560 1.3226e-02 )"
        "(  565 1.4130e-02 )"
        "(  570 1.5164e-02 )"
        "(  575 1.6351e-02 )"
        "(  580 1.7714e-02 )"
        "(  585 1.9277e-02 )"
        "(  590 2.1062e-02 )"
        "(  595 2.3084e-02 )"
        "(  600 2.5359e-02 )"
        "(  605 2.7892e-02 )"
        "(  610 3.0683e-02 )"
        "(  615 3.3721e-02 )"
        "(  620 3.6987e-02 )"
        "(  625 4.0454e-02 )"
        "(  630 4.4088e-02 )"
        "(  635 4.7850e-02 )"
        "(  640 5.1700e-02 )"
        "(  645 5.5598e-02 )"
        "(  650 5.9509e-02 )"
        "(  655 6.3402e-02 )"
        "(  660 6.7253e-02 )"
        "(  665 7.1042e-02 )"
        "(  670 7.4752e-02 )"
        "(  675 7.8371e-02 )"
        "(  680 8.1887e-02 )"
        "(  685 8.5295e-02 )"
        "(  690 8.8590e-02 )"
        "(  695 9.1777e-02 )"
        "(  700 9.4864e-02 )"
        "(  705 9.7871e-02 )"
        "(  710 1.0083e-01 )"
        "(  715 1.0376e-01 )"
        "(  720 1.0673e-01 )"
        "(  725 1.0978e-01 )"
        "(  730 1.1296e-01 )"
        "(  735 1.1632e-01 )"
        "(  740 1.1992e-01 )"
        "(  745 1.2378e-01 )"
        "(  750 1.2793e-01 )"
        "(  755 1.3234e-01 )"
        "(  760 1.3697e-01 )"
        "(  765 1.4174e-01 )"
        "(  770 1.4652e-01 )"
        "(  775 1.5120e-01 )"
        "(  780 1.5562e-01 )"
        "(  785 1.5965e-01 )"
        "(  790 1.6320e-01 )"
        "(  795 1.6622e-01 )"
        "(  800 1.6872e-01 )"
        "(  805 1.7074e-01 )"
        "(  810 1.7236e-01 )"
        "(  815 1.7364e-01 )"
        "(  820 1.7465e-01 )"
        "(  825 1.7544e-01 )"
        "(  830 1.7604e-01 )"
        "(  835 1.7648e-01 )"
        "(  840 1.7678e-01 )"
        "(  845 1.7697e-01 )"
        "(  850 1.7704e-01 )"
        "(  855 1.7701e-01 )"
        "(  860 1.7689e-01 )"
        "(  865 1.7670e-01 )"
        "(  870 1.7642e-01 )"
        "(  875 1.7608e-01 )"
        "(  880 1.7568e-01 )"
        "(  885 1.7522e-01 )"
        "(  890 1.7471e-01 )"
        "(  895 1.7415e-01 )"
        "(  900 1.7354e-01 )"
        "(  905 1.7289e-01 )"
        "(  910 1.7221e-01 )"
        "(  915 1.7149e-01 )"
        "(  920 1.7074e-01 )"
        "(  925 1.6996e-01 )"
        "(  930 1.6916e-01 )"
        "(  935 1.6833e-01 )"
        "(  940 1.6748e-01 )"
        "(  945 1.6662e-01 )"
        "(  950 1.6573e-01 )"
        "(  955 1.6483e-01 )"
        "(  960 1.6392e-01 )"
        "(  965 1.6300e-01 )"
        "(  970 1.6207e-01 )"
        "(  975 1.6114e-01 )"
        "(  980 1.6019e-01 )"
        "(  985 1.5924e-01 )"
        "(  990 1.5829e-01 )"
        "(  995 1.5733e-01 )"
        "( 1000 1.5638e-01 )"
        "( 1005 1.5542e-01 )"
        "( 1010 1.5447e-01 )"
        "( 1015 1.5352e-01 )"
        "( 1020 1.5257e-01 )"
        "( 1025 1.5162e-01 )"
        "( 1030 1.5068e-01 )"
        "( 1035 1.4975e-01 )"
        "( 1040 1.4883e-01 )"
        "( 1045 1.4792e-01 )"
        "( 1050 1.4703e-01 )"
        "( 1055 1.4615e-01 )"
        "( 1060 1.4530e-01 )"
        "( 1065 1.4447e-01 )"
        "( 1070 1.4367e-01 )"
        "( 1075 1.4291e-01 )"
        "( 1080 1.4219e-01 )"
        "( 1085 1.4154e-01 )"
        "( 1090 1.4095e-01 )"
        "( 1095 1.4043e-01 )"
        "( 1100 1.4001e-01 )"
        "( 1105 1.3969e-01 )"
        "( 1110 1.3949e-01 )"
        "( 1115 1.3942e-01 )"
        "( 1120 1.3950e-01 )"
        "( 1125 1.3972e-01 )"
        "( 1130 1.4010e-01 )"
        "( 1135 1.4065e-01 )"
        "( 1140 1.4136e-01 )"
        "( 1145 1.4222e-01 )"
        "( 1150 1.4324e-01 )"
        "( 1155 1.4438e-01 )"
        "( 1160 1.4565e-01 )"
        "( 1165 1.4700e-01 )"
        "( 1170 1.4843e-01 )"
        "( 1175 1.4990e-01 )"
        "( 1180 1.5138e-01 )"
        "( 1185 1.5285e-01 )"
        "( 1190 1.5427e-01 )"
        "( 1195 1.5562e-01 )"
        "( 1200 1.5687e-01 )"
        "( 1205 1.5801e-01 )"
        "( 1210 1.5902e-01 )"
        "( 1215 1.5989e-01 )"
        "( 1220 1.6064e-01 )"
        "( 1225 1.6124e-01 )"
        "( 1230 1.6173e-01 )"
        "( 1235 1.6210e-01 )"
        "( 1240 1.6237e-01 )"
        "( 1245 1.6254e-01 )"
        "( 1250 1.6264e-01 )"
        "( 1255 1.6266e-01 )"
        "( 1260 1.6263e-01 )"
        "( 1265 1.6255e-01 )"
        "( 1270 1.6242e-01 )"
        "( 1275 1.6225e-01 )"
        "( 1280 1.6206e-01 )"
        "( 1285 1.6184e-01 )"
        "( 1290 1.6159e-01 )"
        "( 1295 1.6133e-01 )"
        "( 1300 1.6105e-01 )"
        "( 1305 1.6075e-01 )"
        "( 1310 1.6045e-01 )"
        "( 1315 1.6014e-01 )"
        "( 1320 1.5982e-01 )"
        "( 1325 1.5949e-01 )"
        "( 1330 1.5916e-01 )"
        "( 1335 1.5883e-01 )"
        "( 1340 1.5850e-01 )"
        "( 1345 1.5816e-01 )"
        "( 1350 1.5783e-01 )"
        "( 1355 1.5749e-01 )"
        "( 1360 1.5716e-01 )"
        "( 1365 1.5683e-01 )"
        "( 1370 1.5650e-01 )"
        "( 1375 1.5618e-01 )"
        "( 1380 1.5585e-01 )"
        "( 1385 1.5553e-01 )"
        "( 1390 1.5522e-01 )"
        "( 1395 1.5490e-01 )"
        "( 1400 1.5459e-01 )"
        "( 1405 1.5429e-01 )"
        "( 1410 1.5398e-01 )"
        "( 1415 1.5369e-01 )"
        "( 1420 1.5339e-01 )"
        "( 1425 1.5310e-01 )"
        "( 1430 1.5282e-01 )"
        "( 1435 1.5254e-01 )"
        "( 1440 1.5226e-01 )"
        "( 1445 1.5199e-01 )"
        "( 1450 1.5172e-01 )"
        "( 1455 1.5145e-01 )"
        "( 1460 1.5119e-01 )"
        "( 1465 1.5094e-01 )"
        "( 1470 1.5069e-01 )"
        "( 1475 1.5044e-01 )"
        "( 1480 1.5019e-01 )"
        "( 1485 1.4995e-01 )"
        "( 1490 1.4972e-01 )"
        "( 1495 1.4949e-01 )"
        "( 1500 1.4926e-01 )"
        "( 1505 1.4903e-01 )"
        "( 1510 1.4881e-01 )"
        "( 1515 1.4860e-01 )"
        "( 1520 1.4838e-01 )"
        "( 1525 1.4817e-01 )"
        "( 1530 1.4797e-01 )"
        "( 1535 1.4777e-01 )"
        "( 1540 1.4757e-01 )"
        "( 1545 1.4737e-01 )"
        "( 1550 1.4718e-01 )"
        "( 1555 1.4699e-01 )"
        "( 1560 1.4681e-01 )"
        "( 1565 1.4662e-01 )"
        "( 1570 1.4644e-01 )"
        "( 1575 1.4627e-01 )"
        "( 1580 1.4610e-01 )"
        "( 1585 1.4593e-01 )"
        "( 1590 1.4576e-01 )"
        "( 1595 1.4559e-01 )"
        "( 1600 1.4543e-01 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveCOFvPatchScalarField
    );

}

// ************************************************************************* //
