
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 5.7559e-05 )"
        "(  280 9.2445e-05 )"
        "(  285 1.4602e-04 )"
        "(  290 2.2704e-04 )"
        "(  295 3.4775e-04 )"
        "(  300 5.2510e-04 )"
        "(  305 7.8217e-04 )"
        "(  310 1.1501e-03 )"
        "(  315 1.6702e-03 )"
        "(  320 2.3970e-03 )"
        "(  325 3.4009e-03 )"
        "(  330 4.7726e-03 )"
        "(  335 6.6266e-03 )"
        "(  340 9.1063e-03 )"
        "(  345 1.2388e-02 )"
        "(  350 1.6687e-02 )"
        "(  355 2.2258e-02 )"
        "(  360 2.9400e-02 )"
        "(  365 3.8453e-02 )"
        "(  370 4.9796e-02 )"
        "(  375 6.3830e-02 )"
        "(  380 8.0964e-02 )"
        "(  385 1.0159e-01 )"
        "(  390 1.2603e-01 )"
        "(  395 1.5451e-01 )"
        "(  400 1.8713e-01 )"
        "(  405 2.2375e-01 )"
        "(  410 2.6404e-01 )"
        "(  415 3.0741e-01 )"
        "(  420 3.5307e-01 )"
        "(  425 4.0002e-01 )"
        "(  430 4.4717e-01 )"
        "(  435 4.9339e-01 )"
        "(  440 5.3761e-01 )"
        "(  445 5.7890e-01 )"
        "(  450 6.1652e-01 )"
        "(  455 6.4992e-01 )"
        "(  460 6.7879e-01 )"
        "(  465 7.0299e-01 )"
        "(  470 7.2257e-01 )"
        "(  475 7.3768e-01 )"
        "(  480 7.4859e-01 )"
        "(  485 7.5559e-01 )"
        "(  490 7.5903e-01 )"
        "(  495 7.5925e-01 )"
        "(  500 7.5659e-01 )"
        "(  505 7.5135e-01 )"
        "(  510 7.4383e-01 )"
        "(  515 7.3427e-01 )"
        "(  520 7.2291e-01 )"
        "(  525 7.0994e-01 )"
        "(  530 6.9552e-01 )"
        "(  535 6.7981e-01 )"
        "(  540 6.6293e-01 )"
        "(  545 6.4499e-01 )"
        "(  550 6.2609e-01 )"
        "(  555 6.0633e-01 )"
        "(  560 5.8579e-01 )"
        "(  565 5.6455e-01 )"
        "(  570 5.4270e-01 )"
        "(  575 5.2033e-01 )"
        "(  580 4.9752e-01 )"
        "(  585 4.7439e-01 )"
        "(  590 4.5104e-01 )"
        "(  595 4.2760e-01 )"
        "(  600 4.0421e-01 )"
        "(  605 3.8103e-01 )"
        "(  610 3.5822e-01 )"
        "(  615 3.3594e-01 )"
        "(  620 3.1435e-01 )"
        "(  625 2.9362e-01 )"
        "(  630 2.7388e-01 )"
        "(  635 2.5522e-01 )"
        "(  640 2.3773e-01 )"
        "(  645 2.2143e-01 )"
        "(  650 2.0633e-01 )"
        "(  655 1.9242e-01 )"
        "(  660 1.7963e-01 )"
        "(  665 1.6793e-01 )"
        "(  670 1.5725e-01 )"
        "(  675 1.4754e-01 )"
        "(  680 1.3876e-01 )"
        "(  685 1.3085e-01 )"
        "(  690 1.2377e-01 )"
        "(  695 1.1747e-01 )"
        "(  700 1.1189e-01 )"
        "(  705 1.0698e-01 )"
        "(  710 1.0266e-01 )"
        "(  715 9.8877e-02 )"
        "(  720 9.5551e-02 )"
        "(  725 9.2613e-02 )"
        "(  730 8.9999e-02 )"
        "(  735 8.7645e-02 )"
        "(  740 8.5499e-02 )"
        "(  745 8.3515e-02 )"
        "(  750 8.1657e-02 )"
        "(  755 7.9900e-02 )"
        "(  760 7.8227e-02 )"
        "(  765 7.6629e-02 )"
        "(  770 7.5105e-02 )"
        "(  775 7.3657e-02 )"
        "(  780 7.2292e-02 )"
        "(  785 7.1018e-02 )"
        "(  790 6.9841e-02 )"
        "(  795 6.8764e-02 )"
        "(  800 6.7786e-02 )"
        "(  805 6.6906e-02 )"
        "(  810 6.6118e-02 )"
        "(  815 6.5415e-02 )"
        "(  820 6.4789e-02 )"
        "(  825 6.4233e-02 )"
        "(  830 6.3739e-02 )"
        "(  835 6.3301e-02 )"
        "(  840 6.2912e-02 )"
        "(  845 6.2566e-02 )"
        "(  850 6.2259e-02 )"
        "(  855 6.1988e-02 )"
        "(  860 6.1749e-02 )"
        "(  865 6.1539e-02 )"
        "(  870 6.1356e-02 )"
        "(  875 6.1198e-02 )"
        "(  880 6.1063e-02 )"
        "(  885 6.0951e-02 )"
        "(  890 6.0860e-02 )"
        "(  895 6.0788e-02 )"
        "(  900 6.0735e-02 )"
        "(  905 6.0700e-02 )"
        "(  910 6.0682e-02 )"
        "(  915 6.0681e-02 )"
        "(  920 6.0695e-02 )"
        "(  925 6.0725e-02 )"
        "(  930 6.0769e-02 )"
        "(  935 6.0827e-02 )"
        "(  940 6.0898e-02 )"
        "(  945 6.0982e-02 )"
        "(  950 6.1078e-02 )"
        "(  955 6.1184e-02 )"
        "(  960 6.1301e-02 )"
        "(  965 6.1428e-02 )"
        "(  970 6.1562e-02 )"
        "(  975 6.1705e-02 )"
        "(  980 6.1854e-02 )"
        "(  985 6.2008e-02 )"
        "(  990 6.2167e-02 )"
        "(  995 6.2330e-02 )"
        "( 1000 6.2495e-02 )"
        "( 1005 6.2661e-02 )"
        "( 1010 6.2827e-02 )"
        "( 1015 6.2992e-02 )"
        "( 1020 6.3155e-02 )"
        "( 1025 6.3313e-02 )"
        "( 1030 6.3466e-02 )"
        "( 1035 6.3612e-02 )"
        "( 1040 6.3750e-02 )"
        "( 1045 6.3878e-02 )"
        "( 1050 6.3995e-02 )"
        "( 1055 6.4099e-02 )"
        "( 1060 6.4188e-02 )"
        "( 1065 6.4263e-02 )"
        "( 1070 6.4322e-02 )"
        "( 1075 6.4364e-02 )"
        "( 1080 6.4390e-02 )"
        "( 1085 6.4400e-02 )"
        "( 1090 6.4394e-02 )"
        "( 1095 6.4375e-02 )"
        "( 1100 6.4343e-02 )"
        "( 1105 6.4302e-02 )"
        "( 1110 6.4255e-02 )"
        "( 1115 6.4202e-02 )"
        "( 1120 6.4149e-02 )"
        "( 1125 6.4095e-02 )"
        "( 1130 6.4044e-02 )"
        "( 1135 6.3996e-02 )"
        "( 1140 6.3952e-02 )"
        "( 1145 6.3912e-02 )"
        "( 1150 6.3876e-02 )"
        "( 1155 6.3843e-02 )"
        "( 1160 6.3812e-02 )"
        "( 1165 6.3785e-02 )"
        "( 1170 6.3761e-02 )"
        "( 1175 6.3740e-02 )"
        "( 1180 6.3724e-02 )"
        "( 1185 6.3714e-02 )"
        "( 1190 6.3712e-02 )"
        "( 1195 6.3718e-02 )"
        "( 1200 6.3734e-02 )"
        "( 1205 6.3761e-02 )"
        "( 1210 6.3800e-02 )"
        "( 1215 6.3850e-02 )"
        "( 1220 6.3912e-02 )"
        "( 1225 6.3985e-02 )"
        "( 1230 6.4068e-02 )"
        "( 1235 6.4160e-02 )"
        "( 1240 6.4260e-02 )"
        "( 1245 6.4367e-02 )"
        "( 1250 6.4480e-02 )"
        "( 1255 6.4598e-02 )"
        "( 1260 6.4720e-02 )"
        "( 1265 6.4846e-02 )"
        "( 1270 6.4974e-02 )"
        "( 1275 6.5104e-02 )"
        "( 1280 6.5235e-02 )"
        "( 1285 6.5368e-02 )"
        "( 1290 6.5501e-02 )"
        "( 1295 6.5635e-02 )"
        "( 1300 6.5769e-02 )"
        "( 1305 6.5902e-02 )"
        "( 1310 6.6036e-02 )"
        "( 1315 6.6168e-02 )"
        "( 1320 6.6301e-02 )"
        "( 1325 6.6432e-02 )"
        "( 1330 6.6562e-02 )"
        "( 1335 6.6691e-02 )"
        "( 1340 6.6819e-02 )"
        "( 1345 6.6946e-02 )"
        "( 1350 6.7071e-02 )"
        "( 1355 6.7195e-02 )"
        "( 1360 6.7317e-02 )"
        "( 1365 6.7438e-02 )"
        "( 1370 6.7558e-02 )"
        "( 1375 6.7676e-02 )"
        "( 1380 6.7792e-02 )"
        "( 1385 6.7907e-02 )"
        "( 1390 6.8020e-02 )"
        "( 1395 6.8132e-02 )"
        "( 1400 6.8242e-02 )"
        "( 1405 6.8351e-02 )"
        "( 1410 6.8458e-02 )"
        "( 1415 6.8563e-02 )"
        "( 1420 6.8667e-02 )"
        "( 1425 6.8769e-02 )"
        "( 1430 6.8870e-02 )"
        "( 1435 6.8969e-02 )"
        "( 1440 6.9067e-02 )"
        "( 1445 6.9163e-02 )"
        "( 1450 6.9258e-02 )"
        "( 1455 6.9351e-02 )"
        "( 1460 6.9443e-02 )"
        "( 1465 6.9533e-02 )"
        "( 1470 6.9622e-02 )"
        "( 1475 6.9710e-02 )"
        "( 1480 6.9796e-02 )"
        "( 1485 6.9881e-02 )"
        "( 1490 6.9964e-02 )"
        "( 1495 7.0046e-02 )"
        "( 1500 7.0127e-02 )"
        "( 1505 7.0206e-02 )"
        "( 1510 7.0284e-02 )"
        "( 1515 7.0361e-02 )"
        "( 1520 7.0437e-02 )"
        "( 1525 7.0511e-02 )"
        "( 1530 7.0584e-02 )"
        "( 1535 7.0656e-02 )"
        "( 1540 7.0727e-02 )"
        "( 1545 7.0797e-02 )"
        "( 1550 7.0865e-02 )"
        "( 1555 7.0933e-02 )"
        "( 1560 7.0999e-02 )"
        "( 1565 7.1064e-02 )"
        "( 1570 7.1128e-02 )"
        "( 1575 7.1191e-02 )"
        "( 1580 7.1253e-02 )"
        "( 1585 7.1314e-02 )"
        "( 1590 7.1374e-02 )"
        "( 1595 7.1433e-02 )"
        "( 1600 7.1491e-02 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveCO2FvPatchScalarField
    );

}

// ************************************************************************* //
