
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 1.6939e-25 )"
        "(  280 1.0252e-24 )"
        "(  285 5.8247e-24 )"
        "(  290 3.1167e-23 )"
        "(  295 1.5754e-22 )"
        "(  300 7.5432e-22 )"
        "(  305 3.4305e-21 )"
        "(  310 1.4853e-20 )"
        "(  315 6.1371e-20 )"
        "(  320 2.4248e-19 )"
        "(  325 9.1791e-19 )"
        "(  330 3.3352e-18 )"
        "(  335 1.1650e-17 )"
        "(  340 3.9185e-17 )"
        "(  345 1.2707e-16 )"
        "(  350 3.9778e-16 )"
        "(  355 1.2033e-15 )"
        "(  360 3.5208e-15 )"
        "(  365 9.9716e-15 )"
        "(  370 2.7354e-14 )"
        "(  375 7.2713e-14 )"
        "(  380 1.8736e-13 )"
        "(  385 4.6807e-13 )"
        "(  390 1.1338e-12 )"
        "(  395 2.6629e-12 )"
        "(  400 6.0633e-12 )"
        "(  405 1.3384e-11 )"
        "(  410 2.8635e-11 )"
        "(  415 5.9386e-11 )"
        "(  420 1.1939e-10 )"
        "(  425 2.3271e-10 )"
        "(  430 4.3998e-10 )"
        "(  435 8.0728e-10 )"
        "(  440 1.4385e-09 )"
        "(  445 2.4916e-09 )"
        "(  450 4.1991e-09 )"
        "(  455 6.8927e-09 )"
        "(  460 1.1033e-08 )"
        "(  465 1.7242e-08 )"
        "(  470 2.6340e-08 )"
        "(  475 3.9383e-08 )"
        "(  480 5.7705e-08 )"
        "(  485 8.2963e-08 )"
        "(  490 1.1718e-07 )"
        "(  495 1.6279e-07 )"
        "(  500 2.2270e-07 )"
        "(  505 3.0036e-07 )"
        "(  510 3.9975e-07 )"
        "(  515 5.2553e-07 )"
        "(  520 6.8300e-07 )"
        "(  525 8.7816e-07 )"
        "(  530 1.1177e-06 )"
        "(  535 1.4090e-06 )"
        "(  540 1.7600e-06 )"
        "(  545 2.1791e-06 )"
        "(  550 2.6750e-06 )"
        "(  555 3.2564e-06 )"
        "(  560 3.9317e-06 )"
        "(  565 4.7086e-06 )"
        "(  570 5.5936e-06 )"
        "(  575 6.5916e-06 )"
        "(  580 7.7050e-06 )"
        "(  585 8.9332e-06 )"
        "(  590 1.0272e-05 )"
        "(  595 1.1715e-05 )"
        "(  600 1.3248e-05 )"
        "(  605 1.4857e-05 )"
        "(  610 1.6522e-05 )"
        "(  615 1.8221e-05 )"
        "(  620 1.9931e-05 )"
        "(  625 2.1631e-05 )"
        "(  630 2.3300e-05 )"
        "(  635 2.4921e-05 )"
        "(  640 2.6483e-05 )"
        "(  645 2.7980e-05 )"
        "(  650 2.9408e-05 )"
        "(  655 3.0773e-05 )"
        "(  660 3.2079e-05 )"
        "(  665 3.3335e-05 )"
        "(  670 3.4554e-05 )"
        "(  675 3.5748e-05 )"
        "(  680 3.6935e-05 )"
        "(  685 3.8133e-05 )"
        "(  690 3.9364e-05 )"
        "(  695 4.0651e-05 )"
        "(  700 4.2017e-05 )"
        "(  705 4.3483e-05 )"
        "(  710 4.5068e-05 )"
        "(  715 4.6786e-05 )"
        "(  720 4.8647e-05 )"
        "(  725 5.0651e-05 )"
        "(  730 5.2797e-05 )"
        "(  735 5.5076e-05 )"
        "(  740 5.7476e-05 )"
        "(  745 5.9981e-05 )"
        "(  750 6.2578e-05 )"
        "(  755 6.5250e-05 )"
        "(  760 6.7987e-05 )"
        "(  765 7.0782e-05 )"
        "(  770 7.3631e-05 )"
        "(  775 7.6538e-05 )"
        "(  780 7.9508e-05 )"
        "(  785 8.2552e-05 )"
        "(  790 8.5681e-05 )"
        "(  795 8.8906e-05 )"
        "(  800 9.2233e-05 )"
        "(  805 9.5666e-05 )"
        "(  810 9.9206e-05 )"
        "(  815 1.0285e-04 )"
        "(  820 1.0659e-04 )"
        "(  825 1.1043e-04 )"
        "(  830 1.1434e-04 )"
        "(  835 1.1834e-04 )"
        "(  840 1.2239e-04 )"
        "(  845 1.2651e-04 )"
        "(  850 1.3067e-04 )"
        "(  855 1.3487e-04 )"
        "(  860 1.3910e-04 )"
        "(  865 1.4336e-04 )"
        "(  870 1.4764e-04 )"
        "(  875 1.5194e-04 )"
        "(  880 1.5625e-04 )"
        "(  885 1.6057e-04 )"
        "(  890 1.6489e-04 )"
        "(  895 1.6922e-04 )"
        "(  900 1.7356e-04 )"
        "(  905 1.7790e-04 )"
        "(  910 1.8226e-04 )"
        "(  915 1.8662e-04 )"
        "(  920 1.9100e-04 )"
        "(  925 1.9540e-04 )"
        "(  930 1.9983e-04 )"
        "(  935 2.0430e-04 )"
        "(  940 2.0883e-04 )"
        "(  945 2.1342e-04 )"
        "(  950 2.1809e-04 )"
        "(  955 2.2287e-04 )"
        "(  960 2.2778e-04 )"
        "(  965 2.3284e-04 )"
        "(  970 2.3810e-04 )"
        "(  975 2.4358e-04 )"
        "(  980 2.4934e-04 )"
        "(  985 2.5542e-04 )"
        "(  990 2.6189e-04 )"
        "(  995 2.6882e-04 )"
        "( 1000 2.7629e-04 )"
        "( 1005 2.8440e-04 )"
        "( 1010 2.9324e-04 )"
        "( 1015 3.0295e-04 )"
        "( 1020 3.1366e-04 )"
        "( 1025 3.2553e-04 )"
        "( 1030 3.3874e-04 )"
        "( 1035 3.5348e-04 )"
        "( 1040 3.7000e-04 )"
        "( 1045 3.8853e-04 )"
        "( 1050 4.0937e-04 )"
        "( 1055 4.3281e-04 )"
        "( 1060 4.5921e-04 )"
        "( 1065 4.8893e-04 )"
        "( 1070 5.2240e-04 )"
        "( 1075 5.6004e-04 )"
        "( 1080 6.0234e-04 )"
        "( 1085 6.4981e-04 )"
        "( 1090 7.0297e-04 )"
        "( 1095 7.6240e-04 )"
        "( 1100 8.2866e-04 )"
        "( 1105 9.0235e-04 )"
        "( 1110 9.8403e-04 )"
        "( 1115 1.0743e-03 )"
        "( 1120 1.1735e-03 )"
        "( 1125 1.2823e-03 )"
        "( 1130 1.4008e-03 )"
        "( 1135 1.5292e-03 )"
        "( 1140 1.6676e-03 )"
        "( 1145 1.8155e-03 )"
        "( 1150 1.9724e-03 )"
        "( 1155 2.1376e-03 )"
        "( 1160 2.3098e-03 )"
        "( 1165 2.4876e-03 )"
        "( 1170 2.6692e-03 )"
        "( 1175 2.8526e-03 )"
        "( 1180 3.0359e-03 )"
        "( 1185 3.2166e-03 )"
        "( 1190 3.3928e-03 )"
        "( 1195 3.5623e-03 )"
        "( 1200 3.7236e-03 )"
        "( 1205 3.8750e-03 )"
        "( 1210 4.0158e-03 )"
        "( 1215 4.1454e-03 )"
        "( 1220 4.2637e-03 )"
        "( 1225 4.3710e-03 )"
        "( 1230 4.4677e-03 )"
        "( 1235 4.5548e-03 )"
        "( 1240 4.6328e-03 )"
        "( 1245 4.7028e-03 )"
        "( 1250 4.7655e-03 )"
        "( 1255 4.8215e-03 )"
        "( 1260 4.8715e-03 )"
        "( 1265 4.9160e-03 )"
        "( 1270 4.9555e-03 )"
        "( 1275 4.9903e-03 )"
        "( 1280 5.0209e-03 )"
        "( 1285 5.0477e-03 )"
        "( 1290 5.0709e-03 )"
        "( 1295 5.0910e-03 )"
        "( 1300 5.1081e-03 )"
        "( 1305 5.1227e-03 )"
        "( 1310 5.1350e-03 )"
        "( 1315 5.1453e-03 )"
        "( 1320 5.1539e-03 )"
        "( 1325 5.1609e-03 )"
        "( 1330 5.1665e-03 )"
        "( 1335 5.1709e-03 )"
        "( 1340 5.1743e-03 )"
        "( 1345 5.1768e-03 )"
        "( 1350 5.1785e-03 )"
        "( 1355 5.1795e-03 )"
        "( 1360 5.1799e-03 )"
        "( 1365 5.1798e-03 )"
        "( 1370 5.1792e-03 )"
        "( 1375 5.1783e-03 )"
        "( 1380 5.1770e-03 )"
        "( 1385 5.1754e-03 )"
        "( 1390 5.1736e-03 )"
        "( 1395 5.1716e-03 )"
        "( 1400 5.1694e-03 )"
        "( 1405 5.1670e-03 )"
        "( 1410 5.1646e-03 )"
        "( 1415 5.1620e-03 )"
        "( 1420 5.1594e-03 )"
        "( 1425 5.1567e-03 )"
        "( 1430 5.1539e-03 )"
        "( 1435 5.1511e-03 )"
        "( 1440 5.1483e-03 )"
        "( 1445 5.1455e-03 )"
        "( 1450 5.1427e-03 )"
        "( 1455 5.1399e-03 )"
        "( 1460 5.1372e-03 )"
        "( 1465 5.1344e-03 )"
        "( 1470 5.1317e-03 )"
        "( 1475 5.1290e-03 )"
        "( 1480 5.1263e-03 )"
        "( 1485 5.1237e-03 )"
        "( 1490 5.1211e-03 )"
        "( 1495 5.1186e-03 )"
        "( 1500 5.1161e-03 )"
        "( 1505 5.1136e-03 )"
        "( 1510 5.1112e-03 )"
        "( 1515 5.1089e-03 )"
        "( 1520 5.1066e-03 )"
        "( 1525 5.1044e-03 )"
        "( 1530 5.1022e-03 )"
        "( 1535 5.1000e-03 )"
        "( 1540 5.0980e-03 )"
        "( 1545 5.0959e-03 )"
        "( 1550 5.0940e-03 )"
        "( 1555 5.0921e-03 )"
        "( 1560 5.0902e-03 )"
        "( 1565 5.0884e-03 )"
        "( 1570 5.0866e-03 )"
        "( 1575 5.0849e-03 )"
        "( 1580 5.0833e-03 )"
        "( 1585 5.0817e-03 )"
        "( 1590 5.0801e-03 )"
        "( 1595 5.0786e-03 )"
        "( 1600 5.0771e-03 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveH2FvPatchScalarField
    );

}

// ************************************************************************* //
