
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 3.0672e-06 )"
        "(  280 3.7510e-06 )"
        "(  285 4.5596e-06 )"
        "(  290 5.5135e-06 )"
        "(  295 6.6382e-06 )"
        "(  300 7.9660e-06 )"
        "(  305 9.5402e-06 )"
        "(  310 1.1420e-05 )"
        "(  315 1.3687e-05 )"
        "(  320 1.6458e-05 )"
        "(  325 1.9898e-05 )"
        "(  330 2.4244e-05 )"
        "(  335 2.9831e-05 )"
        "(  340 3.7138e-05 )"
        "(  345 4.6832e-05 )"
        "(  350 5.9846e-05 )"
        "(  355 7.7461e-05 )"
        "(  360 1.0142e-04 )"
        "(  365 1.3404e-04 )"
        "(  370 1.7839e-04 )"
        "(  375 2.3842e-04 )"
        "(  380 3.1913e-04 )"
        "(  385 4.2670e-04 )"
        "(  390 5.6851e-04 )"
        "(  395 7.5318e-04 )"
        "(  400 9.9031e-04 )"
        "(  405 1.2902e-03 )"
        "(  410 1.6633e-03 )"
        "(  415 2.1196e-03 )"
        "(  420 2.6677e-03 )"
        "(  425 3.3142e-03 )"
        "(  430 4.0632e-03 )"
        "(  435 4.9155e-03 )"
        "(  440 5.8688e-03 )"
        "(  445 6.9177e-03 )"
        "(  450 8.0539e-03 )"
        "(  455 9.2665e-03 )"
        "(  460 1.0543e-02 )"
        "(  465 1.1869e-02 )"
        "(  470 1.3231e-02 )"
        "(  475 1.4612e-02 )"
        "(  480 1.5998e-02 )"
        "(  485 1.7374e-02 )"
        "(  490 1.8727e-02 )"
        "(  495 2.0043e-02 )"
        "(  500 2.1312e-02 )"
        "(  505 2.2524e-02 )"
        "(  510 2.3672e-02 )"
        "(  515 2.4750e-02 )"
        "(  520 2.5755e-02 )"
        "(  525 2.6686e-02 )"
        "(  530 2.7543e-02 )"
        "(  535 2.8330e-02 )"
        "(  540 2.9052e-02 )"
        "(  545 2.9716e-02 )"
        "(  550 3.0331e-02 )"
        "(  555 3.0909e-02 )"
        "(  560 3.1462e-02 )"
        "(  565 3.2005e-02 )"
        "(  570 3.2556e-02 )"
        "(  575 3.3131e-02 )"
        "(  580 3.3752e-02 )"
        "(  585 3.4437e-02 )"
        "(  590 3.5206e-02 )"
        "(  595 3.6078e-02 )"
        "(  600 3.7072e-02 )"
        "(  605 3.8200e-02 )"
        "(  610 3.9472e-02 )"
        "(  615 4.0895e-02 )"
        "(  620 4.2466e-02 )"
        "(  625 4.4181e-02 )"
        "(  630 4.6027e-02 )"
        "(  635 4.7989e-02 )"
        "(  640 5.0048e-02 )"
        "(  645 5.2184e-02 )"
        "(  650 5.4377e-02 )"
        "(  655 5.6609e-02 )"
        "(  660 5.8859e-02 )"
        "(  665 6.1111e-02 )"
        "(  670 6.3348e-02 )"
        "(  675 6.5552e-02 )"
        "(  680 6.7706e-02 )"
        "(  685 6.9794e-02 )"
        "(  690 7.1801e-02 )"
        "(  695 7.3713e-02 )"
        "(  700 7.5520e-02 )"
        "(  705 7.7216e-02 )"
        "(  710 7.8795e-02 )"
        "(  715 8.0257e-02 )"
        "(  720 8.1603e-02 )"
        "(  725 8.2835e-02 )"
        "(  730 8.3960e-02 )"
        "(  735 8.4980e-02 )"
        "(  740 8.5901e-02 )"
        "(  745 8.6726e-02 )"
        "(  750 8.7460e-02 )"
        "(  755 8.8108e-02 )"
        "(  760 8.8676e-02 )"
        "(  765 8.9175e-02 )"
        "(  770 8.9617e-02 )"
        "(  775 9.0019e-02 )"
        "(  780 9.0400e-02 )"
        "(  785 9.0778e-02 )"
        "(  790 9.1170e-02 )"
        "(  795 9.1590e-02 )"
        "(  800 9.2046e-02 )"
        "(  805 9.2541e-02 )"
        "(  810 9.3075e-02 )"
        "(  815 9.3645e-02 )"
        "(  820 9.4245e-02 )"
        "(  825 9.4870e-02 )"
        "(  830 9.5513e-02 )"
        "(  835 9.6166e-02 )"
        "(  840 9.6823e-02 )"
        "(  845 9.7480e-02 )"
        "(  850 9.8130e-02 )"
        "(  855 9.8771e-02 )"
        "(  860 9.9400e-02 )"
        "(  865 1.0001e-01 )"
        "(  870 1.0061e-01 )"
        "(  875 1.0119e-01 )"
        "(  880 1.0176e-01 )"
        "(  885 1.0230e-01 )"
        "(  890 1.0282e-01 )"
        "(  895 1.0333e-01 )"
        "(  900 1.0381e-01 )"
        "(  905 1.0428e-01 )"
        "(  910 1.0472e-01 )"
        "(  915 1.0515e-01 )"
        "(  920 1.0556e-01 )"
        "(  925 1.0595e-01 )"
        "(  930 1.0632e-01 )"
        "(  935 1.0668e-01 )"
        "(  940 1.0702e-01 )"
        "(  945 1.0734e-01 )"
        "(  950 1.0765e-01 )"
        "(  955 1.0794e-01 )"
        "(  960 1.0821e-01 )"
        "(  965 1.0848e-01 )"
        "(  970 1.0872e-01 )"
        "(  975 1.0895e-01 )"
        "(  980 1.0917e-01 )"
        "(  985 1.0938e-01 )"
        "(  990 1.0956e-01 )"
        "(  995 1.0974e-01 )"
        "( 1000 1.0990e-01 )"
        "( 1005 1.1004e-01 )"
        "( 1010 1.1016e-01 )"
        "( 1015 1.1027e-01 )"
        "( 1020 1.1036e-01 )"
        "( 1025 1.1043e-01 )"
        "( 1030 1.1048e-01 )"
        "( 1035 1.1050e-01 )"
        "( 1040 1.1050e-01 )"
        "( 1045 1.1048e-01 )"
        "( 1050 1.1042e-01 )"
        "( 1055 1.1034e-01 )"
        "( 1060 1.1023e-01 )"
        "( 1065 1.1009e-01 )"
        "( 1070 1.0992e-01 )"
        "( 1075 1.0972e-01 )"
        "( 1080 1.0948e-01 )"
        "( 1085 1.0922e-01 )"
        "( 1090 1.0893e-01 )"
        "( 1095 1.0862e-01 )"
        "( 1100 1.0828e-01 )"
        "( 1105 1.0794e-01 )"
        "( 1110 1.0758e-01 )"
        "( 1115 1.0721e-01 )"
        "( 1120 1.0685e-01 )"
        "( 1125 1.0648e-01 )"
        "( 1130 1.0613e-01 )"
        "( 1135 1.0578e-01 )"
        "( 1140 1.0544e-01 )"
        "( 1145 1.0511e-01 )"
        "( 1150 1.0479e-01 )"
        "( 1155 1.0447e-01 )"
        "( 1160 1.0417e-01 )"
        "( 1165 1.0387e-01 )"
        "( 1170 1.0359e-01 )"
        "( 1175 1.0331e-01 )"
        "( 1180 1.0304e-01 )"
        "( 1185 1.0279e-01 )"
        "( 1190 1.0255e-01 )"
        "( 1195 1.0233e-01 )"
        "( 1200 1.0212e-01 )"
        "( 1205 1.0194e-01 )"
        "( 1210 1.0179e-01 )"
        "( 1215 1.0165e-01 )"
        "( 1220 1.0153e-01 )"
        "( 1225 1.0144e-01 )"
        "( 1230 1.0136e-01 )"
        "( 1235 1.0130e-01 )"
        "( 1240 1.0126e-01 )"
        "( 1245 1.0123e-01 )"
        "( 1250 1.0122e-01 )"
        "( 1255 1.0121e-01 )"
        "( 1260 1.0122e-01 )"
        "( 1265 1.0123e-01 )"
        "( 1270 1.0125e-01 )"
        "( 1275 1.0127e-01 )"
        "( 1280 1.0130e-01 )"
        "( 1285 1.0133e-01 )"
        "( 1290 1.0137e-01 )"
        "( 1295 1.0141e-01 )"
        "( 1300 1.0146e-01 )"
        "( 1305 1.0150e-01 )"
        "( 1310 1.0155e-01 )"
        "( 1315 1.0160e-01 )"
        "( 1320 1.0165e-01 )"
        "( 1325 1.0170e-01 )"
        "( 1330 1.0175e-01 )"
        "( 1335 1.0181e-01 )"
        "( 1340 1.0186e-01 )"
        "( 1345 1.0192e-01 )"
        "( 1350 1.0197e-01 )"
        "( 1355 1.0203e-01 )"
        "( 1360 1.0208e-01 )"
        "( 1365 1.0214e-01 )"
        "( 1370 1.0219e-01 )"
        "( 1375 1.0225e-01 )"
        "( 1380 1.0230e-01 )"
        "( 1385 1.0235e-01 )"
        "( 1390 1.0241e-01 )"
        "( 1395 1.0246e-01 )"
        "( 1400 1.0252e-01 )"
        "( 1405 1.0257e-01 )"
        "( 1410 1.0262e-01 )"
        "( 1415 1.0267e-01 )"
        "( 1420 1.0273e-01 )"
        "( 1425 1.0278e-01 )"
        "( 1430 1.0283e-01 )"
        "( 1435 1.0288e-01 )"
        "( 1440 1.0293e-01 )"
        "( 1445 1.0298e-01 )"
        "( 1450 1.0303e-01 )"
        "( 1455 1.0308e-01 )"
        "( 1460 1.0313e-01 )"
        "( 1465 1.0317e-01 )"
        "( 1470 1.0322e-01 )"
        "( 1475 1.0327e-01 )"
        "( 1480 1.0331e-01 )"
        "( 1485 1.0336e-01 )"
        "( 1490 1.0341e-01 )"
        "( 1495 1.0345e-01 )"
        "( 1500 1.0350e-01 )"
        "( 1505 1.0354e-01 )"
        "( 1510 1.0358e-01 )"
        "( 1515 1.0363e-01 )"
        "( 1520 1.0367e-01 )"
        "( 1525 1.0371e-01 )"
        "( 1530 1.0375e-01 )"
        "( 1535 1.0380e-01 )"
        "( 1540 1.0384e-01 )"
        "( 1545 1.0388e-01 )"
        "( 1550 1.0392e-01 )"
        "( 1555 1.0396e-01 )"
        "( 1560 1.0400e-01 )"
        "( 1565 1.0404e-01 )"
        "( 1570 1.0408e-01 )"
        "( 1575 1.0411e-01 )"
        "( 1580 1.0415e-01 )"
        "( 1585 1.0419e-01 )"
        "( 1590 1.0423e-01 )"
        "( 1595 1.0426e-01 )"
        "( 1600 1.0430e-01 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveH2OFvPatchScalarField
    );

}

// ************************************************************************* //
