
/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     | Website:  https://openfoam.org
    \\  /    A nd           | Copyright (C) 2011-2019 OpenFOAM Foundation
     \\/     M anipulation  |
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField.H"
#include "addToRunTimeSelectionTable.H"
#include "fvPatchFieldMapper.H"
#include "volFields.H"
#include "surfaceFields.H"
#include "IOobjectList.H"
#include "turbulentFluidThermoModel.H"

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

const Foam::List<Foam::Tuple2<Foam::scalar, Foam::scalar>>
Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::interpTable
(
    IStringStream
    (
        "("
        "(  275 6.5714e-12 )"
        "(  280 1.6703e-11 )"
        "(  285 4.1100e-11 )"
        "(  290 9.8059e-11 )"
        "(  295 2.2721e-10 )"
        "(  300 5.1199e-10 )"
        "(  305 1.1235e-09 )"
        "(  310 2.4039e-09 )"
        "(  315 5.0204e-09 )"
        "(  320 1.0245e-08 )"
        "(  325 2.0450e-08 )"
        "(  330 3.9957e-08 )"
        "(  335 7.6487e-08 )"
        "(  340 1.4354e-07 )"
        "(  345 2.6423e-07 )"
        "(  350 4.7740e-07 )"
        "(  355 8.4685e-07 )"
        "(  360 1.4754e-06 )"
        "(  365 2.5251e-06 )"
        "(  370 4.2455e-06 )"
        "(  375 7.0124e-06 )"
        "(  380 1.1377e-05 )"
        "(  385 1.8128e-05 )"
        "(  390 2.8355e-05 )"
        "(  395 4.3528e-05 )"
        "(  400 6.5548e-05 )"
        "(  405 9.6790e-05 )"
        "(  410 1.4010e-04 )"
        "(  415 1.9872e-04 )"
        "(  420 2.7618e-04 )"
        "(  425 3.7609e-04 )"
        "(  430 5.0189e-04 )"
        "(  435 6.5662e-04 )"
        "(  440 8.4259e-04 )"
        "(  445 1.0612e-03 )"
        "(  450 1.3129e-03 )"
        "(  455 1.5967e-03 )"
        "(  460 1.9108e-03 )"
        "(  465 2.2520e-03 )"
        "(  470 2.6162e-03 )"
        "(  475 2.9987e-03 )"
        "(  480 3.3938e-03 )"
        "(  485 3.7958e-03 )"
        "(  490 4.1986e-03 )"
        "(  495 4.5964e-03 )"
        "(  500 4.9836e-03 )"
        "(  505 5.3550e-03 )"
        "(  510 5.7063e-03 )"
        "(  515 6.0338e-03 )"
        "(  520 6.3346e-03 )"
        "(  525 6.6068e-03 )"
        "(  530 6.8491e-03 )"
        "(  535 7.0612e-03 )"
        "(  540 7.2435e-03 )"
        "(  545 7.3970e-03 )"
        "(  550 7.5234e-03 )"
        "(  555 7.6248e-03 )"
        "(  560 7.7040e-03 )"
        "(  565 7.7641e-03 )"
        "(  570 7.8087e-03 )"
        "(  575 7.8416e-03 )"
        "(  580 7.8671e-03 )"
        "(  585 7.8894e-03 )"
        "(  590 7.9130e-03 )"
        "(  595 7.9422e-03 )"
        "(  600 7.9810e-03 )"
        "(  605 8.0329e-03 )"
        "(  610 8.1004e-03 )"
        "(  615 8.1851e-03 )"
        "(  620 8.2876e-03 )"
        "(  625 8.4068e-03 )"
        "(  630 8.5408e-03 )"
        "(  635 8.6865e-03 )"
        "(  640 8.8404e-03 )"
        "(  645 8.9986e-03 )"
        "(  650 9.1579e-03 )"
        "(  655 9.3155e-03 )"
        "(  660 9.4699e-03 )"
        "(  665 9.6204e-03 )"
        "(  670 9.7674e-03 )"
        "(  675 9.9114e-03 )"
        "(  680 1.0053e-02 )"
        "(  685 1.0193e-02 )"
        "(  690 1.0331e-02 )"
        "(  695 1.0466e-02 )"
        "(  700 1.0597e-02 )"
        "(  705 1.0724e-02 )"
        "(  710 1.0844e-02 )"
        "(  715 1.0956e-02 )"
        "(  720 1.1060e-02 )"
        "(  725 1.1153e-02 )"
        "(  730 1.1237e-02 )"
        "(  735 1.1310e-02 )"
        "(  740 1.1371e-02 )"
        "(  745 1.1421e-02 )"
        "(  750 1.1459e-02 )"
        "(  755 1.1485e-02 )"
        "(  760 1.1501e-02 )"
        "(  765 1.1507e-02 )"
        "(  770 1.1504e-02 )"
        "(  775 1.1495e-02 )"
        "(  780 1.1482e-02 )"
        "(  785 1.1468e-02 )"
        "(  790 1.1453e-02 )"
        "(  795 1.1441e-02 )"
        "(  800 1.1431e-02 )"
        "(  805 1.1424e-02 )"
        "(  810 1.1420e-02 )"
        "(  815 1.1419e-02 )"
        "(  820 1.1419e-02 )"
        "(  825 1.1420e-02 )"
        "(  830 1.1421e-02 )"
        "(  835 1.1422e-02 )"
        "(  840 1.1421e-02 )"
        "(  845 1.1417e-02 )"
        "(  850 1.1411e-02 )"
        "(  855 1.1402e-02 )"
        "(  860 1.1390e-02 )"
        "(  865 1.1374e-02 )"
        "(  870 1.1355e-02 )"
        "(  875 1.1332e-02 )"
        "(  880 1.1305e-02 )"
        "(  885 1.1275e-02 )"
        "(  890 1.1242e-02 )"
        "(  895 1.1206e-02 )"
        "(  900 1.1166e-02 )"
        "(  905 1.1124e-02 )"
        "(  910 1.1079e-02 )"
        "(  915 1.1032e-02 )"
        "(  920 1.0982e-02 )"
        "(  925 1.0930e-02 )"
        "(  930 1.0877e-02 )"
        "(  935 1.0822e-02 )"
        "(  940 1.0766e-02 )"
        "(  945 1.0708e-02 )"
        "(  950 1.0649e-02 )"
        "(  955 1.0589e-02 )"
        "(  960 1.0528e-02 )"
        "(  965 1.0466e-02 )"
        "(  970 1.0403e-02 )"
        "(  975 1.0340e-02 )"
        "(  980 1.0276e-02 )"
        "(  985 1.0211e-02 )"
        "(  990 1.0146e-02 )"
        "(  995 1.0080e-02 )"
        "( 1000 1.0014e-02 )"
        "( 1005 9.9466e-03 )"
        "( 1010 9.8789e-03 )"
        "( 1015 9.8105e-03 )"
        "( 1020 9.7413e-03 )"
        "( 1025 9.6713e-03 )"
        "( 1030 9.6004e-03 )"
        "( 1035 9.5285e-03 )"
        "( 1040 9.4556e-03 )"
        "( 1045 9.3815e-03 )"
        "( 1050 9.3062e-03 )"
        "( 1055 9.2296e-03 )"
        "( 1060 9.1516e-03 )"
        "( 1065 9.0723e-03 )"
        "( 1070 8.9915e-03 )"
        "( 1075 8.9094e-03 )"
        "( 1080 8.8261e-03 )"
        "( 1085 8.7416e-03 )"
        "( 1090 8.6563e-03 )"
        "( 1095 8.5704e-03 )"
        "( 1100 8.4843e-03 )"
        "( 1105 8.3982e-03 )"
        "( 1110 8.3126e-03 )"
        "( 1115 8.2278e-03 )"
        "( 1120 8.1442e-03 )"
        "( 1125 8.0620e-03 )"
        "( 1130 7.9815e-03 )"
        "( 1135 7.9029e-03 )"
        "( 1140 7.8261e-03 )"
        "( 1145 7.7511e-03 )"
        "( 1150 7.6779e-03 )"
        "( 1155 7.6064e-03 )"
        "( 1160 7.5366e-03 )"
        "( 1165 7.4684e-03 )"
        "( 1170 7.4017e-03 )"
        "( 1175 7.3368e-03 )"
        "( 1180 7.2736e-03 )"
        "( 1185 7.2122e-03 )"
        "( 1190 7.1529e-03 )"
        "( 1195 7.0956e-03 )"
        "( 1200 7.0405e-03 )"
        "( 1205 6.9877e-03 )"
        "( 1210 6.9372e-03 )"
        "( 1215 6.8889e-03 )"
        "( 1220 6.8428e-03 )"
        "( 1225 6.7988e-03 )"
        "( 1230 6.7567e-03 )"
        "( 1235 6.7164e-03 )"
        "( 1240 6.6778e-03 )"
        "( 1245 6.6407e-03 )"
        "( 1250 6.6050e-03 )"
        "( 1255 6.5706e-03 )"
        "( 1260 6.5372e-03 )"
        "( 1265 6.5049e-03 )"
        "( 1270 6.4736e-03 )"
        "( 1275 6.4432e-03 )"
        "( 1280 6.4136e-03 )"
        "( 1285 6.3847e-03 )"
        "( 1290 6.3565e-03 )"
        "( 1295 6.3290e-03 )"
        "( 1300 6.3021e-03 )"
        "( 1305 6.2758e-03 )"
        "( 1310 6.2500e-03 )"
        "( 1315 6.2248e-03 )"
        "( 1320 6.2001e-03 )"
        "( 1325 6.1758e-03 )"
        "( 1330 6.1520e-03 )"
        "( 1335 6.1286e-03 )"
        "( 1340 6.1057e-03 )"
        "( 1345 6.0831e-03 )"
        "( 1350 6.0609e-03 )"
        "( 1355 6.0391e-03 )"
        "( 1360 6.0177e-03 )"
        "( 1365 5.9966e-03 )"
        "( 1370 5.9758e-03 )"
        "( 1375 5.9554e-03 )"
        "( 1380 5.9353e-03 )"
        "( 1385 5.9155e-03 )"
        "( 1390 5.8960e-03 )"
        "( 1395 5.8768e-03 )"
        "( 1400 5.8579e-03 )"
        "( 1405 5.8393e-03 )"
        "( 1410 5.8209e-03 )"
        "( 1415 5.8028e-03 )"
        "( 1420 5.7850e-03 )"
        "( 1425 5.7675e-03 )"
        "( 1430 5.7501e-03 )"
        "( 1435 5.7331e-03 )"
        "( 1440 5.7163e-03 )"
        "( 1445 5.6997e-03 )"
        "( 1450 5.6834e-03 )"
        "( 1455 5.6672e-03 )"
        "( 1460 5.6514e-03 )"
        "( 1465 5.6357e-03 )"
        "( 1470 5.6202e-03 )"
        "( 1475 5.6050e-03 )"
        "( 1480 5.5900e-03 )"
        "( 1485 5.5751e-03 )"
        "( 1490 5.5605e-03 )"
        "( 1495 5.5461e-03 )"
        "( 1500 5.5318e-03 )"
        "( 1505 5.5178e-03 )"
        "( 1510 5.5039e-03 )"
        "( 1515 5.4903e-03 )"
        "( 1520 5.4768e-03 )"
        "( 1525 5.4634e-03 )"
        "( 1530 5.4503e-03 )"
        "( 1535 5.4373e-03 )"
        "( 1540 5.4245e-03 )"
        "( 1545 5.4119e-03 )"
        "( 1550 5.3994e-03 )"
        "( 1555 5.3871e-03 )"
        "( 1560 5.3749e-03 )"
        "( 1565 5.3629e-03 )"
        "( 1570 5.3511e-03 )"
        "( 1575 5.3394e-03 )"
        "( 1580 5.3278e-03 )"
        "( 1585 5.3164e-03 )"
        "( 1590 5.3052e-03 )"
        "( 1595 5.2940e-03 )"
        "( 1600 5.2830e-03 )"
        ")"



    )()
);

// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_("phi"),
    rhoName_("none"),
    massFluxFraction_(1.0),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{
    refValue() = 0.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;
}


Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField
(
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const dictionary& dict
)
:
    mixedFvPatchField<scalar>(p, iF),
    phiName_(dict.lookupOrDefault<word>("phi", "phi")),
    rhoName_(dict.lookupOrDefault<word>("rho", "none")),
    massFluxFraction_(dict.lookupOrDefault<scalar>("massFluxFraction", 1.0)),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{

    refValue() = 1.0;
    refGrad() = 0.0;
    valueFraction() = 0.0;

    if (dict.found("value"))
    {
        fvPatchField<scalar>::operator=
        (
            Field<scalar>("value", dict, p.size())
        );
    }
    else
    {
        fvPatchField<scalar>::operator=(refValue());
    }
}

Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField& ptf,
    const fvPatch& p,
    const DimensionedField<scalar, volMesh>& iF,
    const fvPatchFieldMapper& mapper
)
:
    mixedFvPatchField<scalar>(ptf, p, iF, mapper),
    phiName_(ptf.phiName_),
    rhoName_(ptf.rhoName_),
    massFluxFraction_(ptf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField& tppsf
)
:
    mixedFvPatchField<scalar>(tppsf),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}

Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::
myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField
(
    const myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField& tppsf,
    const DimensionedField<scalar, volMesh>& iF
)
:
    mixedFvPatchField<scalar>(tppsf, iF),
    phiName_(tppsf.phiName_),
    rhoName_(tppsf.rhoName_),
    massFluxFraction_(tppsf.massFluxFraction_),
    table_
    (
        interpTable,
        interpolationTable<scalar>::CLAMP,
        "interpTable"
    )
{}


// * * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * //

void Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::autoMap
(
    const fvPatchFieldMapper& m
)
{
    m(*this, *this);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::rmap
(
    const fvPatchScalarField& ptf,
    const labelList& addr
)
{
    mixedFvPatchField<scalar>::rmap(ptf, addr);
}


void Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::updateCoeffs()
{
    if (this->updated())
    {
        return;
    }

    const label patchi = patch().index();

    const compressible::turbulenceModel& turbModel =
        db().lookupObject<compressible::turbulenceModel>
        (
            IOobject::groupName
            (
                turbulenceModel::propertiesName,
                internalField().group()
            )
        );

    const fvsPatchField<scalar>& phip =
        patch().lookupPatchField<surfaceScalarField, scalar>(phiName_);

    const scalarField alphap(turbModel.alphaEff(patchi));

    const scalarField Tp = patch().lookupPatchField<volScalarField, scalar>("T");

    //averages temperature across the top surface
    scalar mTp = gAverage(Tp);

    refValue() = table_(mTp);
    refGrad() = 0.0;

    valueFraction() =
        1.0
        /
        (
            1.0 +
            alphap*patch().deltaCoeffs()*patch().magSf()/max(mag(phip), small)
        );

    mixedFvPatchField<scalar>::updateCoeffs();

    if (debug)
    {
        scalar phi = gSum(-phip*(*this));

        Info<< patch().boundaryMesh().mesh().name() << ':'
            << patch().name() << ':'
            << this->internalField().name() << " :"
            << " mass flux[Kg/s]:" << phi
            << endl;
    }
}


void Foam::myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField::
write(Ostream& os) const
{
    fvPatchField<scalar>::write(os);
    writeEntry(os, "phi", phiName_);
    writeEntry(os, "rho", rhoName_);
    writeEntry(os, "massFluxFraction", massFluxFraction_);
    writeEntry(os, "value", *this);
}


// * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * //

namespace Foam
{
    makePatchTypeField
    (
        fvPatchScalarField,
        myTotalFlowRateAdvectiveDiffusiveHCOOHFvPatchScalarField
    );

}

// ************************************************************************* //
